<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Parent class for "ScriptClasses" in backend modules.
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */


class t3lib_SCbase {
	var $MCONF=array();
	var $MOD_MENU= Array (
			"function" => array()
		);
	var $MOD_SETTINGS=array();

	var $doc;	
	var $include_once=array();

	var $extClassConf;
	var $extObj;

	var $content;

	var $perms_clause;
	var $modTSconfig;
	var $CMD;
	var $id;
	
	var $modMenu_type = "";
	var $modMenu_dontValidateList = "";
	var $modMenu_setDefaultList = "";
	
	function init()	{
		global $AB,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$HTTP_GET_VARS,$HTTP_POST_VARS,$CLIENT,$TYPO3_CONF_VARS;
		$this->MCONF = $GLOBALS["MCONF"];
		$this->id = intval(t3lib_div::GPvar("id"));
		$this->CMD = t3lib_div::GPvar("CMD");
		$this->perms_clause = $BE_USER->getPagePermsClause(1);
		$this->menuConfig();
		$this->handleExternalFunctionValue();
	}
	function menuConfig()	{
		global $AB,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$HTTP_GET_VARS,$HTTP_POST_VARS,$CLIENT,$TYPO3_CONF_VARS;;

			// page/be_user TSconfig settings and blinding of menu-items
		$this->modTSconfig = t3lib_BEfunc::getModTSconfig($this->id,"mod.".$this->MCONF["name"]);
		$this->MOD_MENU["function"] = $this->mergeExternalItems($this->MCONF["name"],"function",$this->MOD_MENU["function"]);
		$this->MOD_MENU["function"] = t3lib_BEfunc::unsetMenuItems($this->modTSconfig["properties"],$this->MOD_MENU["function"],"menu.function");

			// CLEANSE "function" SETTINGS
		$this->MOD_SETTINGS = t3lib_BEfunc::getModuleData($this->MOD_MENU, t3lib_div::GPvar("SET"), $this->MCONF["name"], $this->modMenu_type, $this->modMenu_dontValidateList, $this->modMenu_setDefaultList);
	}
	function checkExtObj()	{
		if (is_array($this->extClassConf) && $this->extClassConf["name"])	{
			$this->extObj = t3lib_div::makeInstance($this->extClassConf["name"]);
			$this->extObj->init($this,$this->extClassConf);
				// Re-write:
			$this->MOD_SETTINGS = t3lib_BEfunc::getModuleData($this->MOD_MENU, t3lib_div::GPvar("SET"), $this->MCONF["name"]);
		}
	}
	function checkSubExtObj()	{
		if (is_object($this->extObj))	$this->extObj->checkExtObj();
	}
	function extObjContent()	{
		if (is_object($this->extObj))	$this->content.=$this->extObj->main();
	}
	function handleExternalFunctionValue($MM_key="function")	{
		$this->extClassConf = $this->getExternalItemConfig($this->MCONF["name"],$MM_key,$this->MOD_SETTINGS[$MM_key]);
		if (is_array($this->extClassConf) && $this->extClassConf["path"])	{
			$this->include_once[]=$this->extClassConf["path"];
		}
	}
	function getExternalItemConfig($modName,$menuKey,$value="")	{
		return strcmp($value,"")?$GLOBALS["TBE_MODULES_EXT"][$modName]["MOD_MENU"][$menuKey][$value]:$GLOBALS["TBE_MODULES_EXT"][$modName]["MOD_MENU"][$menuKey];
	}
	function mergeExternalItems($modName,$menuKey,$menuArr)	{
		$mergeArray = $GLOBALS["TBE_MODULES_EXT"][$modName]["MOD_MENU"][$menuKey];
		if (is_array($mergeArray))	{
			reset($mergeArray);
			while(list($k,$v)=each($mergeArray))	{
				$menuArr[$k]=$GLOBALS["LANG"]->sL($v["title"]);
			}
		}
		return $menuArr;
	}
}

/*
 // Does not make sense, because this class is always extended by the script classes..
if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["t3lib/class.t3lib_scbase.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["t3lib/class.t3lib_scbase.php"]);
}
*/

?>