<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * FE admin lib
 *
 * This library provides a HTML-template file based framework for Front End creating/editing/deleting records authenticated by email or fe_user login.
 * See TSref document for details
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */


require_once (PATH_t3lib."class.t3lib_basicfilefunc.php");		// For use with images.

class user_feAdmin	{
	var $dataArr = array();
	var $failureMsg = array();
	var $theTable = "";
	var $thePid = 0;
	var $markerArray = array();
	var $templateCode="";
	var $cObj;

	var $cmd;
	var $preview;
	var $backURL;
	var $recUid;
	var $failure=0;		// is set if data did not have the required fields set.
	var $error="";
	var $saved=0;		// is set if data is saved
	var $requiredArr;
	var $currentArr = array();
	var $previewLabel="";
	var $nc = "";		// "&no_cache=1" if you want that parameter sent.
	var $additionalUpdateFields="";
	var $emailMarkPrefix = "EMAIL_TEMPLATE_";
	var $codeLength;
	var $cmdKey;
	var $fileFunc="";	// Set to a basic_filefunc object 
	var $filesStoredInUploadFolders=array();		// This array will hold the names of files transferred to the uploads/* folder if any. If the records are NOT saved, these files should be deleted!! Currently this is not working!

	
	function init($content,$conf)	{
		$this->conf = $conf;

			// template file is fetched.
		$this->templateCode = $this->conf["templateContent"] ? $this->conf["templateContent"] : $this->cObj->fileResource($this->conf["templateFile"]);

			// Getting the cmd var
		$this->cmd = (string)t3lib_div::GPvar("cmd");
			// Getting the preview var
		$this->preview = (string)t3lib_div::GPvar("preview");
			// backURL is a given URL to return to when login is performed
		$this->backURL = t3lib_div::GPvar("backURL");
			// Uid to edit:
		$this->recUid = t3lib_div::GPvar("rU");
			// Authentication code:
		$this->authCode = t3lib_div::GPvar("aC");
			// get table
		$this->theTable = $this->conf["table"];
		
		$this->nc = $this->conf["no_cache"] ? "&no_cache=1" : $this->nc;
			// pid
		$this->thePid = intval($this->conf["pid"]) ? intval($this->conf["pid"]) : $GLOBALS["TSFE"]->id;
			// 
		$this->codeLength = intval($this->conf["authcodeFields."]["codeLength"]) ? intval($this->conf["authcodeFields."]["codeLength"]) : 8;
		
			// Setting the hardcoded lists of fields allowed for editing and creation.
		$this->fieldList=implode(",",t3lib_div::trimExplode(",",$GLOBALS["TCA"][$this->theTable]["feInterface"]["fe_admin_fieldList"],1));
		
			// globally substituted markers, fonts and colors.	
		$splitMark = md5(microtime());
		list($this->markerArray["###GW1B###"],$this->markerArray["###GW1E###"]) = explode($splitMark,$this->cObj->stdWrap($splitMark,$this->conf["wrap1."]));
		list($this->markerArray["###GW2B###"],$this->markerArray["###GW2E###"]) = explode($splitMark,$this->cObj->stdWrap($splitMark,$this->conf["wrap2."]));
		$this->markerArray["###GC1###"] = $this->cObj->stdWrap($this->conf["color1"],$this->conf["color1."]);
		$this->markerArray["###GC2###"] = $this->cObj->stdWrap($this->conf["color2"],$this->conf["color2."]);
		$this->markerArray["###GC3###"] = $this->cObj->stdWrap($this->conf["color3"],$this->conf["color3."]);

			// Initialize markerArray, setting FORM_URL and HIDDENFIELDS
		$this->markerArray["###FORM_URL###"] = "index.php?id=".$GLOBALS["TSFE"]->id."&type=".$GLOBALS["TSFE"]->type.$this->nc.$this->conf["addParams"];
		$this->markerArray["###BACK_URL###"]=$this->backURL;
		$this->markerArray["###THE_PID###"]=$this->thePid;
		$this->markerArray["###BACK_URL_ENC###"]=rawurlencode($this->markerArray["###BACK_URL###"]);
		$this->markerArray["###FORM_URL_ENC###"]=rawurlencode($this->markerArray["###FORM_URL###"]);
		$this->markerArray["###REC_UID###"]=$this->recUid;
		$this->markerArray["###AUTH_CODE###"]=$this->authCode;
		$this->markerArray["###THIS_ID###"]=$GLOBALS["TSFE"]->id;
		$this->markerArray["###THIS_URL###"]=t3lib_div::getIndpEnv("TYPO3_REQUEST_DIR");
		$this->markerArray["###HIDDENFIELDS###"] = 
			($this->cmd?'<input type="hidden" name="cmd" value="'.$this->cmd.'">':'').
			($this->authCode?'<input type="hidden" name="aC" value="'.$this->authCode.'">':'').
			($this->backURL?'<input type="hidden" name="backURL" value="'.htmlspecialchars($this->backURL).'">':'');
		
		
			// Setting cmdKey which is either "edit" or "create"
		switch($this->cmd)	{
			case "edit":
				$this->cmdKey="edit";
			break;
			default:
				$this->cmdKey="create";
			break;
		}
			// Setting requiredArr to the fields in "required" intersected field the total field list in order to remove invalid fields.
		$this->requiredArr = array_intersect(
			t3lib_div::trimExplode(",",$this->conf[$this->cmdKey."."]["required"],1),
			t3lib_div::trimExplode(",",$this->conf[$this->cmdKey."."]["fields"],1)
		);
		
			// Setting incoming data. Non-stripped
		$fe=t3lib_div::GPvar("FE");
		$this->dataArr = $fe[$this->theTable];	// Incoming data.

		/*
		debug($GLOBALS["HTTP_POST_VARS"]);
		debug($GLOBALS["HTTP_GET_VARS"]);
		debug($GLOBALS["HTTP_POST_FILES"]);
*/
			// Checking template file and table value
		if (!$this->templateCode)	{
			$content = "No template file found: ".$this->conf[templateFile];
			return $content;
		}

		if (!$this->theTable || !$this->fieldList)	{
			$content = "Wrong table: ".$this->theTable;
			return $content;		// Not listed or editable table!
		}

		// *****************
		// If data is submitted, we take care of it here.
		// *******************
		if ($this->cmd=="delete" && !$this->preview && !t3lib_div::GPvar("doNotSave"))	{	// Delete record if delete command is sent + the preview flag is NOT set.
			$this->deleteRecord();
		}
			// If incoming data is seen...
		if (is_array($this->dataArr))	{		
				// Evaluation of data:
			$this->parseValues();
			$this->overrideValues();
			$this->evalValues();
			if ($this->conf["evalFunc"])	{
				$this->dataArr = $this->userProcess("evalFunc",$this->dataArr);
			}

		/*
		debug($this->dataArr);
		debug($this->failure);
		debug($this->preview);
		*/
				// if not preview and no failures, then set data...
			if (!$this->failure && !$this->preview && !t3lib_div::GPvar("doNotSave"))	{	// doNotSave is a global var (eg a "Cancel" submit button) that prevents the data from being processed
				$this->save();
			} else {
				if ($this->conf["debug"])		debug($this->failure);
			}
		} else {
			$this->defaultValues();	// If no incoming data, this will set the default values.
			$this->preview = 0;	// No preview if data is not received
		}
		if ($this->failure)	{$this->preview=0;}	// No preview flag if a evaluation failure has occured
		$this->previewLabel = $this->preview ? "_PREVIEW" : "";	// Setting preview label prefix.
			
			
			// *********************
			// DISPLAY FORMS:
			// ***********************
		if ($this->saved) {
				// Clear page cache
			$this->clearCacheIfSet();
		
				// Displaying the page here that says, the record has been saved. You're able to include the saved values by markers.
			switch($this->cmd)	{
				case "delete":
					$key="DELETE";
				break;
				case "edit":
					$key="EDIT";
				break;
				default:
					$key="CREATE";
				break;
			}
				// Output message
			$templateCode = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_".$key."_SAVED###");
			$this->setCObjects($templateCode,$this->currentArr);
			$markerArray = $this->cObj->fillInMarkerArray($this->markerArray, $this->currentArr);
//			debug($markerArray);
			$content = $this->cObj->substituteMarkerArray($templateCode, $markerArray);
		
				// email message:
			$this->compileMail(
				$key."_SAVED", 
				array($this->currentArr),
				$this->currentArr[$this->conf["email."]["field"]],
				$this->conf["setfixed."]
			);
			
		} elseif ($this->error) {	// If there was an error, we return the template-subpart with the error message
			$templateCode = $this->cObj->getSubpart($this->templateCode, $this->error);
			$this->setCObjects($templateCode);
			$content = $this->cObj->substituteMarkerArray($templateCode, $this->markerArray);
		} else {
				// Finally, if there has been no attempt to save. That is either preview or just displaying and empty or not correctly filled form:
			if (!$this->cmd)	{
				$this->cmd=$this->conf["defaultCmd"];
			}
			if ($this->conf["debug"])		debug("Display form: ".$this->cmd,1);
			switch($this->cmd)	{
				case "setfixed":
					$content = $this->procesSetFixed();
				break;
				case "infomail":
					$content = $this->sendInfoMail();
				break;
				case "delete":
					$content = $this->displayDeleteScreen();
				break;
				case "edit":
					$content = $this->displayEditScreen();
				break;
				case "create":
					$content = $this->displayCreateScreen();
				break;
			}
		}	
	
		return $content;		
	}
	function getFailure($theField, $theCmd, $label)	{
		return isset($this->conf["evalErrors."][$theField."."][$theCmd]) ? $this->conf["evalErrors."][$theField."."][$theCmd] : $label;
	}
	function evalValues()	{
		// Check required, set failure if not ok.
		reset($this->requiredArr);
		$tempArr=array();
		while(list(,$theField)=each($this->requiredArr))	{
			if (!trim($this->dataArr[$theField]))	{
				$tempArr[]=$theField;
			}
		}

		// Evaluate: This evaluates for more advanced things than "required" does. But it returns the same error code, so you must let the required-message tell, if further evaluation has failed!
		$recExist=0;
		if (is_array($this->conf[$this->cmdKey."."]["evalValues."]))	{
			switch($this->cmd)	{
				case "edit":
					if (isset($this->dataArr["pid"]))	{			// This may be tricked if the input has the pid-field set but the edit-field list does NOT allow the pid to be edited. Then the pid may be false.
						$recordTestPid = intval($this->dataArr["pid"]);
					} else {
						$tempRecArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,$this->dataArr[uid]);
						$recordTestPid = intval($tempRecArr["pid"]);
					}
					$recExist=1;
				break;
				default:
					$recordTestPid = $this->thePid ? $this->thePid : t3lib_div::intval_positive($this->dataArr["pid"]);
				break;
			}

			reset($this->conf[$this->cmdKey."."]["evalValues."]);
			while(list($theField,$theValue)=each($this->conf[$this->cmdKey."."]["evalValues."]))	{
				$listOfCommands = t3lib_div::trimExplode(",",$theValue,1);
				while(list(,$cmd)=each($listOfCommands))	{
					$cmdParts = split("\[|\]",$cmd);	// Point is to enable parameters after each command enclosed in brackets [..]. These will be in position 1 in the array.
					$theCmd = trim($cmdParts[0]);
					switch($theCmd)	{
						case "uniqueGlobal":
							if ($DBrows = $GLOBALS["TSFE"]->sys_page->getRecordsByField($this->theTable,$theField,$this->dataArr[$theField],"LIMIT 1"))	{
								if (!$recExist || $DBrows[0]["uid"]!=$this->dataArr["uid"])	{	// Only issue an error if the record is not existing (if new...) and if the record with the false value selected was not our self.
									$tempArr[]=$theField;
									$this->failureMsg[$theField][] = $this->getFailure($theField, $theCmd, "The value existed already. Enter a new value.");
								}
							}
						break;
						case "uniqueLocal":
							if ($DBrows = $GLOBALS["TSFE"]->sys_page->getRecordsByField($this->theTable,$theField,$this->dataArr[$theField], "AND pid IN (".$recordTestPid.") LIMIT 1"))	{
								if (!$recExist || $DBrows[0]["uid"]!=$this->dataArr["uid"])	{	// Only issue an error if the record is not existing (if new...) and if the record with the false value selected was not our self.
									$tempArr[]=$theField;
									$this->failureMsg[$theField][] = $this->getFailure($theField, $theCmd, "The value existed already. Enter a new value.");
								}
							}
						break;
						case "twice":
							if (strcmp($this->dataArr[$theField], $this->dataArr[$theField."_again"]))	{
								$tempArr[]=$theField;
								$this->failureMsg[$theField][] = $this->getFailure($theField, $theCmd, "You must enter the same value twice");
							}
						break;
						case "email":
							if (!$this->cObj->checkEmail($this->dataArr[$theField]))	{
								$tempArr[]=$theField;
								$this->failureMsg[$theField][] = $this->getFailure($theField, $theCmd, "You must enter a valid email address");
							}
						break;
						case "required":
							if (!trim($this->dataArr[$theField]))	{
								$tempArr[]=$theField;
								$this->failureMsg[$theField][] = $this->getFailure($theField, $theCmd, "You must enter a value!");
							}
						break;
						case "atLeast":
							$chars=intval($cmdParts[1]);
							if (strlen($this->dataArr[$theField])<$chars)	{
								$tempArr[]=$theField;
								$this->failureMsg[$theField][] = sprintf($this->getFailure($theField, $theCmd, "You must enter at least %s characters!"), $chars);
							}
						break;
						case "atMost":
							$chars=intval($cmdParts[1]);
							if (strlen($this->dataArr[$theField])>$chars)	{
								$tempArr[]=$theField;
								$this->failureMsg[$theField][] = sprintf($this->getFailure($theField, $theCmd, "You must enter at most %s characters!"), $chars);
							}
						break;
						case "inBranch":
							$pars = explode(";",$cmdParts[1]);
							if (intval($pars[0]))	{
								$pid_list = $this->cObj->getTreeList(
									intval($pars[0]),
									intval($pars[1]) ? intval($pars[1]) : 999,
									intval($pars[2])
								);
								if (!$pid_list || !t3lib_div::inList($pid_list,$this->dataArr[$theField]))	{
									$tempArr[]=$theField;
									$this->failureMsg[$theField][] = sprintf($this->getFailure($theField, $theCmd, "The value was not a valid valud from this list: %s"), $pid_list);
								}
							}
						break;
						case "unsetEmpty":
							if (!$this->dataArr[$theField])	{
								$hash = array_flip($tempArr); 
								unset($hash[$theField]);
								$tempArr = array_keys($hash);
								unset($this->failureMsg[$theField]);
								unset($this->dataArr[$theField]);	// This should prevent the field from entering the database.
							}
						break;
					}
				}
				$this->markerArray["###EVAL_ERROR_FIELD_".$theField."###"] = is_array($this->failureMsg[$theField]) ? implode($this->failureMsg[$theField],"<BR>") : "";
			}
		}
		$this->failure=implode($tempArr,",");	 //$failure will show which fields were not OK
	}	
	function userProcess($mConfKey,$passVar)	{
		if ($this->conf[$mConfKey])	{
			$funcConf = $this->conf[$mConfKey."."];
			$funcConf["parentObj"]=&$this;
			$passVar = $GLOBALS["TSFE"]->cObj->callUserFunction($this->conf[$mConfKey], $funcConf, $passVar);
		}
		return $passVar;
	}
	function userProcess_alt($confVal,$confArr,$passVar)	{
		if ($confVal)	{
			$funcConf = $confArr;
			$funcConf["parentObj"]=&$this;
			$passVar = $GLOBALS["TSFE"]->cObj->callUserFunction($confVal, $funcConf, $passVar);
		}
		return $passVar;
	}
	function parseValues()	{
			// process...
				//$dataArr["usergroup"] = implode($dataArr["usergroup"],",");
		// *files! (skip i frste omgang... eller f det ordnet...)

		// link-confirm....
/*						case "datetime":
							// Need to do some work here. 
						break;
						case "binaryCheck":
						break;
						case "multiselect":
						break;
						*/
			//parseValues.[fieldname] = int,lower,upper,datetime[d-m-y], binaryCheck, multiselect

						


		
			// Parse: This transforms fields into certain things...
		if (is_array($this->conf["parseValues."]))	{
			reset($this->conf["parseValues."]);
			while(list($theField,$theValue)=each($this->conf["parseValues."]))	{
				$listOfCommands = t3lib_div::trimExplode(",",$theValue,1);
				while(list(,$cmd)=each($listOfCommands))	{
					$cmdParts = split("\[|\]",$cmd);	// Point is to enable parameters after each command enclosed in brackets [..]. These will be in position 1 in the array.
					$theCmd=trim($cmdParts[0]);
					switch($theCmd)	{
						case "int":
							$this->dataArr[$theField]=intval($this->dataArr[$theField]);
						break;
						case "lower":
						case "upper":
							$this->dataArr[$theField] = $this->cObj->caseshift($this->dataArr[$theField],$theCmd);
						break;
						case "nospace":
							$this->dataArr[$theField] = str_replace(" ", "", $this->dataArr[$theField]);
						break;
						case "alpha":
							$this->dataArr[$theField] = ereg_replace("[^a-zA-Z]","",$this->dataArr[$theField]);
						break;	
						case "num":
							$this->dataArr[$theField] = ereg_replace("[^0-9]","",$this->dataArr[$theField]);
						break;	
						case "alphanum":
							$this->dataArr[$theField] = ereg_replace("[^a-zA-Z0-9]","",$this->dataArr[$theField]);
						break;	
						case "alphanum_x":
							$this->dataArr[$theField] = ereg_replace("[^a-zA-Z0-9_-]","",$this->dataArr[$theField]);
						break;
						case "trim":
							$this->dataArr[$theField] = trim($this->dataArr[$theField]);
						break;
						case "random":
							$this->dataArr[$theField] = substr(md5(uniqid(microtime(),1)),0,intval($cmdParts[1]));
						break;
						case "files":
							if ($this->cmdKey=="create" && !t3lib_div::GPvar("doNotSave"))	{
								$this->processFiles($cmdParts,$theField);
							} else unset($this->dataArr[$theField]);	// Fields with files cannot be edited - only created.
						break;
						case "setEmptyIfAbsent":
							if (!isset($this->dataArr[$theField]))	{
								$this->dataArr[$theField]="";
							}
						break;
						case "multiple":
							if (is_array($this->dataArr[$theField]))	{
								$this->dataArr[$theField] = implode(",",$this->dataArr[$theField]);
							}
						break;
						case "checkArray":
							if (is_array($this->dataArr[$theField]))	{
								reset($this->dataArr[$theField]);
								$val = 0;
								while(list($kk,$vv)=each($this->dataArr[$theField]))	{
									$kk = t3lib_div::intInRange($kk,0);
									if ($kk<=30)	{
										if ($vv)	{
											$val|=pow(2,$kk);
										}
									}
								}
								$this->dataArr[$theField] = $val;
							} else {$this->dataArr[$theField]=0;}
						break;
						case "uniqueHashInt":
							$otherFields = t3lib_div::trimExplode(";",$cmdParts[1],1);
							$hashArray=array();
							while(list(,$fN)=each($otherFields))	{
								$vv = $this->dataArr[$fN];
								$vv = ereg_replace("[[:space:]]","",$vv);
								$vv = ereg_replace("[^[:alnum:]]","",$vv);
								$vv = strtolower($vv);
								$hashArray[]=$vv;
							}
							$this->dataArr[$theField]=hexdec(substr(md5(serialize($hashArray)),0,8));
						break;
					}
				}
			}
		}
	}
	function processFiles($cmdParts,$theField)	{
//debug($GLOBALS["HTTP_POST_FILES"]);
			// First, make an array with the filename and file reference, whether the file is just uploaded or a preview 
		$filesArr=array();
		if (is_string($this->dataArr[$theField]))	{		// files from preview.
			$tmpArr = explode(",",$this->dataArr[$theField]);
			reset($tmpArr);
			while(list(,$val)=each($tmpArr))	{
				$valParts = explode("|",$val);
				$filesArr[] = array (
					"name"=>$valParts[1],
					"tmp_name"=>PATH_site."typo3temp/".$valParts[0]
				);
			}
		} elseif (is_array($GLOBALS["HTTP_POST_FILES"]["FE"][$this->theTable][$theField]["name"]))	{	// Files from upload
			reset($GLOBALS["HTTP_POST_FILES"]["FE"][$this->theTable][$theField]["name"]);
			while(list($kk,$vv)=each($GLOBALS["HTTP_POST_FILES"]["FE"][$this->theTable][$theField]["name"]))	{
				if ($vv)	{
					$tmpFile = $GLOBALS["HTTP_POST_FILES"]["FE"][$this->theTable][$theField]["tmp_name"][$kk];
					$filesArr[] = array (
						"name"=>$vv,
						"tmp_name"=>$tmpFile
					);
				}
			}
		} elseif (is_array($GLOBALS["HTTP_POST_FILES"]["FE"]["name"][$this->theTable][$theField]))	{	// Files from upload
			reset($GLOBALS["HTTP_POST_FILES"]["FE"]["name"][$this->theTable][$theField]);
			while(list($kk,$vv)=each($GLOBALS["HTTP_POST_FILES"]["FE"]["name"][$this->theTable][$theField]))	{
				if ($vv)	{
					$tmpFile = $GLOBALS["HTTP_POST_FILES"]["FE"]["tmp_name"][$this->theTable][$theField][$kk];
					$filesArr[] = array (
						"name"=>$vv,
						"tmp_name"=>$tmpFile
					);
				}
			}
		}
#debug($filesArr);
			// Then verify the files in that array; check existence, extension and size
		$this->dataArr[$theField]="";
		$finalFilesArr=array();
		if (count($filesArr))	{
			$extArray=t3lib_div::trimExplode(";",strtolower($cmdParts[1]),1);
			$maxSize = intval($cmdParts[3]);
			reset($filesArr);
			while(list(,$infoArr)=each($filesArr))	{
				$fI = pathinfo($infoArr["name"]);
				if (t3lib_div::verifyFilenameAgainstDenyPattern($fI["name"]))	{
					if (!count($extArray) || in_array(strtolower($fI["extension"]), $extArray))	{
						$tmpFile = $infoArr["tmp_name"];
						if (@is_file($tmpFile))	{
							if (!$maxSize || filesize($tmpFile)<$maxSize*1024)	{
								$finalFilesArr[]=$infoArr;
							} elseif ($this->conf["debug"])	{debug("Size is beyond ".$maxSize." kb (".filesize($tmpFile)." bytes) and the file cannot be saved.");}
						} elseif ($this->conf["debug"])	{debug("Surprisingly there was no file for ".$vv." in ".$tmpFile);}
					} elseif ($this->conf["debug"])	{debug("Extension '".$fI["extension"]."' not allowed");}
				} elseif ($this->conf["debug"])	{debug("Filename matched illegal pattern.");}
			}
		}
			// Copy the files in the resulting array to the proper positions based on preview/non-preview.
//		debug($finalFilesArr);
		reset($finalFilesArr);
		$fileNameList=array();
		while(list(,$infoArr)=each($finalFilesArr))	{
			if ($this->isPreview())	{		// If the form is a preview form (and data is therefore not going into the database...) do this.
				$this->createFileFuncObj();
				$fI=pathinfo($infoArr["name"]);
				$tmpFilename = $this->theTable."_".t3lib_div::shortmd5(uniqid($infoArr["name"])).".".$fI["extension"];
				$theDestFile = $this->fileFunc->getUniqueName($this->fileFunc->cleanFileName($tmpFilename), PATH_site."typo3temp/");
				t3lib_div::upload_copy_move($infoArr["tmp_name"],$theDestFile);
					// Setting the filename in the list
				$fI2=pathinfo($theDestFile);
				$fileNameList[]=$fI2["basename"]."|".$infoArr["name"];
//				debug($theDestFile,1);
			} else {
				$this->createFileFuncObj();
				$GLOBALS["TSFE"]->includeTCA();
				t3lib_div::loadTCA($this->theTable);
				if (is_array($GLOBALS["TCA"][$this->theTable]["columns"][$theField]))	{
					$uploadPath=$GLOBALS["TCA"][$this->theTable]["columns"][$theField]["config"]["uploadfolder"];
				}
				if ($uploadPath)	{
					$theDestFile = $this->fileFunc->getUniqueName($this->fileFunc->cleanFileName($infoArr["name"]), PATH_site.$uploadPath);
					copy($infoArr["tmp_name"],$theDestFile);
//					unlink($infoArr["tmp_name"]);
//					debug($theDestFile,1);
						// Setting the filename in the list
					$fI2=pathinfo($theDestFile);
					$fileNameList[]=$fI2["basename"];
					$this->filesStoredInUploadFolders[]=$theDestFile;
				}
			}
			// Implode the list of filenames
			$this->dataArr[$theField]=implode(",",$fileNameList);
		}
		
	}
	function overrideValues()	{
		// Addition of overriding values
		if (is_array($this->conf[$this->cmdKey."."]["overrideValues."]))	{
			reset($this->conf[$this->cmdKey."."]["overrideValues."]);
			while(list($theField,$theValue)=each($this->conf[$this->cmdKey."."]["overrideValues."]))	{
				$this->dataArr[$theField] = $theValue;
			}
		}
	}
	function defaultValues()	{
		// Addition of default values
		if (is_array($this->conf[$this->cmdKey."."]["defaultValues."]))	{
			reset($this->conf[$this->cmdKey."."]["defaultValues."]);
			while(list($theField,$theValue)=each($this->conf[$this->cmdKey."."]["defaultValues."]))	{
				$this->dataArr[$theField] = $theValue;
			}
		}
	}
	function setCObjects($templateCode,$currentArr=array(),$markerArray="",$specialPrefix="")	{
		if (is_array($this->conf["cObjects."]))	{
			reset($this->conf["cObjects."]);
	
			while(list($theKey,$theConf)=each($this->conf["cObjects."]))	{
				if (!strstr($theKey,"."))	{
					if (strstr($templateCode,"###".$specialPrefix."CE_".$theKey."###"))	{
						$cObjCode = $this->cObj->cObjGetSingle($this->conf["cObjects."][$theKey], $this->conf["cObjects."][$theKey."."], "cObjects.".$theKey);
						
						if (!is_array($markerArray))	{
							$this->markerArray["###".$specialPrefix."CE_".$theKey."###"] = $cObjCode;
						} else {
							$markerArray["###".$specialPrefix."CE_".$theKey."###"] = $cObjCode;
						}
					}
					if (strstr($templateCode,"###".$specialPrefix."PCE_".$theKey."###"))	{
						$local_cObj =t3lib_div::makeInstance("tslib_cObj");
						$local_cObj->start(count($currentArr)?$currentArr:$this->dataArr,$this->theTable);
						$cObjCode = $local_cObj->cObjGetSingle($this->conf["cObjects."][$theKey], $this->conf["cObjects."][$theKey."."], "cObjects.".$theKey);

						if (!is_array($markerArray))	{
							$this->markerArray["###".$specialPrefix."PCE_".$theKey."###"] = $cObjCode;
						} else {
							$markerArray["###".$specialPrefix."PCE_".$theKey."###"] = $cObjCode;
						}
					}
				}
			}
		}
		return $markerArray;
	}
	function save()	{
		switch($this->cmd)	{
			case "edit":
				$theUid = $this->dataArr[uid];
				$origArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,$theUid);		// Fetches the original record to check permissions
				if ($this->conf["edit"] && ($GLOBALS["TSFE"]->loginUser || $this->aCAuth($origArr)))	{	// Must be logged in in order to edit  (OR be validated by email)
					$newFieldList = implode(array_intersect(explode(",",$this->fieldList),t3lib_div::trimExplode(",",$this->conf["edit."]["fields"],1)),",");
					if ($this->aCAuth($origArr) || $this->cObj->DBmayFEUserEdit($this->theTable,$origArr,$GLOBALS["TSFE"]->fe_user->user,$this->conf["allowedGroups"],$this->conf["fe_userEditSelf"]))	{
						$query = $this->cObj->DBgetUpdate($this->theTable, $theUid, $this->dataArr, $newFieldList);
						if ($this->conf["debug"])		debug("Edit query: ".$query,1);
						mysql(TYPO3_db,$query);
						echo mysql_error();
						$this->currentArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,$theUid);
						$this->userProcess_alt($this->conf["edit."]["userFunc_afterSave"],$this->conf["edit."]["userFunc_afterSave."],array("rec"=>$this->currentArr, "origRec"=>$origArr));
						$this->saved=1;
					} else {
						$this->error="###TEMPLATE_NO_PERMISSIONS###";
					}
				}
			break;
			default:
				if ($this->conf["create"])	{
					$newFieldList = implode(array_intersect(explode(",",$this->fieldList),t3lib_div::trimExplode(",",$this->conf["create."]["fields"],1)),",");
					$query = $this->cObj->DBgetInsert($this->theTable, $this->thePid, $this->dataArr, $newFieldList);
					if ($this->conf["debug"])		debug("Create query: ".$query,1);
					mysql(TYPO3_db,$query);
					echo mysql_error();
					$newId = mysql_insert_id();

					if ($this->theTable=="fe_users" && $this->conf["fe_userOwnSelf"])	{		// enables users, creating logins, to own them self.
						$extraList="";
						$dataArr = array();
						if ($GLOBALS["TCA"][$this->theTable]["ctrl"]["fe_cruser_id"])		{
							$field=$GLOBALS["TCA"][$this->theTable]["ctrl"]["fe_cruser_id"]; 	
							$dataArr[$field]=$newId;
							$extraList.=",".$field;
						}
						if ($GLOBALS["TCA"][$this->theTable]["ctrl"]["fe_crgroup_id"])	{
							$field=$GLOBALS["TCA"][$this->theTable]["ctrl"]["fe_crgroup_id"]; 
							list($dataArr[$field])=explode(",",$this->dataArr["usergroup"]); 
							$dataArr[$field]=intval($dataArr[$field]); 
							$extraList.=",".$field;
						}
						if (count($dataArr))	{
							$query = $this->cObj->DBgetUpdate($this->theTable, $newId, $dataArr, $extraList);
							if ($this->conf["debug"])		debug("Own-self query: ".$query,1);
							mysql(TYPO3_db,$query);
							echo mysql_error();
						}
					}
					
					$this->currentArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,$newId);
					$this->userProcess_alt($this->conf["create."]["userFunc_afterSave"],$this->conf["create."]["userFunc_afterSave."],array("rec"=>$this->currentArr));
					$this->saved=1;
				}
			break;
		}
	}
	function removeRequired($templateCode,$failure)	{
			/* Remove required parts. 
				 Works like this: 
				 - Insert subparts like this ###SUB_REQUIRED_FIELD_".$theField."### that tells what is required for the field, if it's not correct filled in.
				 - These subparts are all removed, except if the field is listed in $failure string!
			*/
		reset($this->requiredArr);
		while(list(,$theField)=each($this->requiredArr))	{
			if (!t3lib_div::inList($failure,$theField))	{
				$templateCode = $this->cObj->substituteSubpart($templateCode, "###SUB_REQUIRED_FIELD_".$theField."###", "");
			}
		}
		return $templateCode;
	}
	function aCAuth($r)	{
		if ($this->authCode && !strcmp($this->authCode,$this->authCode($r)))	{
			return true;
		}
	}
	function getPlainTemplate($key,$r="")	{
		if ($this->conf["debug"])	debug("getPlainTemplate(): ".$key,1);
		$templateCode = $this->cObj->getSubpart($this->templateCode, $key);
		$this->setCObjects($templateCode,is_array($r)?$r:array());
		return  $this->cObj->substituteMarkerArray(
				$templateCode, 
				is_array($r) ? $this->cObj->fillInMarkerArray($this->markerArray, $r) : $this->markerArray
			);
	}
	function displayEditForm($origArr)	{
		$currentArr = is_array($this->dataArr) ? $this->dataArr+$origArr : $origArr;
#debug($currentArr);
		if ($this->conf["debug"])	debug("displayEditForm(): "."###TEMPLATE_EDIT".$this->previewLabel."###",1);
		$templateCode = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EDIT".$this->previewLabel."###");
		$failure = t3lib_div::GPvar("noWarnings")?"":$this->failure;
		if (!$failure)	{$templateCode = $this->cObj->substituteSubpart($templateCode, "###SUB_REQUIRED_FIELDS_WARNING###", "");}

		$templateCode = $this->removeRequired($templateCode,$failure);

		$this->setCObjects($templateCode,$currentArr);
		
		$markerArray = $this->cObj->fillInMarkerArray($this->markerArray, $currentArr);

		$markerArray["###HIDDENFIELDS###"].= '<input type="hidden" name="FE['.$this->theTable.'][uid]" value="'.$currentArr["uid"].'">';
		if ($this->conf["edit."]["preview"] && !$this->previewLabel)	{$markerArray["###HIDDENFIELDS###"].= '<input type="hidden" name="preview" value="1">';}
		$content = $this->cObj->substituteMarkerArray($templateCode, $markerArray);
		$content.=$this->cObj->getUpdateJS($this->modifyDataArrForFormUpdate($currentArr), $this->theTable."_form",  "FE[".$this->theTable."]", $this->fieldList.$this->additionalUpdateFields);

		return $content;
	}
	function displayEditScreen()	{
		if ($this->conf["edit"])	{	// If editing is enabled
			$origArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,  $this->dataArr["uid"]?$this->dataArr["uid"]:$this->recUid);

			if ($GLOBALS["TSFE"]->loginUser || $this->aCAuth($origArr))	{	// Must be logged in OR be authenticated by the aC code in order to edit
					// If the recUid selects a record.... (no check here)
				if (is_array($origArr))	{	
					if ($this->aCAuth($origArr) || $this->cObj->DBmayFEUserEdit($this->theTable,$origArr, $GLOBALS["TSFE"]->fe_user->user,$this->conf["allowedGroups"],$this->conf["fe_userEditSelf"]))	{	// Display the form, if access granted.
						$content=$this->displayEditForm($origArr);
					} else {	// Else display error, that you could not edit that particular record...
						$content = $this->getPlainTemplate("###TEMPLATE_NO_PERMISSIONS###");
					}
				} elseif ($GLOBALS["TSFE"]->loginUser) { 	// If the recUid did not select a record, we display a menu of records. (eg. if no recUid)
					$lockPid=$this->conf["edit."]["menuLockPid"] ? " AND pid=".$this->thePid : "";
					$query = "SELECT * FROM ".$this->theTable." WHERE 1=1".$lockPid.$this->cObj->DBmayFEUserEditSelect($this->theTable,$GLOBALS["TSFE"]->fe_user->user, $this->conf["allowedGroups"],$this->conf["fe_userEditSelf"]).$GLOBALS["TSFE"]->sys_page->deleteClause($this->theTable);
					$res = mysql(TYPO3_db,$query);
					echo mysql_error();

					if (mysql_num_rows($res))	{	// If there are menu-items ...
						$templateCode = $this->getPlainTemplate("###TEMPLATE_EDITMENU###");
						$out="";
						$itemCode = $this->cObj->getSubpart($templateCode, "###ITEM###");
						while($menuRow=mysql_fetch_assoc($res))	{
							$markerArray = $this->cObj->fillInMarkerArray(array(), $menuRow);
							$markerArray = $this->setCObjects($itemCode,$menuRow,$markerArray,"ITEM_");
							$out.= $this->cObj->substituteMarkerArray($itemCode, $markerArray);
						}
						$content=$this->cObj->substituteSubpart($templateCode, "###ALLITEMS###", $out);
					} else {	// If there are not menu items....
						$content = $this->getPlainTemplate("###TEMPLATE_EDITMENU_NOITEMS###");
					}
				} else {
					$content = $this->getPlainTemplate("###TEMPLATE_AUTH###");
				}
			} else {	// Finally this is if there is no login user. This must tell that you must login. Perhaps link to a page with create-user or login information.
				$content = $this->getPlainTemplate("###TEMPLATE_AUTH###");
			}
		} else {
			$content.="Edit-option is not set in TypoScript";
		}
		return $content;
	}
	function deleteRecord()	{
		if ($this->conf["delete"])	{	// If deleting is enabled
			$origArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,  $this->recUid);
			if ($GLOBALS["TSFE"]->loginUser || $this->aCAuth($origArr))	{	// Must be logged in OR be authenticated by the aC code in order to delete
					// If the recUid selects a record.... (no check here)
				if (is_array($origArr))	{	
					if ($this->aCAuth($origArr) || $this->cObj->DBmayFEUserEdit($this->theTable,$origArr, $GLOBALS["TSFE"]->fe_user->user,$this->conf["allowedGroups"],$this->conf["fe_userEditSelf"]))	{	// Display the form, if access granted.
						if (!$GLOBALS["TCA"][$this->theTable]["ctrl"]["delete"])	{	// If the record is fully deleted... then remove the image attached.
							$this->deleteFilesFromRecord($this->recUid);
						}
						$query = $this->cObj->DBgetDelete($this->theTable, $this->recUid);
						mysql(TYPO3_db,$query);
						echo mysql_error();
						$this->currentArr = $origArr;
						$this->saved=1;
					} else {
						$this->error="###TEMPLATE_NO_PERMISSIONS###";
					}
				}
			}
		}
	}
	function deleteFilesFromRecord($uid)	{
		// Deletes the files attached to a record and updates the record.
		$table = $this->theTable;
		$rec = $GLOBALS["TSFE"]->sys_page->getRawRecord($table,$uid);
		
		$GLOBALS["TSFE"]->includeTCA();
		t3lib_div::loadTCA($table);
		reset($GLOBALS["TCA"][$table]["columns"]);
		$iFields=array();
		while(list($field,$conf)=each($GLOBALS["TCA"][$table]["columns"]))	{
			if ($conf["config"]["type"]=="group" && $conf["config"]["internal_type"]=="file")	{
				$query="UPDATE ".$table." SET ".$field."='' WHERE uid=".$uid;
				$res=mysql(TYPO3_db,$query);
				echo mysql_error();
				$delFileArr = explode(",",$rec[$field]);
				reset($delFileArr);
				while(list(,$n)=each($delFileArr))	{
					if ($n)	{
						$fpath = $conf["config"]["uploadfolder"]."/".$n;
						unlink($fpath);
					}
				}
			}
		}
	}
	function displayDeleteScreen()	{	// This is basically the preview display of delete
		if ($this->conf["delete"])	{	// If deleting is enabled
			$origArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,  $this->recUid);
			if ($GLOBALS["TSFE"]->loginUser || $this->aCAuth($origArr))	{	// Must be logged in OR be authenticated by the aC code in order to delete
					// If the recUid selects a record.... (no check here)
				if (is_array($origArr))	{	
					if ($this->aCAuth($origArr) || $this->cObj->DBmayFEUserEdit($this->theTable,$origArr, $GLOBALS["TSFE"]->fe_user->user,$this->conf["allowedGroups"],$this->conf["fe_userEditSelf"]))	{	// Display the form, if access granted.
						$this->markerArray["###HIDDENFIELDS###"].= '<input type="hidden" name="rU" value="'.$this->recUid.'">';
						$content = $this->getPlainTemplate("###TEMPLATE_DELETE_PREVIEW###", $origArr);
					} else {	// Else display error, that you could not edit that particular record...
						$content = $this->getPlainTemplate("###TEMPLATE_NO_PERMISSIONS###");
					}
				}
			} else {	// Finally this is if there is no login user. This must tell that you must login. Perhaps link to a page with create-user or login information.
				$content = $this->getPlainTemplate("###TEMPLATE_AUTH###");
			}
		} else {
			$content.="Delete-option is not set in TypoScript";
		}
		return $content;
	}
	function displayCreateScreen()	{
		if ($this->conf["create"])	{
			$templateCode = $this->cObj->getSubpart($this->templateCode, ((!$GLOBALS["TSFE"]->loginUser||$this->conf["create."]["noSpecialLoginForm"])?"###TEMPLATE_CREATE".$this->previewLabel."###":"###TEMPLATE_CREATE_LOGIN".$this->previewLabel."###"));
			$failure = t3lib_div::GPvar("noWarnings")?"":$this->failure;
			if (!$failure)	$templateCode = $this->cObj->substituteSubpart($templateCode, "###SUB_REQUIRED_FIELDS_WARNING###", "");

			$templateCode = $this->removeRequired($templateCode,$failure);
			$this->setCObjects($templateCode);

			$markerArray = $this->cObj->fillInMarkerArray($this->markerArray, $this->dataArr);
			if ($this->conf["create."]["preview"] && !$this->previewLabel)	{$markerArray["###HIDDENFIELDS###"].= '<input type="hidden" name="preview" value="1">';}
			$content = $this->cObj->substituteMarkerArray($templateCode, $markerArray);
			$content.=$this->cObj->getUpdateJS($this->modifyDataArrForFormUpdate($this->dataArr), $this->theTable."_form", "FE[".$this->theTable."]", $this->fieldList.$this->additionalUpdateFields);
		}
		return $content;
	}
	function modifyDataArrForFormUpdate($inputArr)	{
		if (is_array($this->conf[$this->cmdKey."."]["evalValues."]))	{
			reset($this->conf[$this->cmdKey."."]["evalValues."]);
			while(list($theField,$theValue)=each($this->conf[$this->cmdKey."."]["evalValues."]))	{
				$listOfCommands = t3lib_div::trimExplode(",",$theValue,1);
				while(list(,$cmd)=each($listOfCommands))	{
					$cmdParts = split("\[|\]",$cmd);	// Point is to enable parameters after each command enclosed in brackets [..]. These will be in position 1 in the array.
					$theCmd = trim($cmdParts[0]);
					switch($theCmd)	{
						case "twice":
							if (isset($inputArr[$theField]))	{
								if (!isset($inputArr[$theField."_again"]))	{
									$inputArr[$theField."_again"] = $inputArr[$theField];
								}
								$this->additionalUpdateFields.=",".$theField."_again";
							}
						break;
					}
				}
			}
		}
		if (is_array($this->conf["parseValues."]))	{
			reset($this->conf["parseValues."]);
			while(list($theField,$theValue)=each($this->conf["parseValues."]))	{
				$listOfCommands = t3lib_div::trimExplode(",",$theValue,1);
				while(list(,$cmd)=each($listOfCommands))	{
					$cmdParts = split("\[|\]",$cmd);	// Point is to enable parameters after each command enclosed in brackets [..]. These will be in position 1 in the array.
					$theCmd = trim($cmdParts[0]);
					switch($theCmd)	{
						case "multiple":
							if (isset($inputArr[$theField]) && !$this->isPreview())	{
								$inputArr[$theField] = explode(",",$inputArr[$theField]);
							}
						break;
						case "checkArray":
							if ($inputArr[$theField] && !$this->isPreview())	{
								for($a=0;$a<=30;$a++)	{
									if ($inputArr[$theField] & pow(2,$a))	{
										$alt_theField = $theField."][".$a;
										$inputArr[$alt_theField] = 1;
										$this->additionalUpdateFields.=",".$alt_theField;
									}
								}
							} 
						break;
					}
				}
			}
		}


		$inputArr = $this->userProcess_alt(
			$this->conf["userFunc_updateArray"],
			$this->conf["userFunc_updateArray."],
			$inputArr
		);

		return $inputArr;
	}
	function procesSetFixed()	{
		if ($this->conf["setfixed"])	{
			$theUid = intval($this->recUid);
			$origArr = $GLOBALS["TSFE"]->sys_page->getRawRecord($this->theTable,  $theUid);
			$fD = t3lib_div::GPvar("fD");
			$sFK = t3lib_div::GPvar("sFK");
//			debug($fD);
			$fieldArr=array();
			if (is_array($fD) || $sFK=="DELETE")	{
				if (is_array($fD))	{
					reset($fD);
					while(list($field,$value)=each($fD))	{
						$origArr[$field]=stripslashes($value);
						$fieldArr[]=$field;
					}
				}
				$theCode = $this->setfixedHash($origArr,$origArr["_FIELDLIST"]);
				if (!strcmp($this->authCode,$theCode))	{
					if ($sFK=="DELETE")	{
						$query = $this->cObj->DBgetDelete($this->theTable, $theUid);
						mysql(TYPO3_db,$query);
						echo mysql_error();
					} else {
						$newFieldList = implode(array_intersect(t3lib_div::trimExplode(",",$this->fieldList),t3lib_div::trimExplode(",",implode($fieldArr,","),1)),",");
						$query = $this->cObj->DBgetUpdate($this->theTable, $theUid, $fD, $newFieldList);
						mysql(TYPO3_db,$query);
						echo mysql_error();
					}

						// Outputting template
					$this->markerArray = $this->cObj->fillInMarkerArray($this->markerArray, $origArr);
					$content = $this->getPlainTemplate("###TEMPLATE_SETFIXED_OK_".$sFK."###");
					if (!$content)	{$content = $this->getPlainTemplate("###TEMPLATE_SETFIXED_OK###");}

						// Compiling email
					$this->compileMail(
						"SETFIXED_".$sFK, 
						array($origArr),
						$origArr[$this->conf["email."]["field"]],
						$this->conf["setfixed."]
					);
						// Clearing cache if set:
					$this->clearCacheIfSet();
				} else $content = $this->getPlainTemplate("###TEMPLATE_SETFIXED_FAILED###");
			} else $content = $this->getPlainTemplate("###TEMPLATE_SETFIXED_FAILED###");
		}
		return $content;
	}
	function sendInfoMail()	{
		if ($this->conf["infomail"] && $this->conf["email."]["field"])	{
			$fetch = t3lib_div::GPvar("fetch");
			if (isset($fetch))	{
					// Getting infomail config.
				$key= trim(t3lib_div::GPvar("key"));
				if (is_array($this->conf["infomail."][$key."."]))		{
					$config = $this->conf["infomail."][$key."."];
				} else {
					$config = $this->conf["infomail."]["default."];
				}
				$pidLock="";
				if (!$config["dontLockPid"])	{
					$pidLock="AND pid IN (".$this->thePid.") ";
				}

					// Getting records
				if (t3lib_div::testInt($fetch))	{
					$DBrows = $GLOBALS["TSFE"]->sys_page->getRecordsByField($this->theTable,"uid",$fetch,$pidLock."LIMIT 1");
				} elseif ($fetch) {	// $this->conf["email."]["field"] must be a valid field in the table!
					$DBrows = $GLOBALS["TSFE"]->sys_page->getRecordsByField($this->theTable,$this->conf["email."]["field"],$fetch,$pidLock."LIMIT 100");
				}
//				debug($config);
//				debug($DBrows);
					// Processing records
				if (is_array($DBrows))	{
					$recipient = $DBrows[0][$this->conf["email."]["field"]];
					$this->compileMail($config["label"], $DBrows, $recipient, $this->conf["setfixed."]);
				} elseif ($this->cObj->checkEmail($fetch)) {
					$this->sendMail($fetch, "", trim($this->cObj->getSubpart($this->templateCode, "###".$this->emailMarkPrefix."NORECORD###")));
				}

				$content = $this->getPlainTemplate("###TEMPLATE_INFOMAIL_SENT###");
			} else {
				$content = $this->getPlainTemplate("###TEMPLATE_INFOMAIL###");
			}
		} else $content="Error: infomail option is not available or emailField is not setup in TypoScript";
		return $content;
	}
	function compileMail($key, $DBrows, $recipient, $setFixedConfig=array())	{
		$GLOBALS["TT"]->push("compileMail");
		$mailContent="";
		$key = $this->emailMarkPrefix.$key;

		$userContent["all"] = trim($this->cObj->getSubpart($this->templateCode, "###".$key."###"));
		$adminContent["all"] = trim($this->cObj->getSubpart($this->templateCode, "###".$key."-ADMIN###"));
		$userContent["rec"] = $this->cObj->getSubpart($userContent["all"], "###SUB_RECORD###");
		$adminContent["rec"] = $this->cObj->getSubpart($adminContent["all"], "###SUB_RECORD###");

		reset($DBrows);
		while(list(,$r)=each($DBrows))	{
			$markerArray = $this->cObj->fillInMarkerArray($this->markerArray, $r,"",0);
			$markerArray = $this->setCObjects($userContent["rec"].$adminContent["rec"],$r,$markerArray,"ITEM_");
			$markerArray["###SYS_AUTHCODE###"] = $this->authCode($r);
			$markerArray = $this->setfixed($markerArray, $setFixedConfig, $r);
			
			if ($userContent["rec"])	$userContent["accum"] .=$this->cObj->substituteMarkerArray($userContent["rec"], $markerArray);
			if ($adminContent["rec"])	$adminContent["accum"].=$this->cObj->substituteMarkerArray($adminContent["rec"], $markerArray);
		}
//			debug($setFixedConfig);
//			debug($markerArray);

		if ($userContent["all"])	$userContent["final"] .=$this->cObj->substituteSubpart($userContent["all"], "###SUB_RECORD###", $userContent["accum"]);
		if ($adminContent["all"])	$adminContent["final"].=$this->cObj->substituteSubpart($adminContent["all"], "###SUB_RECORD###", $adminContent["accum"]);
		
		if (t3lib_div::testInt($recipient))	{
			$fe_userRec = $GLOBALS["TSFE"]->sys_page->getRawRecord("fe_users",$recipient);
			$recipient=$fe_userRec["email"];
		}
#debug($recipient);
#debug($userContent);
#debug($adminContent);
		$GLOBALS["TT"]->setTSlogMessage("Template key: ###".$key."###, userContentLength: ".strlen($userContent["final"]).", adminContentLength: ".strlen($adminContent["final"]));
		
		$this->sendMail($recipient, $this->conf["email."]["admin"], $userContent["final"], $adminContent["final"]);
		$GLOBALS["TT"]->pull();
	}
	function sendMail($recipient, $admin, $content="", $adminContent="")	{
			// Admin mail:
		if ($admin && $adminContent)	{
			if (!$this->isHTMLContent($adminContent))	{
				$admMail = $this->cObj->sendNotifyEmail($adminContent, 
									$admin, 
									"", 
									$this->conf["email."]["from"], 
									$this->conf["email."]["fromName"],
									$recipient
							);
			} else {
				$this->sendHTMLMail($adminContent, 
									$admin, 
									"", 
									$this->conf["email."]["from"], 
									$this->conf["email."]["fromName"],
									$recipient
							);
			}
		}
			// user mail:
		if (!$this->isHTMLContent($adminContent))	{
			$this->cObj->sendNotifyEmail($content, 
								$recipient, 
								"",			// ($admMail ? "" : $admin), 		// If the special administration mail was not found and send, the regular is...
								$this->conf["email."]["from"], 
								$this->conf["email."]["fromName"]
						);
		} else {
			$this->sendHTMLMail($content, 
								$recipient, 
								"",			// ($admMail ? "" : $admin), 		// If the special administration mail was not found and send, the regular is...
								$this->conf["email."]["from"], 
								$this->conf["email."]["fromName"]
						);
		}
	}
	function isHTMLContent($c)	{
			// Returns true if the content begins and ends with <html></html>-tags
		$c = trim($c);
		$first = strtolower(substr($c,0,6));
		$last = strtolower(substr($c,-7));
		if ($first.$last=="<html></html>")	return 1;
	}
	function sendHTMLMail($content,$recipient,$dummy,$fromEmail,$fromName,$replyTo="")	{
			// HTML
		if (trim($recipient) && trim($content))	{
			$cls=t3lib_div::makeInstanceClassName("t3lib_htmlmail");
			if (class_exists($cls))	{	// If htmlmail lib is included, then generate a nice HTML-email
				$parts = spliti("<title>|</title>",$content,3);
				$subject = trim($parts[1]) ? trim($parts[1]) : "Typo3 FE Admin message";
	
				$Typo3_htmlmail = t3lib_div::makeInstance("t3lib_htmlmail");
				$Typo3_htmlmail->start();
				$Typo3_htmlmail->useBase64();
	
				$Typo3_htmlmail->subject = $subject;
				$Typo3_htmlmail->from_email = $fromEmail;
				$Typo3_htmlmail->from_name = $fromName;
				$Typo3_htmlmail->replyto_email = $replyTo ? $replyTo : $fromEmail;
				$Typo3_htmlmail->replyto_name = $replyTo ? "" : $fromName;
				$Typo3_htmlmail->organisation = "";
				$Typo3_htmlmail->priority = 3;
	
					// HTML
				$Typo3_htmlmail->theParts["html"]["content"] = $content;	// Fetches the content of the page
				$Typo3_htmlmail->theParts["html"]["path"] = "";
				$Typo3_htmlmail->extractMediaLinks();
				$Typo3_htmlmail->extractHyperLinks();
				$Typo3_htmlmail->fetchHTMLMedia();
				$Typo3_htmlmail->substMediaNamesInHTML(0);	// 0 = relative
				$Typo3_htmlmail->substHREFsInHTML();	
				$Typo3_htmlmail->setHTML($Typo3_htmlmail->encodeMsg($Typo3_htmlmail->theParts["html"]["content"]));
	
					// PLAIN
				$Typo3_htmlmail->addPlain("");
		
					// SET Headers and Content
				$Typo3_htmlmail->setHeaders();
				$Typo3_htmlmail->setContent();
				$Typo3_htmlmail->setRecipient($recipient);
	
	
		//		debug($Typo3_htmlmail->theParts);
				$Typo3_htmlmail->sendtheMail();
			} else {
				debug("SYSTEM ERROR: No HTML-mail library loaded. Set 'page.config.incT3Lib_htmlmail = 1' is your TypoScript template.");
			}
		}
	}
	function authCode($r,$extra="")	{
		$l=$this->codeLength;
		if ($this->conf["authcodeFields"])	{
			$fieldArr = t3lib_div::trimExplode(",", $this->conf["authcodeFields"], 1);
			$value="";
			while(list(,$field)=each($fieldArr))	{
				$value.=$r[$field]."|";
			}
			$value.=$extra."|".$this->conf["authcodeFields."]["addKey"];
			if ($this->conf["authcodeFields."]["addDate"])	{
				$value.="|".date($this->conf["authcodeFields."]["addDate"]);
			}
			$value.=$GLOBALS["TYPO3_CONF_VARS"]["SYS"]["encryptionKey"];
//			debug($value);
			return substr(md5($value), 0,$l);
		}
	}
	function setfixed($markerArray, $setfixed, $r)	{
		if (is_array($setfixed))	{
			reset($setfixed);
			while(list($theKey,$data)=each($setfixed))	{
				if (!strcmp($theKey,"DELETE"))	{
					$recCopy = $r;
					$string="&cmd=setfixed&sFK=".rawurlencode($theKey)."&rU=".$r[uid];
					$string.="&aC=".$this->setfixedHash($recCopy,$data["_FIELDLIST"]); 
					$markerArray["###SYS_SETFIXED_DELETE###"] = $string;
				} elseif (strstr($theKey,"."))	{
					$theKey = substr($theKey,0,-1);
					if (is_array($data))	{
						reset($data);
						$recCopy = $r;
						$string="&cmd=setfixed&sFK=".rawurlencode($theKey)."&rU=".$r[uid];
						while(list($fieldName,$fieldValue)=each($data))	{
							$string.="&fD[".$fieldName."]=".rawurlencode($fieldValue);
							$recCopy[$fieldName]=$fieldValue;
						}
						$string.="&aC=".$this->setfixedHash($recCopy,$data["_FIELDLIST"]);
						$markerArray["###SYS_SETFIXED_".$theKey."###"] = $string;
					}
				}
			}
		}
//		debug($markerArray);
		return $markerArray;
	}
	
	function setfixedHash($recCopy,$fields="")	{
		if ($fields)	{
			$fieldArr = t3lib_div::trimExplode(",",$fields,1);
			reset($fieldArr);
			while(list($k,$v)=each($fieldArr))	{
				$recCopy_temp[$k]=$recCopy[$v];
			}
		} else {
			$recCopy_temp=$recCopy;
		}
		$encStr = implode("|",$recCopy_temp)."|".$this->conf["authcodeFields."]["addKey"]."|".$GLOBALS["TYPO3_CONF_VARS"]["SYS"]["encryptionKey"];
//		debug($encStr,1);
//		debug($fields,1);
		$hash = substr(md5($encStr),0,$this->codeLength);
		return $hash;
	}
	
	// Returns true if preview display is on.
	function isPreview()	{
		return ($this->conf[$this->cmdKey."."]["preview"] && $this->preview);
	}
	
	function createFileFuncObj()	{
		if (!$this->fileFunc)	{
			$this->fileFunc = t3lib_div::makeInstance("t3lib_basicFileFunctions");
		}
	}
	function clearCacheIfSet()	{
		if ($this->conf["clearCacheOfPages"])	{
			$cc_pidList = implode(",",t3lib_div::intExplode(",",$this->conf["clearCacheOfPages"]));
//				debug($cc_pidList);
			$GLOBALS["TSFE"]->clearPageCacheContent_pidList($cc_pidList);
		}
	}	
}


if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["media/scripts/fe_adminLib.inc"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["media/scripts/fe_adminLib.inc"]);
}

?>