<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Alternative TBE: Main menu
 *
 * This is an alternative Typo3 Backend interface using the same modules, but designed to work with less capable browsers than MSIE.
 * This is probably in pre-alpha test as this time... so dont expect anything useful.
 * 
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

 
require ("init.php");
require ("template.php");
require_once (PATH_t3lib."class.t3lib_loadmodules.php");
require_once (PATH_t3lib."class.t3lib_basicfilefunc.php");
require_once ("class.alt_menu_functions.inc");
include ("sysext/lang/locallang_alt_intro.php");


// ***************************
// Script Classes
// ***************************
class SC_alt_intro {
	var $loadModules;
	var $content;
	
	function init()	{
		global $TBE_MODULES;

		$this->loadModules = t3lib_div::makeInstance("t3lib_loadModules");
		$this->loadModules->load($TBE_MODULES);
	}
	function main()	{
		global $AB,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$HTTP_GET_VARS,$HTTP_POST_VARS,$CLIENT,$TYPO3_CONF_VARS;
		global $TBE_TEMPLATE,$TYPO_VERSION;
		
		$alt_menuObj = t3lib_div::makeInstance("alt_menu_functions");
			
		$this->content.='
<!DOCTYPE html public "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
'.$TBE_TEMPLATE->docStyle().'
<TITLE>menu</TITLE>
<META name="GENERATOR" content="TYPO3 '.$TYPO_VERSION.' by www.typo3.com, (c) Kasper Skrhj 1998-2003">
'.$TBE_TEMPLATE->initCharset().'
</HEAD>
<BODY vlink=black alink=black link=black bgColor="'.$TBE_TEMPLATE->bgColor.'"'.$TBE_TEMPLATE->getBackgroundImage().'>

<table border=0 cellpadding=0 cellspacing=0 width=600>
<tr><td><img src=clear.gif width=30 height=1></td><td>

<br>
<br>';


			// COPYRIGHT NOTICE:
		$loginCopyrightWarrantyProvider = strip_tags(trim($GLOBALS["TYPO3_CONF_VARS"]["SYS"]["loginCopyrightWarrantyProvider"]));
		$loginCopyrightWarrantyURL = strip_tags(trim($GLOBALS["TYPO3_CONF_VARS"]["SYS"]["loginCopyrightWarrantyURL"]));
		
		if (strlen($loginCopyrightWarrantyProvider)>=2 && strlen($loginCopyrightWarrantyURL)>=10)	{
			$warrantyNote='Warranty is supplied by '.$loginCopyrightWarrantyProvider.'; <a href="'.$loginCopyrightWarrantyURL.'" target="_blank">click for details.</a>';
		} else {
			$warrantyNote='TYPO3 comes with ABSOLUTELY NO WARRANTY; <a href="http://typo3.com/1316.0.html" target="_blank">click for details.</a>';
		}
		
		$cNotice='<br><a href="http://typo3.com/" target="_blank"><img src="gfx/loginlogo_transp.gif" width="75" vspace=2 height="19" alt="TYPO3 logo" border="0" align="left">TYPO3 CMS ver. '.htmlspecialchars($GLOBALS["TYPO_VERSION"]).'</a>. Copyright &copy; 1998-2003 Kasper Skrhj. Extensions are copyright of their respective owners. Go to <a href="http://typo3.com/" target="_blank">http://typo3.com/</a> for details.
		'.strip_tags($warrantyNote,'<a>').' This is free software, and you are welcome to redistribute it under certain conditions; <a href="http://typo3.com/1316.0.html" target="_blank">click for details</a>. Obstructing the appearance of this notice is prohibited by law.<br><br>';

		




		$this->content.= fw(sprintf("<font size=2><strong><div align=center>%s</div></strong></font>%s<font size=1>%s</font>",
			"TYPO3 ".$TYPO_VERSION."<br>".$LANG->getLL("introtext"),
			$cNotice,
			$LANG->getLL("introtext2"))
		);
		

		
		


		$this->content.= "<BR>";

		// *****************************************************
		// Printing the description of the modules available
		// *****************************************************
		$this->content.=$alt_menuObj->topMenu($this->loadModules->modules,0,"",1);
		$this->content.=fw("<BR><em>(".$LANG->getLL("endText").")</em>");
		$this->content.="<BR><HR>";
		$this->content.=fw(sprintf($LANG->getLL("userInfo"),$BE_USER->user["username"],(implode(", ",array($BE_USER->user["realName"],$BE_USER->user["email"])))));
		$this->content.='
<br>
<br>
<br>

</td></tr>
</table>
</BODY>
</HTML>		
		';
	}
	function printContent()	{
		echo $this->content;
	}
}

// Include extension?
if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/alt_intro.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/alt_intro.php"]);
}












// Make instance:
$SOBE = t3lib_div::makeInstance("SC_alt_intro");
$SOBE->init();
$SOBE->main();
$SOBE->printContent();

?>