<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Alternative TBE: Main menu
 *
 * This is an alternative Typo3 Backend interface using the same modules, but designed to work with less capable browsers than MSIE.
 * This is probably in pre-alpha test as this time... so dont expect anything useful.
 * 
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

 
require ("init.php");
require ("template.php");
require_once (PATH_t3lib."class.t3lib_loadmodules.php");
require_once (PATH_t3lib."class.t3lib_basicfilefunc.php");
require_once ("class.alt_menu_functions.inc");


// ***************************
// Script Classes
// ***************************
class SC_alt_menu {
	function init()	{
		global $TBE_MODULES;

		$this->loadModules = t3lib_div::makeInstance("t3lib_loadModules");
		$this->loadModules->load($TBE_MODULES);
	}
	function main()	{
		global $AB,$BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$HTTP_GET_VARS,$HTTP_POST_VARS,$CLIENT,$TYPO3_CONF_VARS;
		global $TBE_TEMPLATE,$TYPO_VERSION;
		
		$this->content.='
<!DOCTYPE html public "-//W3C//DTD HTML 3.2 Final//EN">
<HTML>
<HEAD>
'.$TBE_TEMPLATE->docStyle().'
<TITLE>menu</TITLE>
<META name="GENERATOR" content="TYPO3 '.$TYPO_VERSION.' by www.typo3.com, (c) Kasper Skrhj 1998-2003">
'.$TBE_TEMPLATE->initCharset().'
</HEAD>
<BODY vlink=black alink=black link=black bgColor="'.$TBE_TEMPLATE->bgColor.'"'.$TBE_TEMPLATE->getBackgroundImage().'>
';

		$alt_menuObj = t3lib_div::makeInstance("alt_menu_functions");
		$AB=1;

		// ********************
		// Printing the menu
		// ********************
		$this->content.=$alt_menuObj->topMenu($this->loadModules->modules);
		
		
		// ******************
		// clear cache commands for Admins
		// ******************
		if($BE_USER->isAdmin()) {
			$this->content.='<br><div align="left" style="width:90%;">';
			$this->content.='<table border=0 cellpadding=0 cellspacing=1 width=100%>';

			$this->content.='<tr><td colspan=3 bgColor="'.$TBE_TEMPLATE->bgColor5.'" nowrap>'.fw("&nbsp;<b>Admin functions</b>&nbsp;").'</td></tr>';
			$this->content.='<tr><td colspan=3><img src=clear.gif width=1 height=2></td></tr>';
			
				// Clearing of cache-files in typo3conf/ + menu
			global $TYPO3_CONF_VARS;
			if ($TYPO3_CONF_VARS["EXT"]["extCache"])	{
				if (t3lib_div::GPvar("_clearCacheFiles"))	{
					$this->removeCacheFiles();
				}
				$this->content.='<tr><td valign=top align=center><img src="'.$backPath.'mod/tools/em/em.gif" border=0 width="14" height="12" hspace=2></td><td>'.fw('<a href="'.t3lib_div::linkThisScript(array("_clearCacheFiles"=>1)).'">Clear cache files in typo3conf/</a>').'</td></tr>';
			}

			$this->content.='<tr><td colspan=2><img src="'.$backPath.'gfx/altmenuline.gif" border=0 width="105" height="3" vspace=1></td></tr>';

				// clear all page cache
			$this->content.='<tr><td valign=top align=center><img src="'.$backPath.'sysext/cms/layout/layout.gif" border=0 width="14" height="12" hspace=2></td><td>'.fw('<a href="'.$this->backPath.'tce_db.php?vC='.$BE_USER->veriCode().'&redirect='.rawurlencode(t3lib_div::getIndpEnv("REQUEST_URI")).'&cacheCmd=all">'.htmlspecialchars($GLOBALS["LANG"]->mainLang["rm"]["clearCache_all"])).'</a></td></tr>';

			$this->content.='</table>';
			$this->content.='</div><BR>';
		}

		
		
		// ******************
		// Printing bottons
		// ******************
		$this->content.="<BR>";
		$this->content.='<div align="center">'.$alt_menuObj->topButtons();
		
		$this->content.=fw("<BR>[".$BE_USER->user["username"]."]").'</div>';
		
		$this->content.='
</BODY>
</HTML>		
		';
	}
	/**
		* Unlink (delete) cache files
		*/
	function removeCacheFiles()	{
		$cacheFiles=t3lib_extMgm::currentCacheFiles();
		$out=0;
		if (is_array($cacheFiles))	{
			reset($cacheFiles);
			while(list(,$cfile)=each($cacheFiles))	{
				@unlink($cfile);
				clearstatcache();
				$out++;
			}
		}
		return $out;
	}
	function printContent()	{
		echo $this->content;
	}
}

// Include extension?
if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/alt_menu.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/alt_menu.php"]);
}












// Make instance:
$SOBE = t3lib_div::makeInstance("SC_alt_menu");
$SOBE->init();
$SOBE->main();
$SOBE->printContent();
?>