<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2002-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Content rendering' for the 'css_styled_content' extension.
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_cssstyledcontent_pi1 extends tslib_pibase {
	var $prefixId = "tx_cssstyledcontent_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_cssstyledcontent_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "css_styled_content";	// The extension key.
	var $conf = array();
	
	function main($content,$conf)	{
		$this->conf = $conf;
		
		$CTypeValue = (string)$this->cObj->data["CType"];	// This value is the Content Element Type - determines WHAT kind of element to render...
		$content="";
		switch($CTypeValue)	{
			case "header":
				$content = $this->getHeader().$this->render_subheader();
			break;
			case "bullets":
				$content = $this->getHeader().$this->render_bullets();
			break;
			case "table":
				$content = $this->getHeader().$this->render_table();
			break;
			case "text":
				$content = $this->getHeader().$this->render_text();
			break;
			case "image":
				$content = $this->getHeader().$this->render_image();
			break;
			case "textpic":
				$content = $this->render_textpic();
			break;
			
			case "list":
				$content.=$this->getHeader();
				
			default:
				$content.= $this->cObj->cObjGetSingle($conf[$CTypeValue],$conf[$CTypeValue."."],"CType: ".$CTypeValue);
			break;
		}
#debug($CTypeValue);
#debug(array($content));
		if (!$this->conf["noANameTagForFirstRecord"] || $this->cObj->parentRecordNumber>1)	{
			$content='<a name="'.$this->cObj->data["uid"].'"></a>'.$content;
		}
		return $content;
	}
	function getHeader()	{
		$conf = $GLOBALS["TSFE"]->tmpl->setup["lib."]["stdheader."];
		$out="";
		if (!strcmp(trim($this->cObj->data["header"]),""))	return "";	// Return, if the "header" fields is empty.
		
		if ($this->cObj->data["header_layout"]==100)	return "";	// Hidden header...
		if ($this->cObj->data["date"])	{	// Wrap date:
			$out='<p class="csc-header-date">'.date($conf["5."]["date"],$this->cObj->data["date"]).'</p>';
		}

			// Add link if set:
		$header = $this->cObj->data["header"];
		if ($this->cObj->data["header_link"])	{
			$header = $this->pi_linkToPage($header,$this->cObj->data["header_link"]);
		}
		
			// Getting the header, rendered by a cObject:
		$this->cObj->setCurrentVal($header);
		$content = $this->cObj->cObjGetSingle($conf["10"],$conf["10."]);
			// Prepend the header content to the date, if any
		$out.=chr(10).$content;
			// Add edit icons finally.
		$out = $this->editIcons($out,"tt_content : header, header_layout, [header_link|date]","Edit header");
#debug(array($out));

		return $out;		
	}
	function render_image()	{
		$content = $this->cObj->cObjGetSingle("IMGTEXT",$this->conf["image."],"CType: image");
		return $content;
	}
	function render_textpic()	{
		$header = $this->getHeader();
		$bodytext = $this->render_text();
		$content = "";

		$conf=$this->conf["image."];
		if ($this->cObj->data["imageorient"]<25)	{
			$conf["text."]["10"]="TEXT";
			$conf["text."]["10."]["value"]=$bodytext;
			$content.=$header;
		} else {
			$conf["text."]["10"]="TEXT";
			$conf["text."]["10."]["value"]=$header.$bodytext;
		}
#debug($conf)		;
		$content.= $this->cObj->cObjGetSingle("IMGTEXT",$conf,"CType: image");
		return $content;
	}
	function render_text()	{
		$content = trim($this->cObj->data["bodytext"]);	// Get bodytext field content
		if (!strcmp($content,""))	return "";
		
		$out = $this->cObj->parseFunc($content, $this->conf["text."]["20."]["parseFunc."]);
		$out = $this->editIcons($out,"tt_content:bodytext, rte_enabled","Edit bodytext");

		return $out;
	}
	function render_bullets()	{
		$content = trim($this->cObj->data["bodytext"]);	// Get bodytext field content
		if (!strcmp($content,""))	return "";
		
		$lines = t3lib_div::trimExplode(chr(10),$content);	// Split into single lines
		while(list($k)=each($lines))	{
			$lines[$k]='<LI>'.$lines[$k].'</LI>';
		}
		$out = "<UL>".
			implode(chr(10),$lines).
			"</UL>";

		$out = $this->editIcons($out,"tt_content:bodytext","Edit bulletlist");
		return $out;
	}
	function render_table()	{
		$content = trim($this->cObj->data["bodytext"]);	// Get bodytext field content
		if (!strcmp($content,""))	return "";
		
		$rows = t3lib_div::trimExplode(chr(10),$content);	// Split into single lines (will become table-rows)
		
			// Find number of columns to render:
		$cols = t3lib_div::intInRange($this->cObj->data["cols"]?$this->cObj->data["cols"]:count(explode("|",current($rows))),0,100);

			// Traverse rows (rendering the table here)
		reset($rows);
		while(list($k,$v)=each($rows))	{
			$cells = explode("|",$v);
			$newCells=array();
			for($a=0;$a<$cols;$a++)	{
				$newCells[$a] = '<td><P>'.$cells[$a].'</P></td>';
			}
			$rows[$k]='<tr>'.implode("",$newCells).'</tr>';
		}
		$out = '<table class="contenttable">'.
			implode(chr(10),$rows).
			"</table>";

		$out = $this->editIcons($out,"tt_content:cols,bodytext","Edit table");
		return $out;
	}
	function editIcons($content,$fields,$title)	{
		if ($GLOBALS["TSFE"]->beUserLogin){
			$conf=array(
				"beforeLastTag"=>1,
				"iconTitle" => $title
			);
			$content=$this->cObj->editIcons($content,$fields,$conf);
		}	
		return $content;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/css_styled_content/pi1/class.tx_cssstyledcontent_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/css_styled_content/pi1/class.tx_cssstyledcontent_pi1.php"]);
}

?>