<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2001-2002 Christian Jul Jensen (christian@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Typo3 Extension Repository
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_extrep extends tslib_pibase {
	var $cObj;	
	var $piData = array();
	var $currentCMD="";
	var $dbPageId=0;
	var $byPassMemberOK=0;
	var $ext_feUserSelection=array();
	
	var $varPrefix = "tx_extrep";
	var $categories = Array(
		"be" => "Backend",
		"module" => "Backend Modules",
		"fe" => "Frontend",
		"plugin" => "Frontend Plugins",
		"misc" => "Miscellaneous",
		"example" => "Examples",
		"doc" => "Documentation",
	);
	var $states = Array (
		"stable" => "Stable",
		"beta" => "Beta",
		"alpha" => "Alpha",
		"experimental" => "Experimental",
#		"empty" => "Empty",
#		"blank_framework" => "Blank Framework",
		"test" => "Test",
	);


 	var $maxStoreSize=102400;

	/**
	 * Main function
	 */	
	function main($content,$conf)	{
		$this->getPIdata();
		
		$this->dbPageId = intval($this->cObj->data["pages"]);
		if ($this->dbPageId<=0)	{
			$content='<p>You must add a reference to a page (called "Starting point") in the "Insert Plugin" content element. That page should be where Frontend Users and all repository records are stored.</p>';
		} else {

				// There four situations returns compiled content back to the EM.
				// So the request is expected to come from the EM inside Typo3.
			if (is_array($this->piData["upload"]))	{
				$content.=$this->handleUpload();
			} elseif ($this->piData["cmd"]=="currentListing")	{
				$content = $this->currentListing($this->piData["debug"]);
			} elseif ($this->piData["cmd"]=="importExtension")	{
				$content = $this->importExtension($this->piData["uid"]);
			} elseif ($this->piData["cmd"]=="extensionInfo")	{
				$content = $this->extensionInfo($this->piData["uid"]);
			} else {
#				$content.="Temporarily closed down...";
/*
					$content.='<a href="'.$this->pi_getPageLink($GLOBALS["TSFE"]->id,"",array(
						$this->varPrefix."[cmd]"=>"currentListing",
						$this->varPrefix."[debug]"=>"1"
					)).'">Get extensions listing </a>';
	*/		}
		}
		return $content;
	}

	/**
	 * Initializes pi_data
	 */	
	function getPIdata() {
		$this->piData = t3lib_div::GPvar($this->varPrefix,1);
	}

	/**
	 * Makes insert statement to database based on table and field_values array.
	 */	
	function DBcompileInsert($table,$fields_values,$slash=1)	{
		if (is_array($fields_values))	{
			if ($slash)	{$fields_values = t3lib_div::slashArray($fields_values, "add");}
			$query = "INSERT INTO ".$table." (".implode(array_keys($fields_values),",").") VALUES ('".implode($fields_values,"','")."')";
			return $query;
		}
	}

	/**
	 * Based on a x.x.x version number this is converted to some formats returned in an array.
	 */	
	function renderVersion($v,$raise="")	{
		$parts = t3lib_div::intExplode(".",$v."..");
		$parts[0] = t3lib_div::intInRange($parts[0],0,999);
		$parts[1] = t3lib_div::intInRange($parts[1],0,999);
		$parts[2] = t3lib_div::intInRange($parts[2],0,999);
		switch((string)$raise)	{
			case "main":
				$parts[0]++;
				$parts[1]=0;
				$parts[2]=0;
			break;
			case "sub":
				$parts[1]++;
				$parts[2]=0;
			break;
			case "dev":
				$parts[2]++;
			break;
		}
		$res=array();
		$res["version"]=$parts[0].".".$parts[1].".".$parts[2];
		$res["version_int"]=intval(str_pad($parts[0],3,"0",STR_PAD_LEFT).str_pad($parts[1],3,"0",STR_PAD_LEFT).str_pad($parts[2],3,"0",STR_PAD_LEFT));
		$res["version_main"]=$parts[0];
		$res["version_sub"]=$parts[1];
		$res["version_dev"]=$parts[2];
		return $res;
	}

	/**
	 * Based on $extKey this returns the extension-key record.
	 */	
	function getExtKeyRecord($extKey)	{
		$q="SELECT * FROM tx_extrep_keytable WHERE extension_key='".addslashes($extKey)."' 
				AND pid=".intval($this->dbPageId).
				$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_keytable");
		$res = mysql(TYPO3_db,$q);
		if ($row=mysql_fetch_assoc($res))	{
			return $row;
		}
	}

	/**
	 * Returns most recent repository version record based on extKeyUid
	 */	
	function getLatestRepVersion($extKeyUid)	{
		$q="SELECT * FROM tx_extrep_repository WHERE extension_uid=".intval($extKeyUid)."
				AND pid=".intval($this->dbPageId).
				$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_repository").
				" ORDER BY version_int DESC LIMIT 1";
		$res = mysql(TYPO3_db,$q);
		if ($row=mysql_fetch_assoc($res))	{
			return $row;
		}
	}

	/**
	 * Returns a field from the fe_user record.
	 */	
	function userField($field)		{
		return $GLOBALS["TSFE"]->fe_user->user[$field];
	}













	// *********************************************************
	// 
	// 	Main functions for interaction with the EM in Typo3.
	//  These functions are called from the class tx_extrep
	// 
	// *********************************************************

	

	/**
	 * Returns compiled information to the EM about an extension.
	 */	
	function extensionInfo($uid)	{
		$currentUser = $this->validateUploadUser();

		$pKey=$this->piData["pKey"];
		$pPass=$this->piData["pPass"];
	
		$addQ="";
		$addQ.=" AND tx_extrep_repository.uid=".intval($uid);
		$addQ.=$this->checkPrivate_key_password($pKey,$pPass);
		$q=$this->getRepList("tx_extrep_repository.*",$addQ,"");

		$outArr=array();
		$res = mysql(TYPO3_db,$q);
		echo mysql_error();
		if ($outArr=mysql_fetch_assoc($res))	{
			$access = $this->checkUserAccessToExtension($this->getKeyTableRecord($outArr["extension_uid"]),$currentUser);
			if ($access)	{
				unset($outArr["datablob"]);
	
				$addQ="";
				$addQ.=" AND tx_extrep_keytable.extension_key='".$outArr["extension_key"]."'";
				$addQ.=" AND tx_extrep_repository.emconf_private=0";
				$q=$this->getRepList($this->prependFieldsWithTable("tx_extrep_repository","
					uid,extension_key,tstamp,icondata,version,version_int,datasize,datasize_gz,emconf_description,emconf_title,emconf_category,emconf_dependencies,emconf_state,emconf_modify_tables,emconf_author,emconf_author_company,upload_typo3_version,upload_php_version,emconf_internal,emconf_uploadfolder,emconf_createDirs,emconf_private,emconf_download_password,emconf_shy,emconf_lockType
				"),$addQ," ORDER BY tstamp DESC");
		
				$outArr["_other_versions"]=array();
				$res = mysql(TYPO3_db,$q);
				echo mysql_error();
				while ($outArr2=mysql_fetch_assoc($res))	{
					$outArr["_other_versions"][]=$outArr2;
				}
#				$outArr["_MESSAGES"][]="Request successful!";
#				$outArr["_MESSAGES"][]="Access-type: ".$access;
#				$outArr["_MESSAGES"][]=$q;

				$outArr["_STAT_INFO"]=$this->getStatThisExtRep("info",$outArr);
				$outArr["_STAT_IMPORT"]=$this->getStatThisExtRep("import",$outArr);
				$outArr["_ICON"]=$this->getIconTag($outArr["icondata"]);
				$this->insertLog($outArr,"info");
			} else {
				$outArr=array();
				$outArr["_MESSAGES"][]="Extension is members-only and access was denied.";
				$this->insertLog(array("uid"=>$uid),"info",2);
			}
		} else {
			$outArr["_MESSAGES"][]="Repository Uid '".$uid."' was not found!";
			$this->insertLog(array("uid"=>$uid),"info",1);

		}		
#$outArr["_MESSAGES"][]=$this->piData;
#$outArr["_MESSAGES"][]=$q;

		$this->outputSerializedData($outArr);
	}

	/**
	 * Returns a specific version of an extension (in compiled format) to the EM
	 */	
	function importExtension($uid)	{
		$currentUser = $this->validateUploadUser();

		$pKey=$this->piData["pKey"];
		$pPass=$this->piData["pPass"];
		$transl=$this->piData["transl"];
		$incManual=$this->piData["inc_manual"];

		$addQ="";
		$addQ.=" AND tx_extrep_repository.uid=".intval($uid);
		$addQ.=$this->checkPrivate_key_password($pKey,$pPass);
		$q=$this->getRepList("tx_extrep_repository.*",$addQ,$orderGroup);

		$outArr=array();
		$res = mysql(TYPO3_db,$q);
		echo mysql_error();
		if ($row=mysql_fetch_assoc($res))	{
			$kTableRec=$this->getKeyTableRecord($row["extension_uid"]);
			$access = $this->checkUserAccessToExtension($kTableRec,$currentUser);
			if ($access)	{
					// Add most recent translation?
				if ($transl)	{
					$outArr["_MESSAGES"][]="Most recent translation was added.";
					$row = $this->makeTranslationStatus(0,$row,"",1);	// Don't need sending of ext-keytable uid IF $row is FULL!
				}

				$outArr["extKey"]=$row["extension_key"];
				$outArr["EM_CONF"]=$this->getEMCONFarrayForDownload($row);
				$outArr["FILES"]=unserialize(gzuncompress($row["datablob"]));

					// Include SXW manual?
				if ($incManual)	{
					$outArr["_MESSAGES"][]="Requesting manual send...";
					if (isset($outArr["FILES"]["doc/manual.sxw"]))	{
						$outArr["_MESSAGES"][]="doc/manual.sxw included.";
					} else $outArr["_MESSAGES"][]="No manual found.";
				} else unset($outArr["FILES"]["doc/manual.sxw"]);
				
				$outArr["_MESSAGES"][]="Request successfull!";
				$outArr["_MESSAGES"][]="Access-type: ".$access;

				$this->insertLog($row,"import");
				$this->updateDownloadCounters("tx_extrep_repository",$row["uid"],$row["download_counter"]);
				$this->updateDownloadCounters("tx_extrep_keytable",$kTableRec["uid"],$kTableRec["download_counter"]);
			} else {
				$outArr=array();
				$outArr["_MESSAGES"][]="Extension is members-only and access was denied.";
				$this->insertLog(array("uid"=>$uid),"import",2);
			}
		} else {
			$outArr["_MESSAGES"][]="Repository Uid '".$uid."' was not found!";
			$this->insertLog(array("uid"=>$uid),"import",1);
		}
		
#$outArr["_MESSAGES"][]=$this->piData;
#$outArr["_MESSAGES"][]=$q;

		$this->outputSerializedData($outArr);
	}

	/**
	 * Returns compiled list of extensions to the EM (or TER if $internal flag is set)
	 */	
	function currentListing($debug=0,$internal=0,$listMode=0,$q="",$addWhere="",$addFields="")	{
		$currentUser = $this->validateUploadUser();
		$mode = $internal ? $listMode : $this->piData["listmode"];
		
		$q=$q?$q:"SELECT uid,members_only,owner_fe_user,download_counter,tx_extrepmgm_flags".$addFields." FROM tx_extrep_keytable WHERE 
						pid=".intval($this->dbPageId).
					$addWhere.
					$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_keytable").
					" GROUP BY extension_key ORDER BY title";

		$outArr=array();
$p1=t3lib_div::milliseconds();
		$res = mysql(TYPO3_db,$q);
if ($debug)	debug(array("QUERY"=>$q,"TIME"=>t3lib_div::milliseconds()-$p1));

		echo mysql_error();
$p1=t3lib_div::milliseconds();
		while ($row=mysql_fetch_assoc($res))	{
			$access = $this->checkUserAccessToExtension($row,$currentUser);
			if ($access=="all" && $mode==1)	$access="";
			
			
				// If visible only for members/owners:
			$memberOK=1;
			if ($row["tx_extrepmgm_flags"]&1)	{
				$memberOK = $this->isUserMemberOrOwnerOfExtension($currentUser,$row);
			}
			if ($access && ($memberOK||$this->byPassMemberOK))	{
				$q2="SELECT uid,extension_key,icondata,extension_uid,tstamp,version,version_int,codelines,codebytes,datasize,datasize_gz,emconf_description,emconf_title,emconf_category,emconf_dependencies,emconf_state,emconf_modify_tables,emconf_author,emconf_author_company,upload_typo3_version,upload_php_version,emconf_internal,emconf_uploadfolder,emconf_createDirs,emconf_private,emconf_download_password,emconf_shy,emconf_module,emconf_priority,emconf_clearCacheOnLoad,emconf_lockType,download_counter,tx_extrepmgm_appr_fe_user,tx_extrepmgm_appr_status,crdate,is_manual_included
					FROM tx_extrep_repository 
					WHERE extension_uid=".intval($row["uid"]).
					" AND pid=".intval($this->dbPageId).
					" AND emconf_private=0".
					$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_repository")." ORDER BY version_int DESC LIMIT 1";

					
					
#$p2=t3lib_div::milliseconds();
				$res2 = mysql(TYPO3_db,$q2);
#debug(t3lib_div::milliseconds()-$p2);
				
				if ($row2=mysql_fetch_assoc($res2))	{
					$iC = $this->getIconTag($row2["icondata"]);
#					unset($row2["emconf_description"]);
					unset($row2["icondata"]);
					$outArr[]=array_merge($row2,array(				// Candidate for t3lib_div::array_merge() if integer-keys will some day make trouble...
// The stat takes quite some time to render!
#						"_STAT_IMPORT"=>$this->getStatThisExtRep("import",$row2),
						"_STAT_IMPORT"=>array(
							"extension_thisversion"=>$row2["download_counter"],
							"extension_allversions"=>$row["download_counter"],
						),
						"_MEMBERS_ONLY"=>$row["members_only"],
						"_ACCESS"=>$access,
						"_ICON"=>$iC,
						"_EXTKEY_ROW" => $internal?$row:""
					));
				}
			}
		}
if ($debug)	debug(array("Traverse-TIME"=>t3lib_div::milliseconds()-$p1));

$p1=t3lib_div::milliseconds();
		if (!$internal)	$this->insertLog(array(),"listing");
if ($debug)	debug(array("Log-TIME"=>t3lib_div::milliseconds()-$p1));
		
		if ($debug)	{	
			
			debug(strlen(serialize($outArr)));
			debug($outArr);
		} elseif ($internal) {
			return $outArr;
		} else {
			$this->outputSerializedData($outArr);
		}
	}

	/**
	 * Handles an upload of an extension
	 */	
	function handleUpload()	{
//		$q = $this->cObj->DBgetInsert("tx_extrep_repository", $this->dbPageId, $dataArr, implode(",",array_keys($dataArr)), 1);
//debug($this->piData);

		if (md5($this->piData["upload"]["data"])==$this->piData["upload"]["data_md5"])	{
			$decodedData = $this->decodeExchangeData(base64_decode($this->piData["upload"]["data"]));
#debug($decodedData);
			$uploadUser = $this->validateUploadUser();
			if (is_array($uploadUser))	{
				$extKeyRec = $this->getExtKeyRecord($decodedData["extKey"]);
				if (is_array($extKeyRec))	{
					if ($extKeyRec["upload_password"])	{
						if ($this->isUserMemberOrOwnerOfExtension($uploadUser, $extKeyRec))	{
							if (!strcmp($extKeyRec["upload_password"], $this->piData["upload"]["upload_p"]))	{
								$dataArr = $this->renderVersion($decodedData["EM_CONF"]["version"]);
		
								$latestVersionRec = $this->getLatestRepVersion($extKeyRec["uid"]);
								$newVersionBase = $latestVersionRec["version"];
								switch((string)$this->piData["upload"]["mode"])	{
									case "new_dev":
										$cmd="dev";
									break;
									case "new_sub":
										$cmd="sub";
									break;
									case "new_main":
										$cmd="main";
									break;
									case "latest":
									default:
										$cmd="";
										$newVersionBase=$decodedData["EM_CONF"]["version"];
									break;
								}
								$dataArr = $this->renderVersion($newVersionBase,$cmd);
	
									// If "latest" was sent and this current version IS captured for review, then the version number is forcibly incremented.
								$existRec = $this->isThisVersionInRep($dataArr["version_int"],$extKeyRec["uid"]);
								if ((string)$cmd=="" && is_array($existRec) && $existRec["tx_extrepmgm_appr_fe_user"])	{
									$cmd="dev";
									$dataArr = $this->renderVersion($newVersionBase,$cmd);
									$existRec = $this->isThisVersionInRep($dataArr["version_int"],$extKeyRec["uid"]);
								}
								
								if (!is_array($existRec)  || (string)$this->piData["upload"]["mode"]=="latest")	{
									$dataArr["backend_title"]=$decodedData["extKey"].", ".$dataArr["version"];
	
									$dataArr["extension_key"]=$decodedData["extKey"];
									$dataArr["extension_uid"]=$extKeyRec["uid"];
									$dataArr["last_upload_by_user"]=$uploadUser["uid"];
									$dataArr["upload_comment"]=$this->piData["upload"]["comment"];
									$dataArr["last_upload_referer"]=t3lib_div::getIndpEnv("HTTP_REFERER");
									$dataArr["last_upload_returnUrl"]=$this->piData["upload"]["returnUrl"];
									$dataArr["last_upload_date"]=time();
		
									$dataArr["upload_typo3_version"]=$this->piData["upload"]["typo3ver"];
									$dataArr["upload_php_version"]=$this->piData["upload"]["phpver"];
									$dataArr["upload_os"]=$this->piData["upload"]["os"];
									$dataArr["upload_sapi"]=$this->piData["upload"]["sapi"];
									$dataArr["upload_ext_version"]=$decodedData["EM_CONF"]["version"];
									
									$dataArr["codelines"]=$decodedData["misc"]["codelines"];
									$dataArr["codebytes"]=$decodedData["misc"]["codebytes"];
	
									$dataArr["techinfo"]=serialize($decodedData["techInfo"]);
									$dataArr["icondata"]=is_array($decodedData["FILES"]["ext_icon.png"]) ? 
										$dataArr["icondata"]=serialize($decodedData["FILES"]["ext_icon.png"]) :
										(is_array($decodedData["FILES"]["ext_icon.gif"])?serialize($decodedData["FILES"]["ext_icon.gif"]):"");
									
									$fieldList=explode(",","title,description,category,shy,dependencies,conflicts,priority,module,state,internal,modify_tables,clearCacheOnLoad,author,author_email,author_company,lockType,uploadfolder,createDirs");
									while(list(,$fN)=each($fieldList))	{
										$dataArr["emconf_".$fN] = trim($decodedData["EM_CONF"][$fN]);
									}
									
										// In these cases where $dataArr["xxxxx"] is supposed to hold the value of the incoming data, notice that THIS value is set in the loop above!
										// Thus any added fields here should probably ALSO be added in the $fieldList above!
									$dataArr["emconf_shy"] = $dataArr["emconf_shy"]?1:0;
									$dataArr["emconf_clearCacheOnLoad"] = $dataArr["emconf_clearCacheOnLoad"]?1:0;
									$dataArr["emconf_lockType"] = substr($dataArr["emconf_lockType"],0,1);
									$dataArr["emconf_internal"] = $dataArr["emconf_internal"]?1:0;
									$dataArr["emconf_uploadfolder"] = $dataArr["emconf_uploadfolder"]?1:0;
									$dataArr["emconf_private"] = $this->piData["upload"]["private"]?1:0;
									if ($dataArr["emconf_private"])	{
										$dataArr["emconf_download_password"] = trim($this->piData["upload"]["download_password"]);
										$dataArr["private_key"] = substr(md5(uniqid(rand(),1)),0,4);
									}
		
									$dataArr["emconf_createDirs"] = implode(",",t3lib_div::trimExplode(",",$dataArr["emconf_createDirs"],1));
									$dataArr["emconf_dependencies"] = implode(",",t3lib_div::trimExplode(",",$dataArr["emconf_dependencies"],1));
									$dataArr["emconf_modify_tables"] = implode(",",t3lib_div::trimExplode(",",$dataArr["emconf_modify_tables"],1));
									$dataArr["emconf_conflicts"] = implode(",",t3lib_div::trimExplode(",",$dataArr["emconf_conflicts"],1));
									$dataArr["emconf_module"] = $dataArr["emconf_module"];
	#debug($decodedData);
	#debug($dataArr);
									if (!t3lib_div::inList(implode(",",array_keys($this->categories)),$dataArr["emconf_category"]))	$dataArr["emconf_category"]="";
									if (!t3lib_div::inList(implode(",",array_keys($this->states)),$dataArr["emconf_state"]))	$dataArr["emconf_state"]="";
									if (!t3lib_div::inList("top,bottom",$dataArr["emconf_priority"]))	$dataArr["emconf_priority"]="";
		
									if (is_array($decodedData["FILES"]))	{
										reset($decodedData["FILES"]);
										$filesA=array();
										while(list($k,$d)=each($decodedData["FILES"]))	{
											$d["filename"]=$k;
											if ($d["filename"]=="doc/manual.sxw")	{
												$dataArr["is_manual_included"]=hexdec(substr(md5($d["content_md5"]),0,7));
											}

											unset($d["content"]);
											unset($d["LOCAL_LANG"]);
											unset($d["LOCAL_LANG-conf.php"]);
											
											$filesA[$k]=$d;
#											debug($d);
										}
										$dataArr["files"] = serialize($filesA);
										$rawDat = serialize($decodedData["FILES"]);
										$dataArr["datablob_md5"] = md5($rawDat);
										$dataArr["datasize"] = strlen($rawDat);
										$dataArr["datablob"] = gzcompress($rawDat);
										$dataArr["datasize_gz"] = strlen($dataArr["datablob"]);
									}
									
	 								$maxSize = $extKeyRec["maxStoreSize"]>0 ? $extKeyRec["maxStoreSize"] : 
													($uploadUser["tx_extrepmgm_maxbytes"]>0 ? $uploadUser["tx_extrepmgm_maxbytes"] : $this->maxStoreSize);
									
	 								if ($dataArr["datasize_gz"]<$maxSize)	{
										if (!is_array($existRec))	{
											$dataArr["upload_counter"]=1;
											$q = $this->cObj->DBgetInsert("tx_extrep_repository", $this->dbPageId, $dataArr, implode(",",array_keys($dataArr)), 1);
											$res = mysql(TYPO3_db,$q);
											$content.="The extension '".$decodedData["EM_CONF"]["title"]."' (".$dataArr["extension_key"].") was <strong>inserted</strong> into repository.<br><br>
											The version number is updated to <strong>".$dataArr["version"]."</strong><br>";
											if ($dataArr["emconf_private"]) {
												$content.= "<BR>
												Private import key is: <strong>".mysql_insert_id().($dataArr["private_key"]?"-".$dataArr["private_key"]:"")."</strong><br>
												";
											}
											$recordUID = mysql_insert_id();
										} else {
											$dataArr["upload_counter"]=$existRec["upload_counter"]+1;
											$q = $this->cObj->DBgetUpdate("tx_extrep_repository", $existRec["uid"], $dataArr, implode(",",array_keys($dataArr)), 1);
											$res = mysql(TYPO3_db,$q);
											$content.="The extension '".$decodedData["EM_CONF"]["title"]."' (".$dataArr["extension_key"]."), 
															version <strong>".$dataArr["version"]."</strong> was <strong>updated</strong> in repository.<br>
											";
											if ($dataArr["emconf_private"]) {
												$content.= "<BR>
												Private import key is: <strong>".$existRec["uid"].($dataArr["private_key"]?"-".$dataArr["private_key"]:"")."</strong><br>
												";
											}
											$recordUID = $existRec["uid"];
										}
											// Update extension key cache:
										$this->updateExtKeyCache($extKeyRec["uid"]);
	
											// Print info content:
										$content.= "
		<br>
											Please finish the upload process by pressing this button to return to your servers Extensions Manager and update the configuration.
		<br>
		<br>
										";
										
										$backEM_CONF = $this->getEMCONFarrayForDownload($dataArr);
										$content.='<form action="'.$this->piData["upload"]["returnUrl"].'" method="POST">
										<input type="hidden" name="TER_CMD[returnValue]" value="'.htmlspecialchars($this->compileOutputData($backEM_CONF)).'">
										<input type="hidden" name="TER_CMD[extKey]" value="'.htmlspecialchars($dataArr["extension_key"]).'">
										<input type="hidden" name="TER_CMD[cmd]" value="EM_CONF">
										<input type="submit" name="TER_CMD[update]" value="Syncronize EM">
										</form>
										';
	//									$content.='<a href="'.$this->piData["upload"]["returnUrl"].'">Go back to your Extension Manager</a><BR>';
										return $content;
									} else return  $this->pError("The content to be stored had a compressed size of ".t3lib_div::formatSize($dataArr["datasize_gz"])." and thereby exceeded ".t3lib_div::formatSize($maxSize)." which is the limit for this extension!");
								} else return  $this->pError("This version '".$dataArr["version"]."' existed in the repository already!");
							} else return  $this->pError("The upload password of the extension did not match your password!");
						} else  return  $this->pError("You are not a member or owner of this extension!");
					} else return  $this->pError("The Extension had no upload password assigned to it, so you cannot upload!");
				} else return  $this->pError("No extension by that key (".$decodedData["extKey"].") was found!");
			} else return $this->pError($uploadUser);
		} else return $this->pError("The MD5 hash submitted did not match the MD5 hash of the data content!");
	}



	


	// *********************************************************
	// 
	// 	Smaller helper functions for the EM interaction
	// 
	// *********************************************************




	/**
	 * Having a comma list of fields ($fieldList) this is prepended with the $table."." name
	 */	
	function prependFieldsWithTable($table,$fieldList)	{
		$list=t3lib_div::trimExplode(",",$fieldList,1);
		$return=array();
		while(list(,$listItem)=each($list))	{
			$return[]=$table.".".$listItem;
		}
		return implode(",",$return);
	}

	/**
	 * Inserts the $newRepEntry record in the extension repository. The fields in that array must be available in the repository table.
	 * Some fields are unset before this update happens.
	 */	
	function insertRepositoryVersion($newRepEntry,$verMode="new_dev")	{
	
			// Finding new version number
		$latestVersionRec = $this->getLatestRepVersion($newRepEntry["extension_uid"]);
		$newVersionBase = $latestVersionRec["version"];
		switch($verMode)	{
			case "new_dev":
				$cmd="dev";
			break;
			case "new_sub":
				$cmd="sub";
			break;
			case "new_main":
				$cmd="main";
			break;
			case "latest":
			default:
				$cmd="";
			break;
		}
		$dataArr = $this->renderVersion($newVersionBase,$cmd);
		$newRepEntry = array_merge($newRepEntry,$dataArr);

			// Setting upload user to -1 because this is made by repository.
		$newRepEntry["last_upload_by_user"]=-1;
		$newRepEntry["last_upload_date"]=time();

			// Make query:
		$fieldList="
  pid,
  extension_key ,
  extension_uid ,
  last_upload_by_user,
  emconf_download_password,
  emconf_private,
  private_key,
  version,
  version_int,
  version_main,
  version_sub,
  version_dev,
  last_upload_date,
  datablob,
  datablob_md5,
  datasize,
  datasize_gz,
  files,
  icondata,
  codelines,
  codebytes,
  upload_ext_version,
  emconf_title,
  emconf_description,
  emconf_category,
  emconf_shy,
  emconf_dependencies,
  emconf_createDirs,
  emconf_conflicts,
  emconf_priority,
  emconf_module,
  emconf_state,
  emconf_internal,
  emconf_uploadfolder,
  emconf_modify_tables,
  emconf_clearCacheOnLoad,
  emconf_lockType,
  emconf_author,
  emconf_author_email,
  emconf_author_company,
  upload_typo3_version,
  upload_php_version,
  upload_os,
  upload_sapi,
  backend_title,
  tx_extrepmgm_appr_status,
  tx_extrepmgm_appr_comment,
  tx_extrepmgm_appr_fe_user,
  is_manual_included
		";

		$query=$this->cObj->DBgetInsert("tx_extrep_repository", $newRepEntry["pid"], $newRepEntry, $fieldList, 1);
		$res=mysql(TYPO3_db,$query);
		echo mysql_error();
	}

	/**
	 * Returns a part of WHERE query selecting only non-private extensions or private extensions with the correct password set.
	 */	
	function checkPrivate_key_password($key,$pass)	{
		return " AND 
		( tx_extrep_repository.emconf_private=0 OR 
			(tx_extrep_repository.private_key='".addslashes($key)."' AND 
				(tx_extrep_repository.emconf_download_password='' OR tx_extrep_repository.emconf_download_password='".addslashes($pass)."')
			)
		)";	
	}

	/**
	 * Returns the image tag for an icon of an extension. Input is a serialized array with information about the icon file.
	 * Writes the icon to the temp-folder on the server.
	 */	
	function getIconTag($serDat)	{
		$iDat = unserialize($serDat);
		if ($iDat)	{
			$fI=pathinfo($iDat["name"]);
			if (t3lib_div::inList("gif,png,jpeg,jpg",strtolower($fI["extension"])))	{
				$tempFileName=PATH_site."typo3temp/tx_extrep_".t3lib_div::shortMd5($serDat).".".$fI["extension"];
				if (!@is_file($tempFileName))	{
					t3lib_div::writeFile($tempFileName,$iDat["content"]);
				}
				$imgInfo=getimagesize($tempFileName);
				$tag ='<img src="'.t3lib_div::getIndpEnv("TYPO3_REQUEST_DIR").substr($tempFileName,strlen(PATH_site)).'" '.$imgInfo[3].'>';
				return $tag;
			}
		}
	}

	/**
	 * Takes a repository record as input and returns the proper emconf-array
	 */	
	function getEMCONFarrayForDownload($row)	{
		return array(
				"title" => $row["emconf_title"],
				"description" => $row["emconf_description"],
				"category" => $row["emconf_category"],
				"shy" => $row["emconf_shy"],
				"dependencies" => $row["emconf_dependencies"],
				"conflicts" => $row["emconf_conflicts"],
				"priority" => $row["emconf_priority"],
				"module" => $row["emconf_module"],
				"state" => $row["emconf_state"],
				"internal" => $row["emconf_internal"],
				"uploadfolder" => $row["emconf_uploadfolder"],
				"createDirs" => $row["emconf_createDirs"],
				"modify_tables" => $row["emconf_modify_tables"],
				"clearCacheOnLoad" => $row["emconf_clearCacheOnLoad"],
				"lockType" => $row["emconf_lockType"],
				"author" => $row["emconf_author"],
				"author_email" => $row["emconf_author_email"],
				"author_company" => $row["emconf_author_company"],
				"private" => $row["emconf_private"],
				"download_password" => $row["emconf_download_password"],
				"version" => $row["version"],
			);	
	}

	/**
	 * Inserts a stat-entry in the log
	 */	
	function insertLog($row,$reqMode,$error=0)	{
		$pU=parse_url($this->piData["returnUrl"]);
		$dataArr = Array(
			"extension_uid" => $row["extension_uid"],
			"extension_rep_uid" => $row["uid"],
			"download_referer" => $this->piData["returnUrl"],
			"download_path_hash" => md5($pU["host"].$pU["path"]),
			"download_host" => t3lib_div::getIndpEnv("REMOTE_HOST"),
			"download_addr" => t3lib_div::getIndpEnv("REMOTE_ADDR"),
			"download_server_t3id" => $this->piData["T3instID"],
			"tstamp" => time(),
			"requestMode" => $reqMode,
			"error" => $error
		);
		
		$q = $this->DBcompileInsert("tx_extrep_downloadstat",$dataArr,1);
		$res = mysql(TYPO3_db,$q);
	}

	/**
	 * Updates the download counters in key and repository tables.
	 */	
	function updateDownloadCounters($table,$uid,$count)	{
		$update = "UPDATE ".$table." SET download_counter=".(intval($count)+1)." WHERE uid=".intval($uid);
		$res = mysql(TYPO3_db,$update);
		return $update;
	}

	/**
	 * Input is a extension-key record and the currentUser record. Access type is returned as a string "all", "owner", "member" or "" (if no access)
	 */	
	function checkUserAccessToExtension($row,$currentUser)	{
		if (!$row["members_only"])	{
			return in_array($row["uid"],$this->ext_feUserSelection) ? "selected" : "all";
		} elseif(is_array($currentUser) && $currentUser["uid"]) {
			if (!strcmp($row["owner_fe_user"],$currentUser["uid"]))	{
				return "owner";
			} elseif (intval($currentUser["uid"]) && intval($row["uid"])) {
				$q="SELECT uid_local FROM tx_extrep_groupmem_mm WHERE uid_local=".intval($row["uid"])." AND uid_foreign=".intval($currentUser["uid"]);
				$res = mysql(TYPO3_db,$q);
				if (mysql_num_rows($res))	return "member";
			}
		}
	}

	/**
	 * Validates if a user-record is member or owner of an extension:
	 */	
	function isUserMemberOrOwnerOfExtension($currentUser,$extKeyRow)	{
		if ($currentUser["uid"] && !strcmp($currentUser["uid"],$extKeyRow["owner_fe_user"]))	{
			return "owner";
		} else {
			$query="SELECT uid_local FROM tx_extrep_groupmem_mm WHERE uid_local=".intval($extKeyRow["uid"])." AND uid_foreign=".intval($currentUser["uid"]);
			$res = mysql(TYPO3_db,$query);
			if (mysql_num_rows($res))	{
				return "member";
			}
		}
	}

	/**
	 * Returns statistic information for a certain extRepository row / extension-key.
	 */	
	function getStatThisExtRep($mode,$extRepRow)	{
		$stat=array();
			// extension rep
		$mainq="SELECT count(*)
			FROM tx_extrep_downloadstat
			WHERE requestMode='".$mode."'";


		$q=$mainq." AND extension_uid =".intval($extRepRow["extension_uid"]);
		$res = mysql(TYPO3_db,$q);
		$row = mysql_fetch_row($res);
		$stat["extension_allversions"] = $row[0];

		$res = mysql(TYPO3_db,$q." GROUP BY download_path_hash");
		$stat["extension_allversions_group_path_hash"] = mysql_num_rows($res);

		
		$q=$mainq." AND extension_rep_uid =".intval($extRepRow["uid"]);
		$res = mysql(TYPO3_db,$q);
		$row = mysql_fetch_row($res);
		$stat["extension_thisversion"] = $row[0];
		
		$res = mysql(TYPO3_db,$q." GROUP BY download_path_hash");
		$stat["extension_thisversion_group_path_hash"] = mysql_num_rows($res);

		return $stat;
	}

	/**
	 * Takes in an array and outputs it in the compiled format readable by the Extension Manager. Then exits.
	 */	
	function outputSerializedData($outArr)	{
		if ($this->piData["dlFileName"])	{
			$mimeType = "application/octet-stream";
			Header("Content-Type: ".$mimeType);
			Header("Content-Disposition: attachment; filename=".$this->piData["dlFileName"]);

				// COmpile content
			$serialized = serialize($outArr);
			$md5 = md5($serialized);

			$content=$md5.":";
			$content.=":";
			$content.=$serialized;

			echo $content;
			exit;
		} else {
			$mimeType = "application/octet-stream";
			Header("Content-Disposition: attachment; filename=T3X_".t3lib_div::shortMD5(time()).".t3x");
			Header("Content-Type: ".$mimeType);
			echo $this->compileOutputData($outArr);
			exit;
		}
	}

	/**
	 * This compiles the $outArr into a string, compression is applied if piVar[gzcompress] was set.
	 */	
	function compileOutputData($outArr)	{
		$outDat = serialize($outArr);
		if ($this->piData["gzcompress"])	$outDat = gzcompress($outDat);
		return md5($outDat).":".($this->piData["gzcompress"]?"gzcompress":"").":".base64_encode($outDat).":";
	}

	/**
	 * Returns SELECT statement for selecting extensions/repository entries
	 */	
	function getRepList($selList,$addQ,$orderGroup)	{
		$q="SELECT ".$selList." FROM tx_extrep_repository,tx_extrep_keytable WHERE tx_extrep_keytable.uid=tx_extrep_repository.extension_uid".
			" AND tx_extrep_keytable.pid=".$this->dbPageId.
			" AND tx_extrep_repository.pid=".$this->dbPageId.
			$addQ.
			$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_keytable").
			$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_repository").$orderGroup;
		return $q;
	}

	/**
	 * Returns an array from the compiled input $str
	 */	
	function decodeExchangeData($str)	{
		$parts = explode(":",$str,3);
		if ($parts[1]=="gzcompress")	{
			$parts[2] = gzuncompress($parts[2]);
		}
		if (md5($parts[2]) == $parts[0])	{
			return unserialize($parts[2]);
		}
	}

	/**
	 * Returns a record from the key table.
	 */	
	function getKeyTableRecord($uid)	{
		$q="SELECT uid,members_only,owner_fe_user,download_counter FROM tx_extrep_keytable WHERE uid=".intval($uid).$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_keytable");
		$res = mysql(TYPO3_db,$q);
		return mysql_fetch_assoc($res);
	}

	/**
	 * Prints an error
	 */	
	function pError($str)	{
		return '<font color="red"><strong>'.$str.'</strong></font>';
	}

	/**
	 * Returns the record for a specific version of a repository record based on the $extKey
	 */	
	function isThisVersionInRep($ver,$extUid)	{
		$q="SELECT uid,upload_counter,tx_extrepmgm_appr_fe_user FROM tx_extrep_repository WHERE 
				extension_uid=".intval($extUid)." AND 
				pid=".intval($this->dbPageId)." AND 
				version_int='".$ver."' ".
				$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_repository");
		$res = mysql(TYPO3_db,$q);
		if ($row=mysql_fetch_assoc($res))	{
			return $row;
		}
	}

	/**
	 * This verifies the fe_users username/password that may possibly be sent with the request to the repository. Either the fe_user row is returned or a text-message describing the authentication error.
	 */	
	function validateUploadUser()	{
		if (trim($this->piData["user"]["fe_u"]) && trim($this->piData["user"]["fe_p"]))		{
			$q="SELECT * FROM fe_users WHERE username='".trim(addslashes($this->piData["user"]["fe_u"]))."'".$GLOBALS["TSFE"]->sys_page->enableFields("fe_users");
			$res = mysql(TYPO3_db,$q);
			if ($row=mysql_fetch_assoc($res))	{
				if (!strcmp($row["password"],trim($this->piData["user"]["fe_p"])))	{
					$feUserData = unserialize($row["tx_extrepmgm_selext"]);
					$this->ext_feUserSelection = is_array($feUserData["extSelection"]) ? array_keys($feUserData["extSelection"]) : array();
					return $row;
				} else return $content="Password was incorrect for user '".$this->piData["user"]["fe_u"]."'";
			} else return $content="User '".$this->piData["user"]["fe_u"]."' not found";
		} else return $content="No user or no password submitted";
	}

	/**
	 * This updates the cache-fields in the extension keytable 
	 */	
	function updateExtKeyCache($extKeyUid, $mostRecent_extRepEntry="")	{
		#if (!is_array($mostRecent_extRepEntry))	{
			$mostRecent_extRepEntry = $this->getLatestRepositoryEntry($extKeyUid,"download_counter,is_manual_included,tx_extrepmgm_appr_status,tx_extrepmgm_appr_comment,tx_extrepmgm_appr_fe_user,emconf_state,extension_key,datablob,datablob_md5");
#		}

		$infoArray=array();
		$updateArray=array();
		
		$infoArray["download_counter"]=$mostRecent_extRepEntry["download_counter"];
		$infoArray["is_manual_included"]=$updateArray["tx_extrepmgm_cache_oodoc"]=$mostRecent_extRepEntry["is_manual_included"];
			# HERE: More info about manuals...
		$infoArray["tx_extrepmgm_appr_status"] = $updateArray["tx_extrepmgm_cache_review"] = $mostRecent_extRepEntry["tx_extrepmgm_appr_status"];
		$infoArray["tx_extrepmgm_appr_comment"] = $mostRecent_extRepEntry["tx_extrepmgm_appr_comment"];
		$infoArray["tx_extrepmgm_appr_fe_user"] = $mostRecent_extRepEntry["tx_extrepmgm_appr_fe_user"];
		$infoArray["emconf_state"] = $updateArray["tx_extrepmgm_cache_state"] = $mostRecent_extRepEntry["emconf_state"];
		
			// If the current version is NOT reviewed try to find the previous one.
		if (!$infoArray["tx_extrepmgm_appr_fe_user"])	{
			$q2="SELECT tx_extrepmgm_appr_status,tx_extrepmgm_appr_comment,tx_extrepmgm_appr_fe_user
				FROM tx_extrep_repository 
				WHERE extension_uid=".intval($extKeyUid).
				" AND emconf_private=0".
				" AND pid=".intval($this->dbPageId).
				" AND tx_extrepmgm_appr_fe_user>0".
				$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_repository").
				" ORDER BY version_int DESC LIMIT 1";

			$res2 = mysql(TYPO3_db,$q2);
			if ($row=mysql_fetch_assoc($res2))	{
				$infoArray["tx_extrepmgm_appr_status"]=$row["tx_extrepmgm_appr_status"];
				$infoArray["tx_extrepmgm_appr_comment"]=$row["tx_extrepmgm_appr_comment"];
				$infoArray["tx_extrepmgm_appr_fe_user"]=$row["tx_extrepmgm_appr_fe_user"];
				$updateArray["tx_extrepmgm_cache_review"] = -$row["tx_extrepmgm_appr_status"];
			}
		}
		#$updateArray["tx_extrepmgm_cache_missingtrans"] - bits.
		
			// Get translation status:
		$sendCurrent_arr = !(isset($mostRecent_extRepEntry["extension_key"]) && isset($mostRecent_extRepEntry["datablob"]) && isset($mostRecent_extRepEntry["datablob_md5"]));
#echo "<HR>";
#debug($mostRecent_extRepEntry["extension_key"]);
#debug($sendCurrent_arr);
		$translateStatus = $this->makeTranslationStatus($extKeyUid, $sendCurrent_arr?$mostRecent_extRepEntry:"");
		$infoArray["translation_status"] = is_array($translateStatus) ? $translateStatus["lang"] : $translateStatus;
#debug($infoArray["translation_status"]);
		
		$updateArray["tx_extrepmgm_cache_infoarray"]=serialize($infoArray);
		

		// Perform update query:
		$queryA=array();
		reset($updateArray);
		while(list($f,$v)=each($updateArray))	{
			$queryA[]=$f."='".addslashes($v)."'";
		}
		$query="UPDATE tx_extrep_keytable SET ".implode($queryA,",")." WHERE uid=".intval($extKeyUid);
		$res = mysql(TYPO3_db,$query);
#		debug($query);
#		debug($updateArray);
#		debug($infoArray);

	}

	/**
	 * Returns the most recent extension repository record for an extension-keytable uid.
	 * Private repository entries are NOT selected.
	 */	
	function getLatestRepositoryEntry($extUid,$fieldList="*")	{
		$q2="SELECT ".$fieldList."
				FROM tx_extrep_repository 
				WHERE extension_uid=".intval($extUid).
				" AND emconf_private=0".
				" AND pid=".intval($this->dbPageId).
				$GLOBALS["TSFE"]->sys_page->enableFields("tx_extrep_repository").
				" ORDER BY version_int DESC LIMIT 1";
		$res2 = mysql(TYPO3_db,$q2);
		return mysql_fetch_assoc($res2);
	}






	// TRANSLATION FUNCTIONS:


	
	/**
	 * Generates an array with status statistics off all the labels for translation for a certain extension key uid.
	 */	
	function makeTranslationStatus($extKeyUid, $mostRecent_extRepEntry="", $langInfo="",$mergeAndReturnRepository=0)	{
		if (!t3lib_extmgm::isLoaded("extrep_mgm"))	return 'Error: No extrep_mgm extension loaded.';
		
		
		if (!is_array($mostRecent_extRepEntry))	{
			$mostRecent_extRepEntry = $this->getLatestRepositoryEntry($extKeyUid);
		}
		if (is_array($mostRecent_extRepEntry))	{
			$datStr = gzuncompress($mostRecent_extRepEntry["datablob"]);
			if (md5($datStr)==$mostRecent_extRepEntry["datablob_md5"])	{
				$dB = unserialize($datStr);
#debug($dB);
					// Finding locallang.php files + manual HTML.
				$LL=array();
				while(list($file)=each($dB))	{	
					if ($dB[$file]["LOCAL_LANG"])	{
						$LL[]=$dB[$file];
					}
				}

					// If there are any LOCAL_LANG files:
				if (count($LL))	{
					$translateStat=array();
					
						// This is information about which langauges are available and who are in charge of them
					$langInfo = is_array($langInfo) ? $langInfo : $this->getLanguagesAndTranslators();

						// Caching all already-translated labels:
					$cachedTransl=array();		// Contains new translations for assistants + chief
					$cachedTransl_chief=array();	// Contains only chiefs translation (if any)
					reset($langInfo[0]);
					while(list($lK,$lR)=each($langInfo[0]))	{
							// Getting 
						list($LLarr_comp_users,$temp,$chief_labels) = $this->getCompiledTranslations($langInfo[2][$lK],$lR["auth_translator"],$mostRecent_extRepEntry["extension_key"],$lK);
						$cachedTransl[$lK]=$LLarr_comp_users;
						$cachedTransl_chief[$lK]=$chief_labels;
					}
	
						// Traversing all files for translation:
					reset($LL);
					while(list($fIdx,$LLr)=each($LL))	{
							// Get the LOCALLANG array of the file and clean it up.
						$LLarr = unserialize($LLr["LOCAL_LANG"][1]);
						$LLarr = $this->cleanUpLLArray($LLarr,$langInfo[0]);
						$baseCount = is_array($LLarr["default"]) ? count($LLarr["default"]) : -1;	// This value is about how many labels there are to translate

						if ($baseCount>0)	{
								// For each language, traverse this file:
							reset($langInfo[0]);
							while(list($lK,$lR)=each($langInfo[0]))	{
								if (is_array($LLarr[$lR["langkey"]]))	{	// There is is an entry in the LLarr for this langauge:
									if ($mergeAndReturnRepository)	{
											// Merging all the chief labels:
										if (is_array($cachedTransl_chief[$lK][$LLr["name"]]) && (!is_array($mergeAndReturnRepository) || in_array($lK,$mergeAndReturnRepository)))	{
#debug(array("Merging:",$lK,$LLr["name"]));
											$LLarr[$lR["langkey"]] = t3lib_div::array_merge($LLarr[$lR["langkey"]],$cachedTransl_chief[$lK][$LLr["name"]]);
										}
									} else {
											// This is the number of missing translations for the current language in the current file compared to default.
										$cur_count=$baseCount-count($LLarr[$lR["langkey"]]);
											
											// The missing translations is by default equal to this:
										$missing_count=$cur_count;
										$non_chief_count=0;	//.. and there are by default no non-chief translations.
										$chief_count=0;
											
											// FInding number of missing records to translate from the chiefs perspective:
										if (is_array($cachedTransl_chief[$lK][$LLr["name"]]))	{
											$chief_count=count($cachedTransl_chief[$lK][$LLr["name"]]);
											$plusChief = array_merge($LLarr[$lR["langkey"]],$cachedTransl_chief[$lK][$LLr["name"]]);
											$missing_count=$baseCount-count($plusChief);
										}
											
										if (is_array($cachedTransl[$lK][$LLr["name"]]))	{
												// Finding if there are labels from the full array that the chief translator does not have and if so, increasing a counter.
											$non_chief_count=0;
											reset($cachedTransl[$lK][$LLr["name"]]);
											while(list($kkk,$vvv)=each($cachedTransl[$lK][$LLr["name"]]))	{
												if (!isset($cachedTransl_chief[$lK][$LLr["name"]][$kkk]))	{
													$non_chief_count++;
												}
											}
										}
										
										$translateStat["files"][$LLr["name"]][$lK]=array($cur_count,$missing_count,$non_chief_count,$chief_count);
										$translateStat["lang"][$lK]["cur_count"]+=$cur_count;
										$translateStat["lang"][$lK]["missing_count"]+=$missing_count;
										$translateStat["lang"][$lK]["non_chief_count"]+=$non_chief_count;
										$translateStat["lang"][$lK]["chief_count"]+=$chief_count;
									}
								}
							}
						}
						
						if ($mergeAndReturnRepository)	{
							$LLarr = $this->cleanUpLLArray($LLarr,$langInfo[0]);
							if (isset($dB[$LLr["name"]]) && is_array($dB[$LLr["name"]]["LOCAL_LANG"]))	{
#								debug($dB[$LLr["name"]]);
								$dB[$LLr["name"]]["content"]=$this->makeLocalLangArray($LLarr,$LLr["LOCAL_LANG"][0]);
								$dB[$LLr["name"]]["size"]=strlen($dB[$LLr["name"]]["content"]);
								$dB[$LLr["name"]]["codelines"]=count(explode(chr(10),$dB[$LLr["name"]]["content"]));
								$dB[$LLr["name"]]["LOCAL_LANG"][1]=serialize($LLarr);
								$dB[$LLr["name"]]["content_md5"]=md5($dB[$LLr["name"]]["content"]);
#								debug($dB[$LLr["name"]]);
#								echo "<HR>";
							}
						}
					}
					if ($mergeAndReturnRepository)	{
						$datStr = serialize($dB);
						$mostRecent_extRepEntry["datablob_md5"] = md5($datStr);
						$mostRecent_extRepEntry["datablob"] = gzcompress($datStr);
						$mostRecent_extRepEntry["datasize_gz"] = strlen($mostRecent_extRepEntry["datablob"]);
						$mostRecent_extRepEntry["datasize"] = strlen($datStr);
						
						return $mostRecent_extRepEntry;
#						debug();
					} else return $translateStat;
				} else return 'No language files';
			} else return 'Error: MD5hash didnt match.';			
		} else return 'Error: most recent repository entry was not an array';
	}

	/**
	 * Returns an array with two arrays - one with all languages for translation and another with relations between these languages and sub-translators.
	 */
	function makeLocalLangArray($arr,$header="")	{
		$lines=array();
		reset($arr);
		if (!$header)	{
			$lines[]='<?php';
			$lines[]=trim($this->sPS('
				/**
				 * '.$description.'
				 * 
				 * This file is detected by the translation tool.
				 */
			'));
			$lines[]='';
		} else {
			$lines[]=trim($header);
		}
		$lines[]='';
		$lines[]='$LOCAL_LANG = Array (';
		while(list($lK,$labels)=each($arr))	{
			if (is_array($labels))	{
				$lines[]="	'".$lK."' => Array (";
				while(list($l,$v)=each($labels))	{
					if (strcmp($v,""))	{
						$lines[]="		'".$l."' => '".t3lib_div::slashJS($v,1)."',";
					}
				}
				$lines[]='	),';
			}
		}
		$lines[]=');';
		$lines[]='?>';
		
		return implode(chr(10),$lines);
	}
	
	/**
	 * Returns an array with two arrays - one with all languages for translation and another with relations between these languages and sub-translators.
	 */
	function getLanguagesAndTranslators()	{
		$query="SELECT * FROM tx_extrepmgm_langadmin LEFT JOIN tx_extrepmgm_langadmin_sub_translators_mm".
				" ON tx_extrepmgm_langadmin.uid = tx_extrepmgm_langadmin_sub_translators_mm.uid_local".
				" WHERE tx_extrepmgm_langadmin.pid=".intval($this->dbPageId).
				" ORDER BY tx_extrepmgm_langadmin.crdate, tx_extrepmgm_langadmin_sub_translators_mm.sorting";

		$languages=array();
		$lang_users=array();
		$res=mysql(TYPO3_db,$query);
		while($row=mysql_fetch_assoc($res))	{
			$languages[$row["langkey"]]=$row;
			$lang_users[$row["langkey"]."_".$row["uid_foreign"]]=1;
			$languages_userList[$row["langkey"]][]=$row["uid_foreign"];
		}
		
		return array($languages,$lang_users,$languages_userList);
	}
	
	/**
	 * This compiles an array with the layers of translation from the assistants and the chief translators
	 */
	function getCompiledTranslations($assistants,$chief_uid,$extKey,$lK,$fileName="")	{
		$chief_dat = array();
		$assist_arr = array();
		$LLarr_comp_users=array();
		
		if (is_array($assistants))	{
			if (intval($chief_uid))	array_unshift($assistants,intval($chief_uid));
			$assistants=array_reverse($assistants);	// Total array of assistants and finally the chief.
#debug($assistants);
			reset($assistants);
			while(list(,$assist_fe_users)=each($assistants))	{
				$assist_dat = $this->getDataContent($assist_fe_users,$extKey,$lK);
				if ($fileName)	{
					if (is_array($assist_dat[$fileName]) && count($assist_dat[$fileName]))	{
							// Array with the list of arrays being merged together:
						$assist_arr[$assist_fe_users] = $assist_dat[$fileName];
							// The composite, $LLarr_comp ($LLarr being the original or CURRENT array in the extension) ...
						$LLarr_comp_users=array_merge($LLarr_comp_users,$assist_dat[$fileName]);
					}
				} else {
					if (intval($chief_uid)==$assist_fe_users)	$chief_dat=$assist_dat;
					$LLarr_comp_users=t3lib_div::array_merge_recursive_overrule($LLarr_comp_users,$assist_dat);
				}
			}
		}
		return array($LLarr_comp_users, $assist_arr, $chief_dat, $assistants);
	}
	
	/**
	 * $returns an LL-array in and rearranges all labels in the correct order plus removing all labels which is not in the default-key.
	 */
	function cleanUpLLArray($LLarr,$trans_languages)	{
		if (is_array($LLarr["default"]))	{
			$newLLarr=array();
				// Settint default labels directly.		
			$newLLarr["default"]=$LLarr["default"];
	
				// Going through all translations:		
			reset($trans_languages);
			while(list(,$sLr)=each($trans_languages))	{
				$lK=$sLr["langkey"];
				if (strcmp($lK,"default"))	{
					$newLLarr[$lK]=array();
					
					reset($LLarr["default"]);
					while(list($key)=each($LLarr["default"]))	{
						if (strcmp($LLarr[$lK][$key],""))	{
							$newLLarr[$lK][$key]=$LLarr[$lK][$key];
						}
					}
				}
			}
			return $newLLarr;
		}
	}
	
	/**
	 * Get data content from language element table.
	 */
	function getDataContent($fe_user_uid,$extKey,$langkey)	{
		$query = "SELECT data_content FROM tx_extrepmgm_langelements WHERE 
							pid=".intval($this->dbPageId)."
						AND deleted_tstamp=0
						AND fe_user=".intval($fe_user_uid)." 
						AND extension_key='".addslashes($extKey)."' 
						AND langkey='".addslashes($langkey)."'";
#debug($query,1);
		$res = mysql(TYPO3_db,$query);
		echo mysql_error();
		$row=mysql_fetch_assoc($res);
		$dat=unserialize($row["data_content"]);
#debug($dat);
		if (!is_array($dat))	$dat=array();
		return $dat;
	}
}


if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/extrep/pi/class.tx_extrep.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/extrep/pi/class.tx_extrep.php"]);
}
?>