<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Customization
 *
 * This document (tables.php) holds all customized values that makes Typo work against a given MySQL database.
 * Please don't edit this file directly as it's regularly updated. 
 *
 * Rather use the $typo_db_extTableDef_script variable in localconf.php to point to a script-filename in typo3conf/ folder which will be included subsquently to this file and in that file you can then modify the TCA array as you like...
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */
 

 
/*
************************
$PAGES_TYPES

this array defines the different types of pages (the obligatory table "pages"!)
Here you can set the icon and especially you can define which tables are allowed on a certain pagetype (doktype)
NOTE: The "default" entry in the $PAGES_TYPES-array is the "base" for all types, and for every 
type the entries simply overrides the entries in the "default" type!!
************************
*/

$PAGES_TYPES = Array(
	"254" => Array(	
		"type" => "sys",
		"icon" => "sysf.gif",
		"allowedTables" => "*"
	),
	"255" => Array(		// Typo3: Doktype 255 is a recycle-bin. Documents will be put here when deleted. See manual
		"type" => "sys",
		"icon" => "recycler.gif",
		"allowedTables" => "*"
	),
	"default" => Array(
		"type" => "web",
		"icon" => "pages.gif",
		"allowedTables" => "pages",
		"onlyAllowedTables" => "0"
	)
);


$ICON_TYPES = Array();


$LANG_GENERAL_LABELS = array(
	"endtime" => "LLL:EXT:lang/locallang_general.php:LGL.endtime",
	"hidden" => "LLL:EXT:lang/locallang_general.php:LGL.hidden",
	"starttime" => "LLL:EXT:lang/locallang_general.php:LGL.starttime",
	"fe_group" => "LLL:EXT:lang/locallang_general.php:LGL.fe_group",
	"hide_at_login" => "LLL:EXT:lang/locallang_general.php:LGL.hide_at_login",
	"any_login" => "LLL:EXT:lang/locallang_general.php:LGL.any_login",
	"usergroups" => "LLL:EXT:lang/locallang_general.php:LGL.usergroups",
/*	"type" => "LLL:EXT:lang/locallang_general.php:LGL.type",
	"description" => "LLL:EXT:lang/locallang_general.php:LGL.description",
	"prependAtCopy" => "LLL:EXT:lang/locallang_general.php:LGL.prependAtCopy",
	"layout" => "LLL:EXT:lang/locallang_general.php:LGL.layout",
	"default_value" => "LLL:EXT:lang/locallang_general.php:LGL.default_value",
	"normal" => "LLL:EXT:lang/locallang_general.php:LGL.normal",
	"images" => "LLL:EXT:lang/locallang_general.php:LGL.images",
	"image" => "LLL:EXT:lang/locallang_general.php:LGL.image",
	"caption" => "LLL:EXT:lang/locallang_general.php:LGL.caption",
	"subheader" => "LLL:EXT:lang/locallang_general.php:LGL.subheader",
	"text" => "LLL:EXT:lang/locallang_general.php:LGL.text",
	"name" => "LLL:EXT:lang/locallang_general.php:LGL.name",
	"title" => "LLL:EXT:lang/locallang_general.php:LGL.title",
	"address" => "LLL:EXT:lang/locallang_general.php:LGL.address",
	"phone" => "LLL:EXT:lang/locallang_general.php:LGL.phone",
	"fax" => "LLL:EXT:lang/locallang_general.php:LGL.fax",
	"author" => "LLL:EXT:lang/locallang_general.php:LGL.author",
	"email" => "LLL:EXT:lang/locallang_general.php:LGL.email",
	"company" => "LLL:EXT:lang/locallang_general.php:LGL.company",
	"city" => "LLL:EXT:lang/locallang_general.php:LGL.city",
	"zip" => "LLL:EXT:lang/locallang_general.php:LGL.zip",
	"country" => "LLL:EXT:lang/locallang_general.php:LGL.country",
	"www" => "LLL:EXT:lang/locallang_general.php:LGL.www",
	"note" => "LLL:EXT:lang/locallang_general.php:LGL.note",
	"parameters" => "LLL:EXT:lang/locallang_general.php:LGL.parameters",
	"code" => "LLL:EXT:lang/locallang_general.php:LGL.code",
	"links" => "LLL:EXT:lang/locallang_general.php:LGL.links",
	"language" => "LLL:EXT:lang/locallang_general.php:LGL.language",
	"category" => "LLL:EXT:lang/locallang_general.php:LGL.category",
	"shortcut_page" => "LLL:EXT:lang/locallang_general.php:LGL.shortcut_page",
	"keywords" => "LLL:EXT:lang/locallang_general.php:LGL.keywords",
	"disable" => "LLL:EXT:lang/locallang_general.php:LGL.disable",
	"startingpoint" => "LLL:EXT:lang/locallang_general.php:LGL.startingpoint",
	"disableRTE" => "LLL:EXT:lang/locallang_general.php:LGL.disableRTE",
	"external" => "LLL:EXT:lang/locallang_general.php:LGL.external",
	"recursive" => "LLL:EXT:lang/locallang_general.php:LGL.recursive"
	*/
);



/*****************************************************************************************************************

$TCA:

This array defines the tables and the relationship between them 
and how the fields in tables are treated and so on

See documentation "Inside Typo3" for the syntax and list of required tables/fields!

NOTE: You cannot use the single-quote (') in textlabels for fields (unless you escape it like this: (\')). This will not work out when the label is transferred to JavaScript in ti_inc.php. You MAY use double-qoute (")!
		Labels for item-lists or tablenames may include single-quotes and they MUST NOT be escaped!!
NOTE: The (default) icon for a table is defined 1) as a giffile named "gfx/i/[tablename].gif" or 2) as the value of [table][ctrl][iconfile]
NOTE: [table][ctrl][rootLevel] goes NOT for pages. Apart from that if rootLevel is true, records can ONLY be created on rootLevel. If it's false records can ONLY be created OUTSIDE rootLevel

******************************************************************************************/ 

/*


Languages:

All labels are split by "|".
The order of the languages can be seen in t3lib/config_default.php

Currently it's:

default | Danish | German | Norwegian | Italian | French | Spanish | Netherlands | Czech | Polish | Slovenian | Finnish | Turkish | Swedish | Portuguese | Russian
(default|dk|de|no|it|fr|es|nl|cz|pl|si|fi|tr|se|pt|ru)

*/




 

// ******************************************************************
// This is the mandatory pages table. 
// Must be completely configured in tables.php
// ******************************************************************
$TCA["pages"] = Array (
	"ctrl" => Array (
		"label" => "title",
		"tstamp" => "tstamp",
		"sortby" => "sorting",
		"title" => "LLL:EXT:lang/locallang_tca.php:pages",
		"type" => "doktype",
		"delete" => "deleted",
		"crdate" => "crdate",
		"hideAtCopy" => 1,
		"prependAtCopy" => "LLL:EXT:lang/locallang_general.php:LGL.prependAtCopy",
		"cruser_id" => "cruser_id",
		"useColumnsForDefaultValues" => "doktype"
	),
	"interface" => Array (
		"showRecordFieldList" => "doktype,title",
		"maxDBListItems" => 30,
		"maxSingleDBListItems" => 50
	),
	"columns" => Array (	
		"doktype" => Array (
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.type",
			"config" => Array (
				"type" => "select",	
				"items" => Array (	
					Array("LLL:EXT:lang/locallang_tca.php:doktype.I.0", "1"),
					Array("LLL:EXT:lang/locallang_tca.php:doktype.I.1", "254"),
					Array("LLL:EXT:lang/locallang_tca.php:doktype.I.2", "255")
				),
				"default" => "1"
			)
		),
		"title" => Array (
			"label" => "LLL:EXT:lang/locallang_tca.php:title",
			"config" => Array (
				"type" => "input",	
				"size" => "30",
				"max" => "256",
				"eval" => "required"
			)
		),
		"TSconfig" => Array (
			"exclude" => 1,	
			"label" => "TSconfig:",
			"config" => Array (
				"type" => "text",
				"cols" => "40",
				"rows" => "5",
				"wizards" => Array(
					"_PADDING" => 4,
					"0" => Array(
						"type" => t3lib_extMgm::isLoaded("tsconfig_help")?"popup":"",
						"title" => "TSconfig QuickReference",
						"script" => "wizard_tsconfig.php?mode=page",
						"icon" => "wizard_tsconfig.gif",
						"JSopenParams" => "height=500,width=780,status=0,menubar=0,scrollbars=1",
					)
				)
			)
		),
		"treeStop" => Array (		// This flag demands a little note: If it's set, the JavaScript-loaded page tree in the TBE will NOT descend beyond this point. This may be cool if you have more than a 1000 pages and don't want them all to load! You can still use the "LIST" submodule to descend the tree (and the other non-JS tree browsers)
			"exclude" => 1,	
			"label" => "JS stop:",
			"config" => Array (
				"type" => "check"
			)
		),
		"php_tree_stop" => Array (
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_tca.php:php_tree_stop",
			"config" => Array (
				"type" => "check"
			)
		),
		"is_siteroot" => Array (
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_tca.php:is_siteroot",
			"config" => Array (
				"type" => "check"
			)
		),
		"storage_pid" => Array (
			"exclude" => 1,	
			"label" => "LLL:EXT:lang/locallang_tca.php:storage_pid",
			"config" => Array (
				"type" => "group",
				"internal_type" => "db",
				"allowed" => "pages",
				"size" => "1",
				"maxitems" => "1",
				"minitems" => "0",
				"show_thumbs" => "1"
			)
		),
		"tx_impexp_origuid" => Array("config"=>array("type"=>"passthrough")),
	),
	"types" => Array (					
		"1" => Array("showitem" => "doktype, title, TSconfig;;6;nowrap, storage_pid;;7"),
		"254" => Array("showitem" => "doktype, title;LLL:EXT:lang/locallang_general.php:LGL.title, TSconfig;;6;nowrap, storage_pid;;7"),
		"255" => Array("showitem" => "doktype, title, TSconfig;;6;nowrap, storage_pid;;7")
	),
	"palettes" => Array (
		"6" => Array("showitem" => "php_tree_stop,treeStop"),
		"7" => Array("showitem" => "is_siteroot")
	)
);



// ******************************************************************
// be_groups
//
// This is only the "header" part (ctrl). 
// The full configuration is found in t3lib/install/tbl_users.php
// ******************************************************************
$TCA["be_users"] = Array (
	"ctrl" => Array (
		"label" => "username",
		"tstamp" => "tstamp",
		"title" => "LLL:EXT:lang/locallang_tca.php:be_users",
		"crdate" => "crdate",
		"cruser_id" => "cruser_id",
		"delete" => "deleted",
		"adminOnly" => 1,	// Only admin, if any
		"rootLevel" => 1,
		"default_sortby" => "ORDER BY admin, username",
		"enablecolumns" => Array (
			"disabled" => "disable",
			"starttime" => "starttime",
			"endtime" => "endtime"
		),
		"type" => "admin",
		"typeicon_column" => "admin",
		"typeicons" => Array (
			"0" => "be_users.gif",
			"1" => "be_users_admin.gif"
		),
		"mainpalette" => "1",
		"useColumnsForDefaultValues" => "usergroup,lockToDomain,options,db_mountpoints,file_mountpoints,fileoper_perms,userMods",
		"dynamicConfigFile" => "T3LIB:tbl_be.php"
	)
);




// ******************************************************************
// be_groups
//
// This is only the "header" part (ctrl). 
// The full configuration is found in t3lib/install/tbl_users.php
// ******************************************************************
$TCA["be_groups"] = Array (
	"ctrl" => Array (
		"label" => "title",
		"tstamp" => "tstamp",
		"crdate" => "crdate",
		"cruser_id" => "cruser_id",
		"delete" => "deleted",
		"default_sortby" => "ORDER BY title",
		"prependAtCopy" => "LLL:EXT:lang/locallang_general.php:LGL.prependAtCopy",
		"adminOnly" => 1,	// Only admin, if any
		"rootLevel" => 1,
		"type" => "inc_access_lists",
		"typeicon_column" => "inc_access_lists",
		"typeicons" => Array (
			"1" => "be_groups_lists.gif"
		),
		"enablecolumns" => Array (
			"disabled" => "hidden"
		),
		"title" => "LLL:EXT:lang/locallang_tca.php:be_groups",
		"useColumnsForDefaultValues" => "lockToDomain",
		"dynamicConfigFile" => "T3LIB:tbl_be.php"
	)
);




// ******************************************************************
// sys_filemounts
//
// This is only the "header" part (ctrl). 
// The full configuration is found in t3lib/install/tbl_sys.php
// ******************************************************************
$TCA["sys_filemounts"] = Array (
	"ctrl" => Array (
		"label" => "title",
		"tstamp" => "tstamp",
		"prependAtCopy" => "LLL:EXT:lang/locallang_general.php:LGL.prependAtCopy",
		"title" => "LLL:EXT:lang/locallang_tca.php:sys_filemounts",
		"adminOnly" => 1,	// Only admin, if any
		"rootLevel" => 1,
		"delete" => "deleted",
		"enablecolumns" => Array (
			"disabled" => "hidden"
		),
		"iconfile" => "_icon_ftp.gif",
		"useColumnsForDefaultValues" => "path,base",
		"dynamicConfigFile" => "T3LIB:tbl_be.php"
	)
);


 
 

/*

Modules configuraion. 


Every entry in this array represents a tab in the upper left corner pane in the Typo3 interface


Add Modules: 
If the key (associative key) of the entry exists as a folder by that same name in 
the folder "mod/"-folder AND if that folder holds a conf-file (with valid 
PHP-configuration inside!) then a tab is added to the pane. 
If this is not the case the entry is regarded as a "spacer" in the pane


Add Submodules: 
As long as the value of a valid (see above) module is empty ("") 
then no submodules are added. If not the value is regarded as a comma-sep. 
list of submodules. These must exist as subfolders to the modules folder 
and if the do not they are just regarded as spacers instead.

*/


$TBE_MODULES = Array (
	"web" => "list,info,perm,func",
	"file" => "list",
	"doc" => "",	// This should always be empty!
	"spacer1"=>"",
	"user" => "",
	"tools" => "em",
	"help" => "about"
);



/**
 * Setting up backend styles and colors
 */
$TBE_STYLES = array(
	"colorschemes" => Array (
		"0" => "#E4E0DB,#CBC7C3,#EDE9E5",
	),
	"borderschemes" => Array (
		"0" => array("border:solid 1px black;",5)
	)
);


?>