# TYPO3 Extension Manager dump 1.0
#
# Host: TYPO3_host    Database: t3_testsite
#--------------------------------------------------------


#
# Table structure for table 'sys_tabledescr'
#
DROP TABLE IF EXISTS sys_tabledescr;
CREATE TABLE sys_tabledescr (
  tablename varchar(40) DEFAULT '' NOT NULL,
  fieldname varchar(40) DEFAULT '' NOT NULL,
  description tinytext NOT NULL,
  details text NOT NULL,
  syntax text NOT NULL,
  image tinytext NOT NULL,
  image_descr tinytext NOT NULL,
  seeAlso text NOT NULL,
  serial int(11) DEFAULT '0' NOT NULL,
  tstamp int(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (tablename,fieldname)
);


INSERT INTO sys_tabledescr VALUES ('pages', 'title', 'Enter the title of the page. This is normally shown in the website navigation.', '', 'You must enter a page title. The field is required.', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'layout', 'Select a layout for the page. Any effect depends on the website template.', 'This option may not have any impact on the page design since it depends on how (and if) the front end template uses it. In most default templates it\'s not used.', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'doktype', 'Select the page type. This affects whether the page represents a visible webpage or is used for other purposes.', '\'Standard\' and \'Advanced\' types are regular webpages, just differing in the number of options. \r\n\'External URL\' and \'Shortcut\' types allows you to let a page be a shortcut to either an external URL or in the latter case a page in the page tree.\r\n\'Not in menu\' is also a regular page, but will not be shown in the navigation.\r\n\'Backend User Section\' is an option which requires a backend user to be logged in for the page to be visible.\r\n				\r\nSpecial types:\r\n\'Spacer\' is only meaningfull if your frontend navigation is programmed to use it. In this case it does not represent a page with content but is intended to be a non-clickable placeholder in the navigation.\r\n\'SysFolder\' is a page type which cannot be shown as a webpage but is rather acting as a storage for records of your choice.\r\n\'Recycler\' is a garbage can. Pages and records in a recycler are not visible in the frontend.\r\n\r\n<B>Notice:</B> Each type usually has a specific icon attached. Also certain types may not be available for a user (so you may experience that some of the options is not available for you!). And finally each type is configured to allow only certain table records in the page (SysFolder will allow any record if you have any problems).', '', '', '', 'pages:shortcut,\r\npages:url', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'hidden', 'If this is checked, the page will be hidden on the website.', 'The \'Hidden\', \'Start\', \'Stop\' and \'Access\' options are all about limiting access to pages and thus they are related in functionality. In any case where a page is not visible due to one of these options, the page will not show up in the site navigation.\r\nNotice, these options are related <em>only</em> to the page for which they are set. If you want their effect to cover the subpages as well, you must enable the \'Include subpages\' option.\r\nWhen you\'re logged in as a backend user you can preview hidden pages if you have read access to them.', '', 'hidden_page.gif', 'The page icon of a hidden page is dimmed and a red X is added.', 'pages:starttime,pages:endtime,pages:fe_group,pages:extendToSubpages', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'starttime', 'The \'Start\' time determines the date from which the page will be visible online. Use this to \'publish\' the page on a certain date.If \'Start\' time is not set, the page will be online instantly (unless the page is hidden otherwise).', '', 'Format is DD-MM-YYYY. You may enter the value in other ways - it will be evaluated immediately.\r\nIf you insert eg. a \'d\' the current date is inserted. You can also prepend any value in the field with eg. \'+10\' which will add 10 days to the current value. For instance setting the value to \'d+10\' would select a date 10 days from now.', '', '', 'pages:endtime,pages:hidden', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', '', 'A \'Page\' record usually represents a webpage in Typo3. All pages has an id-number by which they can be linked and referenced. The \'Page\' record does not itself contain the content of the page - for this purpose you should create \'Page content\' records.', 'Depending on the \'Type\' of the page, it may also represent a general storage for database elements in Typo3. In that case it is not necessarily available as a webpage but only internally in the page tree as a place to store items such as users, subscriptions etc.\r\nThe pages table is the very backbone in Typo3. All records editable by the mainstream modules in Typo3 must \'belong\' to a page. It\'s exactly like files and folders on your computers harddrive. \r\nThe pages are organized in a tree structure which is not only a very handy way of organizing in general but also a optimal reflection of how you should organize the pages on your website. And thus you\'ll normally find that the page tree is a reflection of the website navigation itself.\r\n\r\nTechnically all database elements has a field \'uid\' which is a unique identification number. Further they must have a field \'pid\' which holds the uid-number of the page (page id) to which they belong. If the \'pid\' field is zero the record is found in the so called \'root\'. Only administrators are allowed access to the root and furthermore table records must be configured to either belonging to a page or being found in the root.', '', '', '', 'tt_content', '0', '1011031225');
INSERT INTO sys_tabledescr VALUES ('pages', 'endtime', 'The \'Stop\' time is the date from which the page will not be online anymore.', '', 'See Page / Start (click below)', '', '', 'pages:starttime', '0', '1011029861');
INSERT INTO sys_tabledescr VALUES ('pages', 'fe_group', 'If \'Access\' is set to a usergroup name, only website users which are members of the selected usergroup will be able to view the page when they are logged in.The special option \'Hide at login\' means the page will <em>not</em> be visible for website use', '', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'extendToSubpages', 'By default the Start, Stop, Access and Hidden options are effective <em>only</em> for the page on which they are set. If the option \'Include subpages\' is checked for the page, then their effect is inherited by all subpages to that page.', 'Consider a scenario where you want to create a whole section of subpages only visible for users which are logged in. Setting the \'Access\' option for the top page in the section would affect access to that page only. So the page would not show up in the navigation unless you are logged in. \r\nHowever the subpages would still be visible if one could guess the id-number of the pages and enter it manually in the URL. But setting this option would extend the effect of the top page setting to cover all subpages as well.', '', '', '', 'pages:hidden,\r\npages:starttime,\r\npages:endtime,\r\npages:fe_group', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'alias', 'An \'alias\' is a unique identification string for a page. You can use this string instead of the id-number to refer to the page.', 'Ultimately a page is identified by its id-number. For instance you may refer to a page in Typo3 by \'.../?id=123\'. If the page with id \'123\' has the alias \'one_two_three\', then the URL \'.../?id=one_two_three\' would display exactly the same page, because \'one_two_three\' is an alias for the id \'123\'.\r\nNormally you should assign aliases only to a limited number of pages, preferably those you need to link to a lot. In most Typo3 configurations you would be able to use the syntax \'.. &lt;link one_two_three&gt;go to the page&lt;/link&gt; ..\' to create a link to the page. This is easier to remember.\r\nAnother use is if you need to change which page such a link is refering to. In that case you can delete the alias for one page and enter it for another and all links pointing to the alias would now refer to another id-number.', 'An alias can contain only lowercase alphanumeric characters and must be unique. \r\nPlease notice: If the entered value was not unique, it will automatically be prepended with a number. ', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'target', 'The HTML target of menu items linking to this page.', 'Set this value only to overrule the default link, which should be configured correctly for most pages in the website TypoScript template.', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'no_cache', 'This option disables server caching of the page.', 'Normally pages in Typo3 are cached on the server after being constructed for the first time. This means a page is displayed much faster the second time it\'s requested. \r\nFor most pages this presents no problems - rather it\'s boosting the performance of the website.\r\nHowever you may need to disable caching for a page if it contains dynamic content which must not be cached under any circumstances. Normally the PHP-code rendering such content is programmed to disable the caching automatically. But in any case you can force the page not to be cached via this option.', '', '', '', 'pages:cache_timeout', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'cache_timeout', 'Sets the cache timeout for the page.', 'By default pages last for 24 hours in the cache. After that period the page is constructed again and rewritten to the cache. Depending on your configuration, the cache may also be cleared at midnight.\r\nAnyhow you may here set another timeout time for the page in cache if you need to. \r\nThis option is used quite rarely.', '', '', '', 'pages:no_cache', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'no_search', 'If enabled, this option excludes the page from searching operations on the website.', '', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'author', 'Enter the page authors name.', 'Whether the author name is used or not depends on the template. For most templates this value is not used.\r\nIf you\'re using Typo3 pages as \'articles\' then you could use this field to display the name of the page (article) author.', '', '', '', 'pages:author_email', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'author_email', 'Enter the page authors email address.', '', '', '', '', 'pages:author', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'treeStop', 'If enabled, the loading of the page tree in the classic Typo3 Backend will not decend further from this point.', 'The classic Typo3 Backend interface loads the whole page tree during the initialization. If your website contains more than 1000 pages this will slow down both the initialization process (depending on your internet connection speed) and perhaps also your work (needs memory on the client computer).\r\nIf this option is enabled you can still decend in the page tree through the \'List\' module by clicking the page titles there. In addition you can mount specific subpages in the section of course.\r\nThe Alternative Backend page tree is not affected by this option because it uses another approach for the page tree (re-calculated for each instance of the page tree).\r\nThis option is used very rarely and should be enabled and set by admin-users only.', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'TSconfig', 'Page TypoScript configuration.', 'Basically \'TypoScript\' is a concept for entering values in a tree-structure. This is known especially in relation to creating templates for Typo3 websites.\r\nHowever the same principle for entering the hierarchy of values is used here to configure various features in relation to the backend, functions in modules, the Rich Text Editor etc. \r\nThe resulting \'TSconfig\' for a page is actually an accumulation of all \'TSconfig\' values from the root of the page tree and outwards to the current page. And thus all subpages are affected as well. A print of the page TSconfig is available from the \'Page TSconfig\' menu in the \'Web>Info\' module.\r\n\r\n<strong>Example:</strong>\r\nNormally the \'Web>Page\' module lets you create content in four columns, Left, Normal, Right, Border. However most websites use only a single or two columns. So some of these content columns are just taking up space and may even be confusing to users.\r\nIf you enter this string in the \'TSconfig\' field, the \'Web>Page\' module will allow you to work only in the \'Normal\' and \'Border\' column!\r\n\r\n<em>mod.web_layout.tt_content.colPos_list = 0,3</em>\r\n\r\n(Must be entered in a single line!)\r\n\r\nFor the full range of options you must refer to the the \'Adminguide\' PDF-document.', 'Basic TypoScript syntax <em>without</em> \'Conditions\' and \'Constants\'.\r\n\r\nIt\'s recommended that only admin-users are allowed access to this field!', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'module', 'Define the page as a frontend \'module\'.', 'In the backend there is a module called \'Web>Modules\' as well as a header \'Modules\' in the \'User>Task Center\'. Both functions list the available \'Frontend modules\' to which the user has access.\r\nBasically, setting this option just marks the page so the backend knows this page contains eg. a forum or is the root page of a shopping section on the website. And based on this knowledge the backend is able to display a shortcut list as well as relevant functionality in the \'Web>Modules\' module. The frontend display is - largely - not affected.\r\nSo in effect, by \'marking\' a page to be a \'Shop\' module simply means it\'ll show up in the shortcut list of modules in the backend.\r\n\r\nThere may be a little more to it than this, but for details on the subject, you must refer to the administration documentation.\r\n\r\nIt\'s recommended that only admin-users are allowed access to this field!', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'media', 'Attach media files related to the page.', 'This fields allows you to attach various files to the page record. \r\nIf and how these files are used depends on your template. So basically which files you attach here and in which order they must be listed is determined by your specific website template and thus you should seek instructions in the documentation for your specific website.\r\nAs an example this field could be used from the template to allow you to attach a logo-image to the page. Or the template might be programmed to expect the first file to be an image used as a link in the navigation menu. But remember, this totally depends on how this field is used in the programming of the template.', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'subtitle', 'Enter a subtitle if needed.', 'Whether this field is used or not depends on the template. In most cases it\'s not used.\r\nYou may use this field as you like in your own templates.', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'url', 'Enter the URL to which this page is supposed to link.', 'Example: \'http://www.typo3.com\' or just \'www.typo3.com\' provided the \'Type\' selector is set to \'http://\'.\r\nUse the \'Type\' selector to select a prefix for the URL.\r\n\r\nThis option is used only if the page \'Type\' is set to \'External URL\'.', '', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'shortcut', 'Insert a reference to the page to which this page is supposed to be a shortcut.', 'Click the \'Browse for records\' icon and a new window will appear in which you can easily select the page to which the shortcut is supposed to link.\r\n\r\nThis option is used only if the page \'Type\' is set to \'Shortcut\'.', '', 'page_shortcut.gif', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'keywords', 'Enter keywords for the page separated by commas.', 'Most Typo3 websites inserts these keywords in a meta-tag on the page. Depends on the TypoScript template.\r\nThe keywords may also be used for searching.', '', '', '', 'pages:description', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'description', 'Enter a short description for the page.', 'Most Typo3 websites insert this description in a meta-tag on the page. Depends on the TypoScript template.', '', '', '', 'pages:keywords\r\npages:abstract', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'abstract', 'Enter an abstract for the page.', 'An abstract is a short description of the page content. It\'s different from the Description field in the fact that it\'s not inserted in any meta-tags.\r\nBasically the use of the abstract depends on the TypoScript template. You may use this field for user defined purposes as you like. \r\nHowever there is one explicit use with most Typo3 websites: If you insert a content element of the type \'Menu/Sitemap\' and select the subtype \'Menu of subpages to these pages (with abstract)\' then the content of this field will be displayed as a short description in the list.', '', '', '', 'pages:description', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('pages', 'newUntil', 'Enter the \'expiry date\' of the page.', 'The \'expiry date\' of the page has no effect on the display of the webpage. This value is rather for internal use meant as a reminder of the date when the content of this page should be revised. So if the content of the page will be outdated at a certain point in time, you could set this value to that approximate date.\r\nIn order to obtain an overview of the expiry dates of pages, use the \'Pagetree overview\' in the \'Web>Info\' module.', 'See Page / Start (click below)', '', '', 'pages:starttime', '0', '1011029861');
INSERT INTO sys_tabledescr VALUES ('pages', 'lastUpdated', 'Enter the time and date of the most recent update of this page.', 'How the value of this field is used is determined by the TypoScript template of the website. First of all a \'Last updated\' notice needs to be inserted on the pages and secondly the template must be configured to use this value. \r\nThe most common use which is found in the standard templates will automatically display the last update time and date <em>unless</em> this field specifies a value in which case this value is inserted.', 'Format is HH:MM DD-MM-YYYY. \r\nIf you insert eg. a \'d\' the current time and date is inserted. You can also prepend any value in the field with eg. \'+10\' which will add 10 days to the current value.', '', '', '', '0', '1011029579');
INSERT INTO sys_tabledescr VALUES ('sys_language', 'title', 'Enter the name of this additional system language.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('sys_language', 'hidden', 'This option will hide the system language from being available in the backend.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'username', 'Enter the username of the website user. This is needed to login.', '', 'A username is required and must be in lowercase without spaces in it. Furthermore the username must be unique among other usernames in the page where it\'s saved. If it is not unique a number will be prepended automatically.', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'password', 'Enter the password for the username above. This is needed to login.', '', 'A password is required and must be in lowercase without spaces in it.', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'usergroup', 'Select a user group for the username.', 'When a user logs in he is able to view all content which is access restricted to the user <em>group(s)</em> the user is a member of. Therefore the user login primarily makes sense with regard to the member groups.', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'lockToDomain', 'Enter the host name from which the user is forced to login.', 'A Typo3 system may have multiple domains pointing to it. Therefore this option secures that users can login only from a certain host name.', 'Either a domain name, "www.typo3.com" or an IP address, "10.34.222.83"', '', '', 'fe_groups:lockToDomain', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'name', 'Enter the regular name of the user, both first- and surname.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'address', 'Enter the street address of the user.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'www', 'Enter the homepage URL', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'title', 'Enter the job title, eg. \'Director\' or \'Accountant\'.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'company', 'Enter the name of the company in which the user is employed.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'image', 'Insert a photo of the user.', '', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'disable', 'This option will temporarily disable the user from logging in.', '', '', '', '', 'fe_users:starttime,fe_users:endtime', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'starttime', 'Enter the date from which the account is active.', '', '[SHARED:dateTime]', '', '', 'fe_users:disable,fe_users:endtime', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'endtime', 'Enter the date from which the account is disabled.', '', '[SHARED:dateTime]', '', '', 'fe_users:disable,fe_users:starttime', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_users', 'TSconfig', 'Enter additional TSconfig for the user (advanced).', 'This field allows you to enter TypoScript style configuration values for the user. Currently there are no system defined keys. If there ever will be, they will be described in detail in the administrative documentation.\r\n\r\nThe primary use of this field (as well as the \'sister\'-field in the Website usergroup table) is for custom purposes. In this case, you should use the root-key "user" for your customly defined values. Thus you don\'t risk any future system keys to interfere with your configuration.\r\n\r\nYou access the values of the configuration from your PHP include code in the frontend by calling the function <em>$GLOBALS["TSFE"]->fe_user->getUserTSconf()</em> which will return an array with the valuetree in it.\r\n\r\n<B>Warning:</B> You should use Website user/group TSconfig in your PHP-scripts ONLY if your resulting content is NOT being cached! So call it from TypoScript USER_INT cObjects or disable caching from your PHP-code by calling <em>$GLOBALS["TSFE"]->set_no_cache();</em>\r\n\r\n<b>TSconfig from Website usergroups:</b>\r\nNotice that the configuration from the field TSconfig in the member groups of the user is accumulated and prepended to the TSconfig of the user before it\'s parsed. This means for instance that a key defined in the TSconfig of the user (this field) will override the same key defined in the last (bottom) usergroup in the list which will again override the same key defined in the first (top) usergroup in the list.\r\n\r\n<b>Example:</b>\r\nLet\'s imagine you want to define for a user that his name is printed in the bottom of the webpages when he is logged in. First of all you must write a PHP-function and insert the result from it as a USER_INT cObject in the bottom of the page. But your function needs to know, whether or not this user is configured to have his name printed. So you decide to use a custom TSconfig key, \'user.printUserName\':\r\n\r\n<em>In the TSconfig field of the user or usergroup:</em>\r\n\r\nuser.printUserName = 1\r\n\r\n\r\n<em>In your PHP-function:</em>\r\n\r\n$userTSConfig = $GLOBALS["TSFE"]->fe_user->getUserTSconf();\r\nif ($userTSConfig["user."]["printUserName"]) {\r\n  return $GLOBALS["TSFE"]->fe_user->user["name"];\r\n}', 'TypoScript syntax, without conditions and constants.', '', '', 'pages:TSconfig,fe_groups:TSconfig,be_users:TSconfig,be_groups:TSconfig', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_groups', 'hidden', 'This option disables the user group.', 'If you disable a user group all user which are members of the group will in effect not inherit any properties this group may have given them.\r\nFor instance if a page or content element was assigned access only by this group and you disable the group, noone would gain access to that page or content element.', '', '', '', 'fe_users:disable', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_groups', 'title', 'Name of the group.', 'This title will appear as the group name in the \'Access\'-list in other records.', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_groups', 'lockToDomain', 'Enter the host name from which the group will be available only.', 'This options may be important if you have multiple websites in the same Typo3 database but still only one main storage page for all Website users. Thus the users may log in on any of the website urls. This may be considered a feature (having a global login as a user) or a problem (in which case you should have multiple user storages anyway). However you may wish to limit the use of a Website usergroup to a specific website and thus you don\'t want the group to be enabled for the user when he logs in at another URL (still from the same database of course). By entering the host name of the website here, you restrict the group to be used only from within this domain.\r\n\r\n<b>Notice:</b> The use for this option is not critical if you have multiple Website user storages, namely one for each site.', '', '', '', 'fe_users:lockToDomain', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_groups', 'description', 'Enter a description of the group.', 'This is for internal use and is just a way to put a note on what the group is for, why you created it and who should be members.\r\nUse it as you like.', '', '', '', '', '0', '0');
INSERT INTO sys_tabledescr VALUES ('fe_groups', 'TSconfig', 'TSconfig for the group (advanced).', 'This is the user TSconfig for the group. The values are inherited by any Website user who is a member of this group. \r\nThe configuration is subject to being overridden in other groups and by the TSconfig of the user himself.', 'TypoScript syntax, without conditions and constants.', '', '', 'fe_users:TSconfig', '0', '0');
INSERT INTO sys_tabledescr VALUES ('be_users', '', 'This is the table of backend administration users.', '', '', '', '', 'be_groups', '0', '1011030999');
INSERT INTO sys_tabledescr VALUES ('be_groups', '', 'This is the backend administration user groups available for the Backend users. These determine the permissions for the Backend users.', '', '', '', '', 'be_users', '0', '1011030999');
INSERT INTO sys_tabledescr VALUES ('sys_filemounts', '', 'Filemounts describe a filepath on the server, relative or absolute.', 'By creating a file mount record and placing a reference to it in a Backend usergroup you can allow a user access to the file mount in the File>List module. \r\nYou need to create and set at least one filemount with a folder \'_temp_\' in it if you want users to upload files through the webbrowser.\r\nFilemounts may also configure access to a path on the server to which the user has FTP-access. Just remember to set file-permissions on the server correctly so the webserver user (which PHP is running as) has at least read access to the FTP-dir.', '', '', '', 'be_users,\r\nbe_groups', '0', '1011036452');
INSERT INTO sys_tabledescr VALUES ('static_template', '', 'Static templates is a centrally distributed TypoScript library. You should never changes these values.', 'The Static templates are meant to be included by your TypoScript Template records depending on your needs. Refer to the \'TSref\' document (see below) for details on this process.\r\nNotice that by each release of Typo3 you should reinstall the Static Templates table by the install tool. See the \'Install/Upgrade\' document for details (see below).', '', '', '', 'sys_template\r\nTSref | http://www.typo3.com/doclink.php?doc=TSref.pdf\r\nInstall/Upgrade | http://www.typo3.com/doclink.php?doc=installing_upgrading.pdf', '0', '1011036452');
INSERT INTO sys_tabledescr VALUES ('sys_action', '', 'An \'Action\' is a configuration of a specific task which may be performed by assigned usergroups via the Task Center.', 'Currently an Action may be configured to create additional backend usergroups without being and admin-user and by selecting from a limited set of options. Another option is to let an action initiate a SQL SELECT-query in the database and return the result as a CSV file. \r\nActions can be assigned to a Backend usergroup and they are activated by a single click in the Task Center.', '', '', '', '', '0', '1011036452');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', '', 'Workflow records defines a certain task to be done by a To-Do item in the Task Center. ', 'Basically a Workflow record lets you define a database table in which a record should be created, a review user and Backend usergroups from which the issuer and recipients of a workflow task (To-Do) is selected. It also contains information about what happens with the record attached to the workflow after it done. For instance you can configure a workflow to create the record in one page and by the event of finalizing the workflow it\'s automatically moved to another page and maybe even unhidden (published online).\r\n\r\nWorkflows are an integrated part of the Task Center\'s To-Do facility.', '', '', '', '', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('sys_language', '', 'Defines which languages are alternatively available on each webpage.', 'The Web>Page module has a feature which allows users to edit page content divided into not only columns but also languages. The languages available for translation are determined by the number of Website Language record created.\r\nFor a webpage to be available in another language a "Alternative Page Language" record must be created on the page.', '', '', '', 'pages_language_overlay', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_content', '', 'All visible content on webpages in Typo3 is typically made up or represented with "Pagecontent" records. ', '"Pagecontent" records is ordered and can thus be rearranged. Also notice that the "Language" and "Column" selector of the "Pagecontent" records determines where and in which situation they appear. If you do not change the value of the "Language" and "Column" selectors you are most sure that the element will appear by default.', '', '', '', '', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_address', '', 'Built-in address database.', 'You may use it to build address lists in Typo3. There are in fact default TypoScript code which allows you to implement a online administration of the address information by each person in the list himself.\r\nThis table is also used by the Direct Mail system as the default subscription table for newsletters.', '', '', '', '', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_links', '', 'Built-in links database.', 'Currently there are no default use of the links table. You may implement and use it as you like through your own PHP-scripts.', '', '', '', '', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_guest', '', 'Built-in guestbook. ', 'This table is used by the default TypoScript guestbook available. All entries goes into this table and you can thus administer any guestbook through the backend.', '', '', '', 'tt_content:list_type', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_board', '', 'Built-in discussion board.', 'This table is used by the default TypoScript discussion board/list available. All entries goes into this table and you can thus administer the forums through the backend.', '', '', '', 'tt_content:list_type', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_calender', '', 'Built-in calendar. ', 'This table is meant to hold calender events displayed on the website. There is a primitive TypoScript based script available for display although you might as well use your own.', '', '', '', 'tt_content:list_type,\r\ntt_calender_cat', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_calender_cat', '', 'Built-in calendar categories.', 'Categories for the calender items.', '', '', '', 'tt_calender', '0', '1011036453');
INSERT INTO sys_tabledescr VALUES ('tt_products', '', 'Built-in shop items.', 'This table holds the products available in the default TypoScript shopping system.', '', '', '', 'tt_products_cat\r\ntt_content:list_type', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('tt_products_cat', '', 'Built-in  shop items categories.', 'The categories are only used with the shopping system if the shop is configured to do so.', '', '', '', 'tt_products', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('tt_news', '', 'Built-in news system.', '\'News\' items are typically those which goes on your frontpage on the websites and allows you to link down to a page with the full story. They may also represent articles (links to full pages) in the system.', '', '', '', 'tt_content:list_type,\r\ntt_news_cat', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('tt_news_cat', '', 'Built-in news system categories.', '', '', '', '', 'tt_news', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('sys_dmail', '', 'Direct mail campaigns ', 'The "Direct mail" module in Typo3 lets you send highly customized and personalized newsletters to subscribers either as HTML or Plain text, with or without attachments.\r\nA \'Direct mail\' record contains information about a direct mail campaign such as subject, sender, priority, attachments and whether HTML or Plain text content is allowed. Furthermore it also holds the compiled mail content which is to be sent to the subscribers.\r\nEverything regarding this module is controlled through the Web>Modules backend module.', '', '', '', 'sys_dmail_group\r\ntt_content:list_type', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('sys_dmail_group', '', 'Defines a group of recipients of Direct mails.', 'You can compile the group of either single individuals, all Address records within a page or branch, all results or an SQL query or maybe the result from other Direct mail groups.', '', '', '', 'sys_dmail', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('fe_users', '', 'A website login user.', 'This is users with a username and password who are allowed specific access to otherwise restricted areas on your website.', '', '', '', 'fe_groups\r\nbe_users', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('fe_groups', '', 'Usergroups for Website users.', 'The access restriction in Typo3 is assigned to these usergroups. When a page or other element is access restricted to a group, only Website users which are members or that group will be able to view the element on the website.', '', '', '', 'fe_users', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('sys_domain', '', 'Determines the entrypoint of a certain host name.', 'When a Typo3 database contains more than a single website, you\'ll typicall have to assign a domain name to each new websites "root-page". In practice you point all the domains to the same Typo3 database on the server, but then you insert these Domain records at the positions in the page tree where you want to direct requests to the domain. And thus pages \'outside\' that point will not be accessible from that domain.\r\nThis is like "Virtual hosts" in Apache servers.\r\n\r\n(Should probably be available for admin only.)', '', '', '', 'sys_language\r\nsys_template\r\n', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('sys_note', '', 'Internal reminder note placed on a the page.', 'This provides a simple way to attach instructional notes to a page regarding backend related issues. Use it as you like for reminders, instructions etc. ', '', '', '', 'pages\r\n', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('sys_template', '', 'TypoScript template record.', 'The \'Template\' records are the vital components used to set the design of the webpages. No matter how (almost) you would like to build your website, it must be initiated by a \'Template\' record placed in the root of the page tree of the site.\r\nBasically, create a \'Template\' record, enter a title and make sure to check of Clear constants, setup and Rootline. Then enter some TypoScript configuration in the Setup field and you\'re set. \r\nIt\'s very important to read how to do all this in the documents listed below! Also make sure you use the Web>TS module to do all the working with templates. It\'s a specialized tool to help you with this.', '', '', '', 'static_template\r\nTSref | http://www.typo3.com/doclink.php?doc=TSref.pdf\r\nTypoScript by Example | http://www.typo3.com/doclink.php?doc=TypoScript_by_example.pdf\r\n', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', '', 'Represents an alternative language for the page.', 'These records contains fields very similar to the Page records, exactly those fields which should be translated to another language in case you want a localized version of the page.\r\nCreate only ONE Alternative Page Language record of a specific language in each page. Having more than one record will leave it uncertain which of them is used when the page is displayed.\r\n\r\nBefore you can create Alternative Page Language records you should create a \'master\' language to be available in the root of the website ("Website Language")\r\nThe TypoScript template must be configured to allow other languages as well.\r\n\r\nTechnically when an alternative language is being viewed, the content of the Alternative Page Language record is simply overlaid on the actual page records thus substituting the content of the fields in the default language.', '', '', '', 'sys_language', '0', '1011036829');
INSERT INTO sys_tabledescr VALUES ('be_users', 'username', 'Enter the login name of the backend user.', 'A username is required and must be in lowercase without spaces in it. Furthermore the username must be unique. If it is not unique a number will be prepended automatically.', '', '', '', 'be_users:password', '0', '1011054587');
INSERT INTO sys_tabledescr VALUES ('be_users', 'password', 'Enter the password for the backend username above (Notice the value you enter <i>will</i> be readable in the field!).', 'The password is required. Before the password is sent to the server it\'s md5-hashed, so the password value itself is not transferred over the internet. This is true both when editing the password and when the user logs in. \r\nWhile this principle does not reveal the raw password it is <i>not</i> the same as real encryption. If you need the highest degree of security you should install the Typo3 backend on a secure server.\r\nThe password is stored in the database as an md5-hash and thus it\'s not possible to extract the original password from the database either. This means that \'lost passwords\' must be substituted with a new password for the user.', '', '', '', '', '0', '1011054667');
INSERT INTO sys_tabledescr VALUES ('be_users', 'usergroup', 'Assign backend user groups to the user.', 'The backend user groups defines the permissions which the backend user will inherit. So unless the backend user is an \'Admin\' user, he needs to be a member of one or more user groups in order to have practically any permissions assigned. The properties set in the user groups are mostly added together.\r\nThe first (top) group in the list is the group which will, by default, be the owner of pages the user creates.', '', '', '', 'be_users:TSconfig,\r\nbe_groups', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'lockToDomain', 'Enter the host name from which the user is forced to login.', 'A Typo3 system may have multiple domains pointing to it. Therefore this option secures that users can login only from a certain host name.', '', '', '', 'be_groups:lockToDomain,\r\nfe_users:lockToDomain,\r\nfe_groups:lockToDomain', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'db_mountpoints', 'Assign startpoints for the users page tree.', 'The page tree used my all Web-submodules to navigate must have some points-of-entry defined. Here you should insert one or more references to a page which will represent a new root page for the page tree. This is called a \'Database mount\'.\r\n\r\n<strong>Notice</strong> that backend user groups also has DB mounts which can be inherited by the user. So if you want a group of users to share a page tree, you should probably mount the page tree in the backend user group which they share instead.', '', '', '', 'be_groups:db_mountpoints,\r\nbe_users:file_mountpoints,\r\nbe_users:options\r\n', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'file_mountpoints', 'Assign startpoints for the file folder tree.', 'The file folder tree is used by all File-submodules to navigate between the file folders on the webserver. In order to be able to upload <em>any</em> files the user <em>must</em> have a file folder mounted with a folder named \'_temp_\' in it (which is where uploads go by default). \r\nNotice as with \'DB mounts\' the file folder mounts may be inherited from the member groups of the user. ', '', '', '', 'be_groups:file_mountpoints,\r\nbe_users:db_mountpoints,\r\nbe_users:options', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'email', 'Enter the email address of the user.', 'This address is rather important to enter because this is where messages from the system is sent.\r\n<strong>Notice</strong> the user is able to change this value by himself from within the User>Setup module.\r\n', '', '', '', 'be_users:realName', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'realName', 'Enter the ordinary name of the user, eg. John Doe.', '<strong>Notice</strong> the user is able to change this value by himself from within the User>Setup module.', '', '', '', 'be_users:email', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'disable', 'This option will temporarily disable the user from logging in.', '', '', '', '', 'be_users:starttime,\r\nbe_users:endtime', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'admin', '\'Admin\' users has TOTAL access to the system!', '\'Admin\' can do anything Typo3 allows and this kind of user should be used only for administrative purposes. All daily handling should be done with regular users. \r\n\'Admin\' users don\'t need to be members or any backend user groups. However you should be aware that any page created by an admin user without a group will not have any owner-group assigned and thus it will probably be invisible for other users. If this becomes a problem you can easily solve it by assigning a user group to the \'Admin\' user anyway. This does of course not affect the permissions since they are unlimited, but the first group listed is by default the owner group of newly created pages.\r\n\'Admin\' users are easily recognized as they appear with a red icon instead of the ordinary blue user-icon.\r\n\r\nYou should probably not assign any other users than yourself as an \'Admin\' user.', '', '', '', '', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'options', 'Select if the user should inherit page tree or folder tree mountpoints from member groups.', 'It\'s a great advantage to let users inherit mountpoints from membergroups because it makes administration of the same mountpoints for many users extremely easy. \r\nIf you don\'t check these options, you must make sure the mount points for the page tree and file folder tree is set specifically for the user.', '', '', '', 'be_users:db_mountpoints,\r\nbe_users:file_mountpoints', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'fileoper_perms', 'Select file operation permissions for the user.', 'These settings relates to the functions found in the File>List module as well as general upload of files.', '', '', '', 'be_users:file_mountpoints', '0', '1011037201');
INSERT INTO sys_tabledescr VALUES ('be_users', 'starttime', 'Enter the date from which the account is active.', '', '', '', '', 'be_users:disable,\r\nbe_users:endtime,\r\npages:starttime', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_users', 'endtime', 'Enter the date from which the account is disabled.', '', '', '', '', 'be_users:disable,\r\nbe_users:starttime,\r\npages:starttime', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_users', 'lang', 'Select the <i>default</i> language.', 'This determines the language of the backend interface for the user. All mainstream parts available for regular users are available in the system language selected. \r\n\'Admin\'-users however will experience that the \'Admin\'-only parts of Typo3 is in english. This includes all submodules in "Tools" and the Web>Template module.\r\n\r\n<B>Notice</b> this is only the default language. As soon as the user has logged in the language must be changed through the User>Setup module.', '', '', '', '', '0', '1011054793');
INSERT INTO sys_tabledescr VALUES ('be_users', 'userMods', 'Select available backend modules for the user.', 'This determines which \'menu items\' are available for the user.\r\n\r\nNotice that the same list of modules may be configured for the backend user groups and that these will be inherited by the user in addition to the modules you select here. It\'s highly likely that you should not set any modules for the user himself but rather select the modules in the backend groups he\'s a member of. However this list provides a great way to add a single module for specific users.', '', '', '', 'be_groups:groupMods', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_users', 'TSconfig', 'Enter additional TSconfig for the user (advanced).', 'This field allows you to extend the configuration of the user in severe details. A brief summary of the options include a more detailed configuration of the backend modules, setting of user specific default table field values, setting of Rich Text Editor options etc. The list will be growing by time and is fully documented in the adminstration documentation, in particular \'admin_guide.pdf\' (see link below).', '', '', '', 'pages:TSconfig,\r\nfe_users:TSconfig,\r\nbe_groups:TSconfig\r\nadmin_guide.pdf|http://www.typo3.com/doclink.php?key=admin_guide.pdf\r\n', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'title', 'Name of the Backend usergroup', '', '', '', '', '', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'db_mountpoints', 'Assign startpoints for the users page tree.', 'The page tree used my all Web-submodules to navigate must have some points-of-entry defined. Here you should insert one or more references to a page which will represent a new root page for the page tree. This is called a \'Database mount\'.\r\nDB mounts may be inherited by the users which are members of this group. This does depend on whether the user is configured to include the mounts set in the member groups. However it\'s recommended to use backend user groups like this to configure mounts. Especially if the need to be shared amoung many users.', '', '', '', 'be_groups:file_mountpoints,\r\nbe_users:db_mountpoints,\r\nbe_users:options\r\n', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'file_mountpoints', 'Assign startpoints for the file folder tree.', 'The file folder tree is used by all File-submodules to navigate between the file folders on the webserver.\r\nNotice as with \'DB mounts\' the file folder mounts may be inherited by the users which are members of this group.', '', '', '', 'be_groups:db_mountpoints,\r\nbe_users:file_mountpoints,\r\nbe_users:options\r\n', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'pagetypes_select', 'Select which \'Types\' of Pages the members may set.', 'This option limits the number of valid choices for the user when he is about to select a page type.', '', '', '', 'pages:doktype,\r\nbe_groups:inc_access_lists', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'tables_modify', 'Select which tables the members may modify.', 'An important part of setting permissions is to define which database tables a user is allowed to modify. \r\nTables allowed for modification is automatically also allowed for selection and thus you don\'t need to set tables entered here in the "Tables (listing)" box.\r\n\r\n<strong>Notice</strong> that this list adds to the fields selected in other member groups of a user.', '', '', '', 'be_groups:tables_select,\r\nbe_groups:inc_access_lists', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'tables_select', 'Select which tables the members may see in record lists (\'modify\' tables does not need to be re-entered here!).', 'This determines which tables - in addition to those selected in the "Tables (modify)" box - may be viewed and listed for the user. He is thus not able to <em>edit</em> the table - only select the records and view the content.\r\nThis list is not so very important. It\'s a pretty rare situation that a user may select tables but not modify them.', '', '', '', 'be_groups:tables_modify,\r\nbe_groups:inc_access_lists', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'non_exclude_fields', 'Certain table fields are not available by default. Those fields can be explicitly enabled for the group members here.', '"Allowed excludefields" allows you to detail the permissions granted to tables. By default all these fields are not available to users but must be specifically enabled by being selected here.\r\nOne application of this is that pages are usually hidden by default and that the hidden field is not available for a user unless he has been granted access by this list of "Allowed excludefields". So the user may create a new page, but cannot un-hide the page. Unless of course he has been assigned the "Page: Hidden" exclude field through one of his member groups.\r\nOf course it does not make any sense to add fields from tables which are not included in the list of table allowed to be modified.', '', '', '', 'be_groups:inc_access_lists', '0', '1011037496');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'hidden', 'Disables a user group.', 'If you disable a user group all user which are members of the group will in effect not inherit any properties this group may have given them.', '', '', '', '', '0', '1011054897');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'lockToDomain', 'Enter the host name from which the user is forced to login.', 'A Typo3 system may have multiple domains pointing to it. Therefore this option secures that users can login only from a certain host name.', '', '', '', 'be_users:lockToDomain,\r\nfe_users:lockToDomain,\r\nfe_groups:lockToDomain', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'groupMods', 'Select available backend modules for the group members.', 'This determines which \'menu items\' are available for the group members.\r\nThis list of modules is added to any modules selected in other member groups of a user as well as the corresponding field of the user himself.', '', '', '', 'be_users:userMods,\r\nbe_groups:inc_access_lists', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'inc_access_lists', 'Select whether Page type, Table, Module and Allowed excludefield access lists are enabled for this group.', '', '', '', '', 'be_groups:pagetypes_select,\r\nbe_groups:tables_modify,\r\nbe_groups:tables_select,\r\nbe_groups:groupMods,\r\nbe_groups:non_exclude_fields\r\n', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'description', 'Enter a short description of the user group, what it is for and who should be members. This is for internal use only.', '', '', '', '', 'fe_groups:description', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'TSconfig', 'Additional configuration through TypoScript style values (Advanced).', '', 'TypoScript style without conditions and constants.', '', '', 'be_users:TSconfig\r\nfe_users:TSconfig\r\nfe_groups:TSconfig\r\npages:TSconfig', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'hide_in_lists', 'This option will prevent the user group from showing up in lists, where user groups are selected.', 'This will affect the list of user groups in the Task Center To-Do and Messages parts as well as the Web>Access module.\r\nThe option is extremely useful if you have general user groups defining some global properties which all your users are members of. Then you would probably not like all those users to \'see\' each other through the membership of this group, for instance sending messages or To-Dos to each other. And this is what is option will prevent.', '', '', '', '', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('be_groups', 'subgroup', 'Select backend user groups which are automatically included for members of this group.', 'The properties or subgroups are added to the properties of this groups and basically they will simply be added to the list of member groups of any user which is a member of this group.\r\nThis feature provides a great way to create \'Supervisor\' user groups.', '', '', '', '', '0', '1011038011');
INSERT INTO sys_tabledescr VALUES ('sys_filemounts', 'title', 'Enter a title for the filemount', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_filemounts', 'path', 'Enter the path of the filemount, relative or absolute depending on the settings of BASE.', 'If BASE is set to relative, the path mounted is found in the subfolder "fileadmin/" of the website. Then you should enter the subfolder in "fileadmin/" as path. For instance if you want to mount access to "fileadmin/user_uploads/all/" then enter the value "user_uploads/all" as the value of PATH.\r\nIf BASE is absolute you should enter the absolute path on the server, eg. "/home/ftp_upload" or "C:/home/ftp_upload". \r\n\r\n<strong>Notice:</strong> In any case, make sure the webserver user which PHP is running as has <em>at least</em> read-access to the path. If not, the mount will simply not appear without any warnings. \r\nIf you have problems - especially with absolute mounts - try to mount something "simple" like a relative path in fileadmin. If that is working well, try the absolute path.\r\n\r\nYour PHP-configuration may also impose other restrictions on you if safe-mode like features are enabled. Then use relative paths.', '', '', '', 'sys_filemounts:base', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_filemounts', 'hidden', 'Use this option to temporarily disable the filemount.', 'All backend users using the mount will not have access anymore. This includes \'Admin\'-users.', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_filemounts', 'base', 'Determines whether the value of the PATH field is to be recognized as an absolute path on the server or a path relative to the fileadmin/ subfolder to the website.', '', '', '', '', 'sys_filemounts:path', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_domain', 'domainName', 'Enter the host name, eg. "www.my-domain.com".', 'Before a domain record will have any effect you must make sure that the domains A-record is pointed towards the server and that your server is setup to direct requests to this Typo3 database. So basically before entering anything here, make sure a request to the domain you wish to enter arrives at the root of the current page tree. \r\nWhen you create a domain record and the host name in it (be it a real domain name or an IP address) matches the hostname of the URL, the TypoScript based front end will limit the available page to only those in the page tree from this point and outwards. In effect you will \'arrive\' at the page where this record is and furthermore users cannot see pages with ids outside this branch.\r\n\r\n<strong>Notice, </strong>if you run Typo3 from a subdirectory of the domain name, you must include the subdirectory as well, eg. "www.my-domain.org/typo3_subdir/"\r\n', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_domain', 'redirectTo', 'All requests to the domain will be redirected to this URL, if any value is entered.', 'Make sure to prepend "http://" or equally to the value! Basically a "Location: " header is just issued to this value!\r\n<strong>Warning:</strong> You cannot use this to \'redirect\' to a specific page id within the same domain as the record has! If you do that it\'ll just go into an endless loop because the redirect is redirecting to itself!\r\n\r\nGood Example:\r\nDomain: "my-domain.org"\r\nRedirect: "www.my-domain.org"\r\n\r\nThis redirects requests to what is infact another domain name, namely "www.my-domain.org"\r\n\r\nBad Example:\r\nDomain: "www.my-domain.org"\r\nRedirect: "www.my-domain.org/?id=10"\r\n\r\nThis will go into an eternal loop because the domain name has in fact not changed!\r\n\r\n\r\nVirtual directories:\r\nIf you\'re using Typo3 on a unix computer you can make \'virtual subdirectories\' to a website, still within the same database. See document list for more information. In that case you should enter the hostname with the subdirectory appended, like this: "my-domain.org/subdir/". If the combination of host name and current subdirectory matches the value, the domain record will be correctly detected and limit page access to the page tree below the Domain record.\r\n', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_domain', 'hidden', 'Use this option to temporarily disable the Domain record.', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_note', 'category', 'Select a category which describes the character of the note.', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_note', 'subject', 'Enter a title for the note.', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_note', 'message', 'This is the note itself.', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_note', 'author', 'Enter your name. ', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_note', 'email', 'Enter your email address.', '', '', '', '', '', '0', '1011038268');
INSERT INTO sys_tabledescr VALUES ('sys_note', 'personal', 'Check this, if you don\'t want other users to see this note.', '', '', '', '', '', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'hidden', 'Use this to temporarily disable the alternative language overlay for this page.', 'Setting this option is practical in the phase of adding the extra language. When it is set, the alternative content will not be displayed unless you - as an logged in backend user - enableds the Admin Panel>Preview>Show hidden records option.', '', '', '', 'pages_language_overlay:starttime,\r\npages_language_overlay:endtime\r\n', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'starttime', 'The \'Start\' time determines the date from which the alternative language will be available online.', '', '', '', '', 'pages_language_overlay:endtime,\r\npages_language_overlay:hidden,\r\npages:starttime', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'endtime', 'The \'End\' time determines the date from which the alternative language will be available online.', '', '', '', '', 'pages_language_overlay:starttime,\r\npages_language_overlay:hidden,\r\npages:endtime', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'title', 'Enter the title of the alternative language.', '', '', '', '', 'pages:title', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'subtitle', 'Enter the subtitle of the alternative language.', '', '', '', '', 'pages:subtitle', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'keywords', 'Enter the keywords of the alternative language.', '', '', '', '', 'pages:keywords', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'description', 'Enter the description of the alternative language.', '', '', '', '', 'pages:description', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'abstract', 'Enter the abstract of the alternative language.', '', '', '', '', 'pages:abstract', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'author', 'Enter the author of the alternative language.', '', '', '', '', 'pages:author', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'author_email', 'Enter the author email address of the alternative language.', '', '', '', '', 'pages:author_email', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'media', 'Enter the media files of the alternative language.', '', '', '', '', 'pages:media', '0', '1011038455');
INSERT INTO sys_tabledescr VALUES ('pages_language_overlay', 'sys_language_uid', 'Select the Alternative Language represented by this record.', '', '', '', '', 'sys_language,\r\nsys_language:title', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 'title', 'Enter the title of the action. This is shown in the list of available actions in the Task Center.', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 'description', 'Describe what the action does or allows to do.', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 'hidden', 'Check this option if you wish to disable the availability of the action or non-admin users.', 'This option is a great way to disable an action during changes made to it because it still allows you as an \'Admin\'-user to activate it for test purposes.', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 'type', 'Select the action type.', '<strong>"Create Backend User"</strong> allows to create backend users with a limited set of options. This action type is meant for semi-administrators among your users which is in charge of daily user administration - still without being full fledged \'Admin\'-users with \'a License to Kill everything\'.\r\nWhen you select this option, you get to enter a \'template\' user, enter a prefix which the new users will automatically have and whether or not a user home-dir is created in the proces. Finally you can select a limited number of usergroups which the can be selected among.\r\n\r\n<strong>"SQL-query"</strong> allows to make a fixed SQL SELECT-query in the database returned as CSV lists. When you have created an action of this type, you need to go to the Tools>DBint module and enter the Advanced Search feature. Here you can design your SQL-query. When you have designed it to select what you want correctly, you can select this action (by it\'s name) and save the query to the action there. From that point it will be effective from the Task Center. (Notice that the form of output selected in the Advanced Search function is also stored, so make sure to select CSV output there!)\r\n', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 'assign_to_groups', 'Select the backend users groups allowed to activate the action in the Task Center.', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 't1_userprefix', 'Enter a prefix which is forcibly prepended to new usernames (eg. "news_")', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 't1_allowed_groups', 'Enter the Backend user groups which the user performing the action is able to choose among (if any).', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 't1_create_user_dir', 'If checked, a private home-directory is also created during user creation. ', '<strong>Notice:</strong> $TYPO3_CONF_VARS["BE"]["userHomePath"] must be configured correctly along with $TYPO3_CONF_VARS["BE"]["lockRootPath"] and writable!', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_action', 't1_copy_of_user', 'Insert a current Backend user which will be used as a template for the new users created. ', 'All values are copied to the new user, except username, password, name and email is of course overridden.\r\nIf the template user is a member of a group which is not defined among the "Groups which may be assigned through the action" that group is still set for the user and cannot be removed by the user carrying out the action.', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'title', 'Enter a title as it will appear in the Task Centers list of To-Do workflows.', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'description', 'Describe the general purpose of the workflow. This will be visible in the To-Do Details view.', '', '', '', '', '', '0', '1011038674');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'hidden', 'Check this to temporarily disable the workflow.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'tablename', 'Enter the table in which the workflow should create a record when it\'s begun.', '<strong>Notice:</strong> The user/group which the workflow task is assigned to should be allowed to work on this table and furthermore have regular edit permissions set up in the Working area. In addition records from this table should be allowed to be created in the Working Area as defined by the Pagetype of the Working Area page.', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'working_area', 'The page where the new records from the above table are created and edited during the workflow process.', '<strong>Notice: </strong>See Workflow / Table description for information about permission setting!\r\n', '', '', '', 'sys_workflows:tablename', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'allowed_groups', 'Backend user groups, allowed to assign the workflow to other users through To-Do items.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'target_groups', 'Backend user groups to which, this workflow can be assigned.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'review_users', 'Review users (first is default) which should review items before they are finalized by the owner.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_unhide', 'If you want the workflow to un-hide the record attached when the workflow is finalized, set this option.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_set_perms', 'If you want page permissions to be changed when the workflow is finalized, set this option (Only if the Table is "Page").', 'When you set this option it makes sense only if the table operated on by the workflow is "Page" because only pages has the permission fields. However it does no harm if the table is not "Page" - it just does not make sense.\r\nWhen the option is set, save the record and then you can set the permissions afterwards.', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_target', 'Target page to which the record is moved when the workflow is finalized.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_perms_userid', 'Insert the owner Backend user.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_perms_groupid', 'Select the owner Backend usergroup.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_perms_user', 'Enter page permissions for the Backend user.', '', '', '', '', '', '0', '1011038883');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_perms_group', 'Enter page permissions for the Backend usergroups.', '', '', '', '', '', '0', '1011039065');
INSERT INTO sys_tabledescr VALUES ('sys_workflows', 'final_perms_everybody', 'Enter page permissions for Everybody (all Backend users).', '', '', '', '', '', '0', '1011039065');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'CType', 'Select the kind of page content this element represents. New options will appear when you save the record.', 'The \'Type\' of content you select determines which options you have in the editform, so make sure to save the record before you make changes.\r\n\r\nThis is a description of the various types:\r\n\r\n<strong>Header</strong>\r\nThis type allows you insert a standard content element header and nothing more. \r\nAlmost all the other types described below also includes the header with the exact same options. So the Header type just provides a way to insert a header <em>only</em> without anything else.\r\n\r\n<strong>Text</strong>\r\nThe Text type allows you to insert regular page content.\r\n\r\n<strong>Text w/image</strong>\r\nThis is the same as the Text type (regular page content) but with the option of attaching images.\r\n\r\n<strong>Rich Text</strong>\r\nThis type makes sense only if you\'re using the Rich Text Editor which allows you to format text with a toolbar as you know from eg. the Word textprocessor. Although you have the same options with the Text and Text w/image types, the Rich Text type offers you a few more features in the toolbar, for instance a table editor.\r\n<strong>Notice</strong> that the content made with the Rich Text editor is <em>not</em> preprocessed by any means and thus this is basically a WYSIWYG HTML editor.\r\n\r\n<strong>Image</strong>\r\nThe same as Text w/image but without the text field - so only images.\r\n\r\n<strong>Bullet list</strong>\r\nLets you create a bullet list. Each line in the text-field will appear as a single line in the bulletlist.\r\n\r\n<strong>Table</strong>\r\nLets you create <em>simple</em> tables. Each line represents a tablerow and vertical bars \'|\' separates each column.\r\n\r\n<strong>Filelinks</strong>\r\nAllows you to present a list of files for download. You can have thumbnails attached to the list including filesize.\r\n\r\n<strong>Multimedia</strong>\r\nLets you insert multimedia elements such as sound, video, java applets and flash animations.\r\n\r\n<strong>Form</strong>\r\nLets you create mail forms. There is a special syntax to use when you wish to create form fields.\r\n\r\n<strong>Search</strong>\r\nThis inserts a search box and it will also display the search result if a query is performed to the page.\r\n\r\n<strong>Login</strong>\r\nDisplays a login box for website users. You must create at least one Website user and user group before this makes any sense to use.\r\n\r\n<strong>Textbox</strong>\r\nThis is mainly for customly defined design which includes typically some text and an image. So in other words the function is not generally defined. However the default subtypes will let you choose various ways to display some text with an image.\r\nUse only if instructed to.\r\n\r\n<strong>Menu/Sitemap</strong>\r\nOffers a selection of various link menus and a sitemap you can insert on a page.\r\n\r\n<strong>Insert records</strong>\r\nThis is a placeholder for other records. In other words, by this element you can attach other content elements from elsewhere and thus insert them this page.\r\n\r\n<strong>Insert module</strong>\r\nThis will allow you to insert a forum, guestbook, list of addresses, shopping basket etc. The various features are available <em>only</em> if they are configured correctly in the template of your website. So before you use it, make sure this is the case.\r\n\r\n<strong>Script</strong>\r\nThis is reserved for custom purposes where the template developer can allow you to insert specialized page content by this element type along with a code to identify which special content you want.\r\n\r\n<strong>HTML</strong>\r\nThis is plain HTML content. Everything put here will be displayed directly on the page without any preprocessing.\r\n', '', '', '', 'tt_content:colPos,\r\ntt_content:sys_language_uid', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'hidden', 'Check this box if you wish to hide the content element from being displayed.', '', '', '', '', 'tt_content:starttime,\r\ntt_content:endtime,\r\ntt_content:fe_group,\r\ntt_content:colPos,\r\ntt_content:sys_language_uid\r\n', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'starttime', 'Enter the date from which the content element will be visible.', '', '', '', '', 'pages:starttime,\r\ntt_content:endtime,\r\ntt_content:hidden,\r\ntt_content:fe_group\r\n', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'endtime', 'Enter the date from which the content element will disappear from the website.', '', '', '', '', 'pages:endtime,\r\ntt_content:starttime,\r\ntt_content:hidden,\r\ntt_content:fe_group\r\n', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'fe_group', 'Select a Website usergroup which is exclusive allowed to view the element.', 'The options in this box depends on which Website usergroups are created and available for you. When you select a user group here, the content element will no longer be visible to users which are not logged in. Only Website users which are logged in and members of the group you selected will be allowed to see the element.\r\nIf you select "Hide at login" the effect is kind of reversed in that the element <em>disappears</em> if <em>any</em> Website user is logged in. This is useful if you want to present information like "How to login" and such which is irrelevant if a user is finally logged in.\r\n', '', '', '', 'tt_content:hidden,\r\ntt_content:starttime,\r\ntt_content:endtime,\r\npages:fe_group', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'sys_language_uid', 'Select the system language of this element. <strong>Notice</strong> this will affect whether the element is visible.', 'This allows you to assign a specific language to the content element. If you select anything but the default value, the element will <em>not</em> be visible unless the language assigned is also configured by the TypoScript template. \r\nThe available system languages are created by the administrator.', '', '', '', 'tt_content:colPos', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'layout', 'Select a layout. ', 'This option is not used in the default templates but may be used by any custom rendering.\r\n\r\nThere are a number of default implementations depending on the content element type:\r\n\r\n<B>"Filelinks":</B>\r\n"Normal" will provide a list of filelinks with no thumbnail.\r\n"Layout 1" adds a file icon to the left of the link\r\n"Layout 2" adds a thumbnail if the file is an image file and if not an icon. A black border is wrapped around.\r\n"Layout 3" is like Layout 2, but without the black border.\r\n\r\n<B>"Insert list" / Board</B>\r\nThere are two built-in board types in Typo3, the one is a List board and the other a Tree board. The List board is inserted by the "Normal" layout type while the "Tree" board is inserted by the "Layout 1". <i>Be aware of this fact! Nothing will show up if you select the wrong type!</i>\r\n', '', '', '', '', '0', '1011447548');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'colPos', 'Select the column position this element. <strong>Notice</strong> this will affect whether the element is visible.', 'Most websites use only one column of content. However some templates lets you put content in multiple columns and this option allows you to select another column for the element.\r\n\r\n<strong>Notice</strong> that selecting another column than "Normal" will make the content element disappear unless that column is also displayed in the website template. If your content element is \'strangely\' not visible please make sure the Column and Language selectors are set correctly.', '', '', '', 'tt_content:sys_language_uid', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'date', 'Enter a date to be displayed above the header.', '', 'For syntax, see Pages / Start below.', '', '', 'pages:starttime', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'header', 'Enter a headline for the content element.', 'Almost all content elements (except the HTML type for instance) will display this header above the content. If you don\'t want a header displayed, select the header Layout to "Hidden". Alternatively you can choose not to enter any content in this field.\r\n\r\nSome content element types do not display the header by default. In those cases the Header field is typically labeled "Name" instead. One of these are the HTML type content element.', '', '', '', 'tt_content:header_position,\r\ntt_content:header_link,\r\ntt_content:header_layout,\r\ntt_content:date', '0', '1011040990');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'header_position', 'Places the header to the left, centered or to the right.', '', '', '', '', 'tt_content:header', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'header_link', 'Creates a link from the header. Insert a page id, email address or URL.', '', 'If you insert an id-number, eg. "51", the link will refer to page with id=51 <em>inside</em> Typo3.\r\nIf you insert an email address, eg. "name@my-domain.test", the link will point to that email address.\r\nIf you insert an URL or domain, eg. "www.typo3.com" or "http://www.my-domain.org", the link will point to that website.\r\n', '', '', 'tt_content:header', '0', '1011039113');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'header_layout', 'Select a visual design for the header.', 'If you select "Default" the standard design (which is one of the layouts 1-5) will be used. \r\nAlternatively you can select from Layout 1 through 5 which are configured in the website template with individual visual designs.\r\nIf you select "Hidden" the header will simply not appear. This is usefull if you wish a header for the content element (in order to identify it in the backend) but do not wish the header to be displayed on the website.\r\n', '', '', '', 'tt_content:header', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'subheader', 'Enter a subheader. This is displayed below the ordinary headline. If the content element type is "Form" this field is the recipient email.', 'A subheader is displayed only with the "Header" content element type.\r\n\r\n<B>Notice:</B> When using the content element type "Form", this field is named \'Recipient-email:\' and contains the email address of the form mail recipient. It\'s therefore important to allow access to this field for the users.', '', '', '', 'tt_content:header\r\ntt_content:bodytext\r\n', '0', '1018531684');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'bodytext', 'Enter the body text.', 'Here you enter the body text of the content element. Usually you can use some HTML formatting tags, if you\'re using Internet Explorer you can even format the content visually.\r\nThe field is reused in most other types and so switching between the content element types will bring the value of this field with it.\r\n\r\nWhen you\'re using this field with the "Text" and "Text w/image" types, the content is used as ordinary body text. Each linebreak signifies a new paragraph, you can use the special Typo3 tags, &lt;LINK&gt;, &lt;TYPOLIST&gt;, &lt;TYPOHEAD&gt; and &lt;TYPOCODE&gt;. The &lt;TABLE&gt; element is one of the only HTML-elements you cannot use though.\r\n\r\nIf the type is "Bulletlist" each line in this field is a bulletlist entry.\r\n\r\nIf the type is "Table" each line represents a table row. Within each line you divide the columns by inserting a vertical bar, |. So making a table row with 3 columns could look like "This is column 1 | Column 2 here | Third column!"\r\n\r\nTypes like "Script", "Mailform" and "Multimedia" uses this field for parameters you can pass to the element. And the "HTML" type accepts any input as raw HTML which is simply displayed on the website without any preprocessing.\r\n\r\n<strong>Rich Text Editor:</strong>\r\nWith the types "Text", "Text w/image" and "Rich Text" the Rich Text editor is used when Internet Explorer is used for editing (provided that the editor is generally enabled in the system). Be aware that the content is "cleansed" before it goes into the database when you\'re using the "Text" and "Text w/image" types. The "Rich Text" type pretty much passes it through without any interaction.\r\n\r\n<b>Making a mail form:</B>\r\nWhen you have selected the content element type "Form" you should enter lines of parameters into this field. This is a brief example:\r\n\r\n<nobr>\r\nYour name: | *name=input,40 | [Enter name!]\r\nYour email: | *email=input,40\r\nYour address: | address=textarea,40,10\r\nYour haircolor: |hair=radio|Blue=blue, Red=red\r\n\r\n|formtype_mail = submit | Send form\r\n|subject=hidden| Enter a subject here!\r\n|html_enabled=hidden | 1\r\n</nobr>\r\n\r\nThe first two lines makes input-fields for name and email, both are marked "required" by the * and the name field has a default value of "[Enter name!]".\r\nThe third line is a text box and the fourth makes radiobuttons to select haircolor.\r\nThen there are three important lines in the end. The first makes a submit button with the label "Send form", the second line is the subject of the email the receiver gets and the third line makes the form result render in an HTML-table.\r\n<B>Notice:</B> Before any form will ever work, you must enter a recipient email address. The "Recipient-email:" field is used for that (this is in fact the Subheader field used!).\r\n', '', '', '', 'tt_content:CType,\r\ntt_content:rte_enabled,\r\ntt_content:text_align,\r\ntt_content:text_face,\r\ntt_content:text_size,\r\ntt_content:text_color,\r\ntt_content:text_properties\r\ntt_content:subheader', '0', '1011446865');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'text_align', 'Places the body text to the left, centered or to the right.', 'See Pagecontent / Fontface for comments.', '', '', '', 'tt_content:text_face,\r\ntt_content:bodytext', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'text_face', 'Select a font fact family for the body text.', '<strong>Notice</strong> that these options are only meant for special design. The general (default) design should be configured in the template instead. Furthermore you should NOT use these options if your template implements stylesheets and are based on using styles in general.', '', '', '', 'tt_content:text_face,\r\ntt_content:bodytext', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'text_size', 'Select a font size for the body text.', 'See Pagecontent / Fontface for comments.', '', '', '', 'tt_content:text_face,\r\ntt_content:bodytext', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'text_color', 'Select a color for the body text.', 'See Pagecontent / Fontface for comments.', '', '', '', 'tt_content:text_face,\r\ntt_content:bodytext', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'text_properties', 'Select additional font properties.', 'These options will select font properties for all the body text. However you may wish to mark only a part of the bodytext as bold or underline in which case you should use the formatting options in the Rich Text Editor. Alternatively you can use the HTML tags here:\r\n\r\n&lt;B&gt;<strong>This is bold</strong>&lt;B&gt;\r\n&lt;I&gt;<strong>This is italics</strong>&lt;I&gt;\r\n&lt;U&gt;<strong>This is underlined</strong>&lt;U&gt;\r\n\r\nSee Pagecontent / Fontface for comments.\r\n', '', '', '', 'tt_content:text_face,\r\ntt_content:bodytext', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image', 'Insert one or more images.', 'You can attach images to the content element almost as many as you like here. \r\nDepending on the configuration of Typo3 you can even attach them in any format you like. Especially you do not need to worry about size and compression because these factors are normally handled by Typo3 internally.\r\n\r\nWhen you use the "Text w/image" type, it\'s important to select a proper position of the imageblock. For this purpose, use the Position selector which is displayed below (or if you click in the image list field in the Classic backend). See link to Pagecontent>Position below.\r\nYou can also display images in multiple columns and enable an option which enables a link so you can click the image and see a bigger version. Just to name a few options. \r\nMost likely you don\'t have all options available. This depends on your permissions in the system.\r\n', '', '', '', 'tt_content:imagewidth,\r\ntt_content:imageheight,\r\ntt_content:imageorient,\r\ntt_content:imageborder,\r\ntt_content:image_noRows,\r\ntt_content:image_link,\r\ntt_content:image_zoom,\r\ntt_content:imagecols,\r\ntt_content:imagecaption,\r\ntt_content:image_effects,\r\ntt_content:image_frames,\r\ntt_content:image_compression,\r\nUser manual | http://www.typo3.com/Images.1072.0.html\r\n', '0', '1011041323');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imagewidth', 'Enter the width in pixels of the image.', 'The template is normally configured to a max width of an image and so you don\'t need to specify the width if the image fits perfect into those dimensions. However this does give you an opportunity to specify a specific width.', '', '', '', 'tt_content:imageheight, \r\ntt_content:image', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imageheight', 'Enter the height of the image in pixels.', '', '', '', '', 'tt_content:imagewidth, \r\ntt_content:image\r\n', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imageorient', 'Select the position of the imageblock relative to the body text.', 'The position above and below the body text is pretty straight forward.\r\nThe options "In text" means that the image block is displayed with text aside it. When you select this option the template will probably force the images into smaller dimensions because they cannot take up the same space when text is supposed to float around them.\r\nWhen you select "In text" you can choose the options either above or below the divider "No wrap". If you select the "In text" option above, the bodytext will float <em>under</em> the image block when the bodytext reaches the end of the image block. So in other words the body text <em>wraps around</em> the image block. If you select "In text" below the "No wrap" divider, the body text will not float under the image block, but simply continue in it\'s column.\r\nApart from the visual difference there is a technical aspect as well. Because if you choose to allow the content to wrap the image block you will experience a strange phenomenon when you do not have enough bodytext to make it float around the image: You experience that the subsequent content elements on the page is somehow layered on top of the image block - and this certainly looks like a bug. However it\'s easily solved by changing the "In text" position to the equal value but below the "No wrap" divider.\r\n', '', '', '', '', '0', '1011039392');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imageborder', 'Check this, if you wish a colored border around the images.', '', '', '', '', 'tt_content:imagecols,\r\ntt_content:image', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image_noRows', 'Disables strict tablerows in the image block.', 'This options is kinda hard to explain, but image you have 2 or more columns <em>and</em> rows of images. If one image in the upper row is a bit taller than the second this will generate an empty extra space beneath the second image. This is due to the normal procedure in which the images are placed in a table cell each.\r\nIf you set this option, the table will place all images in a column in a single table cell which make the distance between them vertically identical throughout. This may provide a better look it the alternative looks stupid.\r\n', '', '', '', 'tt_content:imagecols, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image_link', 'Enter a link for the images. ', 'By default all images share the same link. However you may ask the administrator to configure the TypoScript template to allow a separate link for each image. If this is the case, you simply separate the link values by a comma.\r\n\r\nSee Pagecontent>Link below for details on syntax.\r\n', '', '', '', 'tt_content:header_link,\r\ntt_content:image_zoom, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image_zoom', 'Check this option, and the image will link to a new window with a bigger version.', 'This option overrides the value in the Link-field.', '', '', '', 'tt_content:image_link, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image_effects', 'Select special image processing effects.', '', '', '', '', 'tt_content:image_compression,\r\ntt_content:image_frames, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image_frames', 'Select special image framing options.', '', '', '', '', 'tt_content:image_compression,\r\ntt_content:image_effects, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'image_compression', 'Select compression/quality options.', '', '', '', '', 'tt_content:image_frames,\r\ntt_content:image_effects, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imagecols', 'Select the number of columns in the image block.\r\n', '', '', '', '', 'tt_content:image_noRows, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imagecaption', 'Enter a caption for the image block\r\n', 'By default the caption is positioned below the whole image block. However your website template may be configured to allow indidual image captions. In that case each line in this field will be the image caption of the corresponding image in the list.\r\n\r\nThe caption text field is also used by the content element type "Filelinks" where each line represents a description of a file in the list.', '', '', '', 'tt_content:imagecaption_position, \r\ntt_content:image\r\n', '0', '1011447282');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'imagecaption_position', 'Places the image caption to the left, centered or to the right.', '', '', '', '', 'tt_content:imagecaption, \r\ntt_content:image\r\n', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'cols', 'Select a fixed number of table columns', '', '', '', '', '', '0', '1011039695');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'pages', 'Insert page(s)\r\n', 'With this field you can generally create a relation to a page (or more) in Typo3. This field is used by many of the content element types. If you don\'t specify a page here, the current page will generally be used.\r\n\r\nUsing the "Search" type, the page you insert will be the page to which the search is targeted. You must make sure that this page has a similar "Search" content element (or something similar) to render a search result. Else it makes no sense.\r\n\r\nThe "Login" type content element also uses this field to direct the login to a certain page. However that page does not need to contain a Login content element in order to perform the authentication - you can in fact submit a login request to any Typo3 page and it will be evaluated! \r\nIf you specify a second page in this list, the id will be passed to the login system as being the page inside Typo3 where the database of users to look up is found. You should use this only if your template is not configured to pass this value on.\r\nIn order for the login procedure to work, you must make sure that 1) you have created at least one Website user and member usergroup and is using the correct username and password, 2) you have configured in your TypoScript template on which page (typically a SysFolder) the users can be found - or alternatively have specified this by the second page in the this page list, 3) cookies must be enabled.\r\n\r\nThe "Menu/Sitemap" element also uses this field. In that case the page(s) will determine from which point the menu is drawn or maybe even represent the actual pages to which the menu links. All this depends on the subtype of Menu/Sitemap you have selected.\r\n\r\nFinally the "Form" element uses this field as the page to which the form is submitted. You might thus insert a page which is the "Thank you" page of the form mail. ', '', '', '', 'tt_content:CType, \r\ntt_content:recursive\r\n', '0', '1011447055');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'recursive', 'Select how many subleves should be additionally selected for each page in the list.', 'Whether this feature makes sense or not depends solely on the template implementation and/or content element type. But basically if this feature is enabled it means that for each page listed in the "Send to page/Starting point" box subpages - to the depth specified here - will <em>also</em> be selected!\r\n\r\n<strong>Warning:</strong> If there are many subpages, be aware of this option. It may select an incredible amount of pages then!\r\n', '', '', '', 'tt_content:pages', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'menu_type', 'Select which kind of menu you wish to create.', 'This is a short description of each type:\r\n\r\n<strong>Menu of these pages</strong>\r\nThis will create a list of links to the pages you insert in the Startingpoint list.\r\n\r\n<strong>Menu of subpages to these pages</strong>\r\nThis results in a list of links to the subpages of the pages in the Startingpoint list. If you do not specify a startingpoint, subpages to the current page will be selected.\r\n\r\n<strong>Menu of subpages to these pages (with abstract)</strong>\r\nLike the previous, but this will include the content of the Abstract field of the pages.\r\n\r\n<strong>Menu of subpages to these pages + sections</strong>\r\nLike the previous, but including \'submenu\' links to all content elements on the page which has the "Index" checkbox set.\r\n\r\n<strong>Sitemap</strong>\r\nGenerates a classic tree sitemap. Maybe your TypoScript template is configured to another design of the sitemap, but anyhow you\'ll get a sitemap out of this. Notice that the sitemap will begin from the current page unless you specify another "Startingpoint" page in the list below.\r\n\r\n<strong>Section index (pagecontent w/Index checked)</strong>\r\nThis makes a menu to the content elements on this page (or the page specified in the Starting point list). Great way to make an index in the top of the page.\r\nNotice that all content elements with the "Index" checkbox set is selected. So if you don\'t want certain content elements to appear in the list, just un-check the Index checkbox for those elements.\r\n\r\n<strong>Recently updated pages</strong>\r\nThis displays the 10 most recently updated pages. \r\n<strong>Notice:</strong> If you update a page and this list seems not to be updated instantly, just clear the cache of the page and the problem is solved.\r\n\r\n<strong>Related pages (based on keywords)</strong>\r\nDisplays other related pages based on the keywords set for this pages matched up with the keywords on other pages.\r\n\r\n\r\nNotice: With many of the above menu types, the default starting point is the current page. However you can specify another startingpoint (or more than one in fact!) by adding pages to the the "Startingpoint" list. See link below.\r\n', '', '', '', 'tt_content:pages,\r\ntt_content:sectionIndex', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'list_type', 'Select a module to insert (Availability depends on the template).', 'It\'s very important that you recognize the need to also install the particular module in the TypoScript template of the website. This is done by the administrator. But when a module is first introduced in the template and configured correctly, then the "Insert module" content element type is used to insert the modules function on the right page on your website. This is a very flexible way to do it, because you determine all by yourself where you want your guestbook, forum, list of shopping items and so on.\r\nBut first make sure which modules are available to you!\r\n\r\nThis is a description of the options:\r\n\r\n<strong><u>LISTS:</u></strong>\r\n(Generally this subdivision of options is about listing records on the page).\r\n\r\n<strong>Guestbook:</strong>\r\nLists the guestbook records on the page. Notice that you\'ll have to insert a special code in the CODE field in order to activate the guestbook. But there will be an explanation displayed when you insert the module without any code.\r\n\r\n<strong>Board:</strong>\r\nLists the discussion board records or list of forums on the page. This depends on the CODE field content. There will be an explanation displayed when you insert the module without any code.\r\n\r\n<strong>Products:</strong>\r\nLists products (or shop items) on the page. Alternatively it inserts the shopping basket or a search form. This all depends on the content of the CODE field. There will be an explanation displayed when you insert the module without any code.\r\n\r\n<strong>News:</strong>\r\nLists news items teasers, extensive list or whole items. This depends on the CODE field content. There will be an explanation displayed when you insert the module without any code.\r\n\r\n<strong>Addresses:</strong>\r\nLists the address records found on the page. \r\n\r\n<strong>To-Do:</strong>\r\nNo default rendering. Must be custom made.\r\n\r\n<strong>Calendar:</strong>\r\nNo default rendering. Must be custom made.\r\n\r\n<strong>Links:</strong>\r\nNo default rendering. Must be custom made.\r\n\r\n\r\n<strong>MODULES:</strong>\r\n\r\n<strong>Rating:</strong>\r\nInserts a rating element on the page.\r\n\r\n<strong>Indexed search:</strong>\r\nInserts a search dialog and result page for the Indexed Searching Engine.\r\n\r\n<strong>Tip-a-friend:</strong>\r\nInserts a link (or form display) to the "Tip-a-friend" feature. There will be an explanation displayed when you insert the module without any code.\r\n\r\n<strong>ADMINISTRATION:</strong>\r\n\r\n<strong>Frontend User administration:</strong>\r\nInserts an editing form for creating and maintenance of frontend users of a website. \r\n\r\n<strong>DirectMail subscription:</strong>\r\nInserts an editing form for subscription and maintenance of subscription for Direct Mail recipients. This is not limited to the Direct Mail feature but can just as well be used to enable an online addresslist where every entry maintains his own record through this. \r\nBasically it just allows access to the Address table in Typo3.\r\n\r\n\r\nThe "Startingpoint" is used with some of the above options to designate from which page records are selected. If you do not enter a starting point, the current page is usually used.\r\n', '', '', '', 'tt_content:select_key', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'select_key', 'Enter a code string.\r\n', 'Whether or not the content of this field is used and how it\'s intepreted depends on the context. \r\n', '', '', '', 'tt_content:list_type', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'table_bgColor', 'Select table background color.', '', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'table_border', 'Select table border thickness.', '', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'table_cellspacing', 'Select table cell spacing.', 'Cell spacing is the distance between table cells in rows an columns. The distance is equally applied in all directions, top, bottom, left and right.', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'table_cellpadding', 'Select table cellpadding.', 'Cell padding is the \'internal\' margin of a table cell. The distance is equally applied in all directions, top, bottom, left and right.', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'media', 'Add files to the list here.', '', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'multimedia', 'Insert the multimedia element, eg. a flash movie here.', '', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'filelink_size', 'Check this, if you wish the filesizes to be displayed.', '', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'records', 'Insert relations to records.', '', '', '', '', '', '0', '1011040060');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'spaceBefore', 'Enter the amount of whitespace (in pixels) to insert <em>before</em> this content element.', '', '', '', '', 'tt_content:spaceAfter,\r\ntt_content:section_frame\r\n', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'spaceAfter', 'Enter the amount of whitespace (in pixels) to insert <em>after</em> this content element.', '', '', '', '', 'tt_content:spaceBefore,\r\ntt_content:section_frame\r\n', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'section_frame', 'Select a framing option for the content element.', '', '', '', '', 'tt_content:spaceAfter,\r\ntt_content:spaceBefore', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'splash_layout', 'Select the design for the Text box.', '<strong>Notice:</strong> The Textbox type has a few default renderings but are primarily designed to be used for custom purposes. Therefore the availability of features will depend on the current website template.\r\n', '', '', '', 'tt_content:CType', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'sectionIndex', 'If set, the content element will appear in section indices.', 'See details for the Menu-type selector (click below).', '', '', '', 'tt_content:menu_type', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'linkToTop', 'If checked, a little "To top" link will be inserted after the content element.', '', '', '', '', '', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('tt_content', 'rte_enabled', 'If checked, the Rich Text Editor will be disabled for the "Text" and "Text w/Image" types (<em>in this element only</em>).', '', '', '', '', 'tt_content:bodytext', '0', '1011040218');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', '', 'Represents actual static HTML files on the server which has editable parts in them. Through these records you edit those parts of content.', 'When you create a record in this table, you must enter a filename from a certain path relative to the path of the site root. By default the files must be located in the fileadmin/static/ folder.\r\nThe main content field of this record is used to edit the content of a certain section in the HTML file defined for the record. The section is delimited by two markers (default markers are \'###TYPO3_STATICFILE_EDIT###\') and then the record content is saved to the database, it\'s also written to the file, substituting the original content between the markers. \r\nThe fact that the content is also saved to the database plays no role. The important thing is that the file is updated.', '', '', '', 'sys_staticfile_edit:edit_file\r\nsys_staticfile_edit:edit_subpart_marker\r\nsys_staticfile_edit:edit_content\r\n', '0', '1011373969');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', 'edit_file', 'Filename of the static file being edited.', 'The filename should be relative to the path configured in $TYPO3_CONF_VARS[BE][staticFileEditPath]. This path is by default \'fileadmin/static/\'. \r\nYou may enter a subpath, eg. "mainfiles/scheme.html" which will in turn be a request for the file "fileadmin/static/mainfiles/scheme.html".', '', '', '', 'sys_staticfile_edit:edit_content\r\nsys_staticfile_edit:edit_subpart_marker', '0', '1011373969');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', 'edit_content', 'This is the content from the section in the static file. Edit, save, and the static file is updated instantly.', '', '', '', '', 'sys_staticfile_edit:edit_file\r\nsys_staticfile_edit:always_reload\r\nsys_staticfile_edit:update_status\r\n', '0', '1011373969');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', 'edit_subpart_marker', 'Alternative subpart marker.', 'By default the content edited in the HTML-file is encapsulated in so called markers. You may specify a marker within an HTML comment tag which is definitely the most smart thing to do, because your marker will not be visible then.\r\nThe default marker is \'###TYPO3_STATICFILE_EDIT###\' which means that your HTML-file should have at least one section that looks in principle like this:\r\n\r\n&lt;!-- ###TYPO3_STATICFILE_EDIT### begin --&gt;\r\n\r\n&lt;strong&gt;Hello World&lt;/strong&gt;\r\n\r\n&lt;!-- ###TYPO3_STATICFILE_EDIT### end --&gt;\r\n\r\nThe content \'Hello world\' with tags is the content being edited by this record and it\'s the markers that are responsible for defining this area!\r\n\r\nSo if you specify the value BUTTERFLY as the value of this field, your subpart markers should look like:\r\n\r\n&lt;!-- BUTTERFLY begin --&gt;\r\n\r\n&lt;strong&gt;Hello World&lt;/strong&gt;\r\n\r\n&lt;!-- BUTTERFLY end --&gt;\r\n\r\n<B>Notice:</B> As you might have realized, it\'s important to pick a subpart marker which does NOT by any chance appear in the bodytext field. BUTTERFLY is not a good example. As string like ###NONSENSE_kdo8u3ksi### is far better. \r\n\r\nThe reason why you can specify this alternative marker is if you for instance wants to define more than one editable section in an HTML-file. Then you\'ll have to define it with separate markers.\r\n', '', '', '', '', '0', '1011374023');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', 'always_reload', 'If checked, the content being edited will always be reloaded from the actual file and not the record.', 'By this you are guarantee that if somebody else has edited the file externally, you\'ll not override those changes but rather continue working on them.', '', '', '', 'sys_staticfile_edit:edit_content', '0', '1011373969');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', 'update_status', 'Contains the latest status of the file update.', 'This field is not editable. It just contains an update message which lets you know how well the operation went.', '', '', '', '', '0', '1011373969');
INSERT INTO sys_tabledescr VALUES ('sys_staticfile_edit', 'rte_enabled', 'If checked, the Rich Text Editor will be disabled in this record.', '', '', '', '', 'tt_content:rte_enabled', '0', '1011432393');
INSERT INTO sys_tabledescr VALUES ('_MOD_web_layout', 'quickEdit', 'The Quick Editor gives you direct access to the form fields of the page content.', 'The Quick Editor is designed to cut down the number of clicks involved in getting to edit the page content. Simply by clicking the page title in the page tree you\'ve got the first content element in the normal column loaded in the list frame. In the toolbar in the top you can select the other content elements on the page in the selector box.', '', '', '', '', '0', '1017229583');
INSERT INTO sys_tabledescr VALUES ('_MOD_web_layout', '', '', '', '', '', '', '', '0', '1017229583');
INSERT INTO sys_tabledescr VALUES ('_MOD_web_layout', 'quickEdit_selElement', 'This is an overview of the content elements on this page. Select another element to edit or click an "New" icon to create a new content element.', '', '', '', '', '', '0', '1018887100');
INSERT INTO sys_tabledescr VALUES ('_MOD_web_layout', 'columns', 'By the "Columns" view you can control the content of the web page as it is positioned in columns.', '', '', '', '', '', '0', '1018887100');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_shy', 'If set, the extension will normally be hidden in the EM because it might be a default extension or otherwise something which is not so important.', 'Use this flag if an extension is of rare interest (which is not the same as un-important - just an extension not sought for very often...)\r\nIt does not affect whether or not it\'s enabled. Only display in EM.\r\nNormally shy is set for all extensions loaded by default according to TYPO3_CONF_VARS.', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_category', 'Which category the extension belongs to.', '<b>be:</b> Backend (Generally backend oriented, but not a module) \r\n\r\n<b>module:</b> Backend modules (When something is a module or connects with one)\r\n\r\n<b>fe:</b> Frontend (Generally frontend oriented, but not a true plugin)\r\n\r\n<b>plugin:</b> Frontend plugins (Plugins inserted as a Insert Plugin content element) \r\n\r\n<b>misc:</b> Miscellaneous stuff (Where not easily placed elsewhere)\r\n\r\n<b>example:</b> Example extension (Which serves as examples etc.)', '', '', '', '', '0', '1024929174');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_dependencies', 'This is a list of other extension keys which this extension depends on being loaded BEFORE it self.', 'The EM will manage that dependency while writing the extension list  to localconf.php', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_conflicts', 'List of extension keys of extensions with which this extension does not work (and so cannot be enabled before those other extensions are un-installed)', '', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_priority', 'This tells the EM to try to put the extensions as the very first in the list. Default is last.', '', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_module', 'If any subfolders to an extension contains backend modules, those foldernames should be listed here.', 'It allows the EM to know about the existence of the module, which is important because the EM has to update the conf.php file of the module in order to set the correct TYPO3_MOD_PATH  constant.', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_state', 'Which development state the extension is in.', '<b>alpha</b>\r\nVery initial development. May do nothing at all. \r\n\r\n<b>beta</b>\r\nUnder current development. Should work partly but is not finished yet.\r\n\r\n<b>stable</b>\r\nStable and used in production.\r\n\r\n<b>experimental</b>\r\nNobody knows if this is going anywhere yet... Maybe still just an idea.\r\n\r\n<b>test</b>\r\nTest extension, demonstrates concepts etc.', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_internal', 'This flag indicates that the core source code is specifically aware of the extension.', 'In order words this flag should convey the message that this extension could not be written without some core source code modifications.\r\n\r\nAn extension is not internal just because it uses Typo3 general classes eg. those from t3lib/. \r\nTrue non-internal extensions are characterized by the fact that they could be written without making core source code changes, but relies only on existing classes  in Typo3 and/or other extensions, plus its own scripts in the extension folder.', '', '', '', '', '0', '1024929416');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_clearCacheOnLoad', 'If set, the EM will request the cache to be cleared when this extension is installed.', '', '', '', '', '', '0', '1024929229');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_modify_tables', 'List of tablenames which are only modified - not fully created - by this extension.', 'Tables from this list found in the ext_tables.sql file of the extension ', '', '', '', '', '0', '1024921752');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', '', 'The Extension Manager', 'Typo3 can be extended in nearly any direction without loosing backwards compatibility. The Extension API provides a powerful framework for easily adding, removing, installing and developing such extensions to Typo3. This is in particular powered by the Extension Manager (EM) inside Typo3.\r\n\r\nExtensions is a term in Typo3 which covers two other terms, plugins and modules.\r\n\r\nA plugin is something that plays a role on the website itself. Eg. a board, guestbook, shop etc. It is normally enclosed in a PHP class and invoked through a USER or USER_INT cObject from TypoScript. A plugin is an extension in the frontend.\r\n\r\nA module is a backend application which has it\'s own position in the administration menu. It requires backend login and works inside the framework of the backend. We might also call something a module if it exploits any connectivity of an existing module, that is if it simply adds itself to the function menu of existing modules. A module is an extension in the backend.', '', '', '', '', '0', '1024929928');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_private', 'If set, this version is not shown in the public list in the online repository.', '"Private" uploads requires you to manually enter a special key (which will be shown to you after an upload has been completed) to be able to import and view details for the uploaded extension.\r\nThis is nice when you are working on something internally which you do not want others to look at.\r\nYou can set and clear the private flag every time you upload your extension.', '', '', '', '_MOD_tools_em:emconf_download_password', '0', '1024923605');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_download_password', 'Additional password required for download of private extensions.', 'Anybody who knows the "special key" assigned to the private upload will be able to import it. Specifying an import password allows you to give away the download key for private uploads and also require a password given in addition. The password can be changed later on.', '', '', '', '_MOD_tools_em:emconf_private', '0', '1024923605');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_type', 'The type of the installation', 'The files for an extension are located in a folder named by the extension key. The location of this folder can be either inside typo3/sysext/,  typo3/ext/ or  typo3conf/ext/. The extension must be programmed so that it does automatically detect where it is located and can work from all three locations.\r\n\r\n<B>Local location typo3conf/ext/:</B> This is where to put extensions which are local for a particular Typo3 installation. The typo3conf/ dir is always local, containing local configuration (eg. localconf.php), local modules etc. If you put an extension here it will be available for this Typo3 installation only. This is a per-database way to install an extension.\r\n\r\n<B>Global location typo3/ext/:</B> This is where to put extensions which are global for the Typo3 source code on the web server. These extensions will be available for any Typo3 installation sharing the source code. \r\nWhen you upgrade your Typo3 source code you probably want to copy the typo3/ext/ directory from the former source to the new source, overriding the default directory. In this way all global extension you use will be installed inside the new sourcecode. After that you can always enter Typo3 and upgrade the versions if needed.\r\nThis is a per-server way to install an extension.\r\n\r\n<B>System location typo3/sysext/:</B> This is system default extensions which cannot and should not be updated by the EM. \r\n\r\n\r\n<B>Loading precedence</B>\r\nLocal extensions take precedence which means that if an extension exists both in typo3conf/ext/ and typo3/ext/ the one in typo3conf/ext/ is loaded. Likewise global extension takes predence over system extensions. This means that extensions are loaded in the order of priority local-global-system. \r\nIn effect you can therefore have - say - a stable version of an extension installed in the global dir (typo3/ext/) which is used by all your projects on a server sharing source code, but on a single experimental project you can import the same extension in a newer experimental version and for that particular project the locally available extension will be used instead.\r\n', '', '', '', '', '0', '1024929630');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_doubleInstall', 'Tells you if the extensions is installed in more than one of the System, Global or Local locations.', 'Because an extension can reside at three locations, System, Global and Local, this indicates if the extension is found in other locations than the current. In that case you should be aware which one of the extensions is loaded!', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_rootfiles', 'List of the files in the extension folder. Does not list files in subfolders.', '', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_dbReq', 'Shows you the requirements to the database tables and fields, if any.', 'This will read from the files ext_tables.sql and ext_tables_static+adt.sql and show you which tables, fields and static tables are required with this extension.', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_dbStatus', 'Displays the current status of the database compared to the extension requirements.', 'If the extension is loaded which will display and error message if some tables or fields are not present in the database as they should be!', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_flags', 'A list of special codes which tells you something about what parts of Typo3 the extension touches.', 'This is a list of the flags:\r\n\r\n<B>Module:</b> A true backend main/sub module is found to be added.\r\n\r\n<B>Module+:</b> The extension adds itself to the function menu of an existing backend module.\r\n\r\n<B>loadTCA:</b> The extension includes a function call to t3lib_div::loadTCA for loading a table. This potentially means that the system is slowed down, because the full table description of some table is always included. However there probably is a good reason for this to happen. Probably the extension tries to manipulate the TCA-config for an existing table in order to extend it.\r\n\r\n<B>TCA:</b> The extension contains configuration of a table in $TCA.\r\n\r\n<B>Plugin:</b> The extension adds a frontend plugin to the plugin list in Content Element type "Insert Plugin".\r\n\r\n<B>Plugin/ST43:</b> TypoScript rendering code for the plugin is added to the static template "Content (default)". "Plugin" and "Plugin/ST43" are commonly used together.\r\n\r\n<B>Page-TSconfig:</b> Default Page-TSconfig is added.\r\n\r\n<B>User-TSconfig:</b> Default User-TSconfig is added.\r\n\r\n<B>TS/Setup:</b> Default TypoScript Setup is added.\r\n\r\n<B>TS/Constants:</b> Default TypoScript Constants is added.\r\n', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_conf', 'Shows if the extension has a template for further lowlevel configuration.', '', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_TSfiles', 'Shows which TypoScript static files may be present', 'If the files ext_typoscript_constants.txt and/or ext_typoscript_setup.txt is found in the extension folder their are included in the hierarchy of all TypoScript templates in Typo3 right after the inclusion of other static templates.', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_locallang', 'Shows which files named "locallang.php" are present in the extension folder (recursive search). Such files are usually used to present an array $LOCAL_LANG with labels for the application in the system languages.', '', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_moduleNames', 'Shows which module names was found inside the extension.', '', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_classNames', 'Shows which PHP-classes were found in .php and .inc files.', '', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_errors', 'Displays if any serious errors with the extension was discovered.', '', '', '', '', '', '0', '1024928038');
INSERT INTO sys_tabledescr VALUES ('_MOD_tools_em', 'emconf_NSerrors', 'Certain naming convensions apply to extensions. This displays any violations found.', 'The naming convensions are defined in the "Inside Typo3" document. To make naming as simple as possible, try to avoid underscores in your extension keys.', '', '', '', '', '0', '1024928205');


# TYPO3 Extension Manager dump 1.0
#
# Host: TYPO3_host    Database: t3_testsite
#--------------------------------------------------------


#
# Table structure for table 'sys_tabledescr_dk'
#
DROP TABLE IF EXISTS sys_tabledescr_dk;
CREATE TABLE sys_tabledescr_dk (
  tablename varchar(40) DEFAULT '' NOT NULL,
  fieldname varchar(40) DEFAULT '' NOT NULL,
  description_dk tinytext NOT NULL,
  details_dk text NOT NULL,
  syntax_dk text NOT NULL,
  image_descr_dk tinytext NOT NULL,
  serial_dk int(11) DEFAULT '0' NOT NULL,
  tstamp_dk int(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (tablename,fieldname)
);


INSERT INTO sys_tabledescr_dk VALUES ('pages', 'doktype', 'Vlg side type. \r\nTyperne \'Standard\' og \'Advanceret\' er almindelig websider, kun antallet af indstilling er forskelligt.\r\n\'Ikke i menu\' er ogs en almindelig side, men vil ikke blive vist i menuen.\r\n\'sysFolder\' er en srlig side type som ikke kan vises so', '', '', '', '0', '0');
INSERT INTO sys_tabledescr_dk VALUES ('pages', 'hidden', 'Hvis valgt, s vil siden vre skjult for alle brugere. Du kan kun se sidens indhold hvis du er logget in i Typo3\'s backend.', '', '', '', '0', '0');
INSERT INTO sys_tabledescr_dk VALUES ('pages', 'starttime', '\'Start\'-tiden er den dato, hvor siden vil blive synlig online. Brug dette til at \'publisere\' siden p en bestemt dato.\r\nHvis \'Start\'-tiden ikke er sat, s bliver siden vist jeblikkeligt (medmindre siden p anden vis er skjult).', '', '', '', '0', '0');
INSERT INTO sys_tabledescr_dk VALUES ('fe_groups', 'description', 'Indtast en beskrivelse af gruppen.', 'Dette er kun til internt brug og er blot en mde hvorp du kan notere hvad gruppen er til, hvorfor du har oprettet den og hvem der br vre medlem.\r\nBrug det hvis du vil.', '', '', '0', '1011028743');
INSERT INTO sys_tabledescr_dk VALUES ('fe_groups', 'hidden', '2', '', '', '', '0', '1011030175');
INSERT INTO sys_tabledescr_dk VALUES ('fe_groups', 'lockToDomain', '4', '', '', '', '0', '1011030175');
INSERT INTO sys_tabledescr_dk VALUES ('_MOD_web_layout', 'quickEdit', 'asdf', '', '', '', '0', '1017232632');


# TYPO3 Extension Manager dump 1.0
#
# Host: TYPO3_host    Database: t3_testsite
#--------------------------------------------------------


#
# Table structure for table 'sys_tabledescr_local'
#
DROP TABLE IF EXISTS sys_tabledescr_local;
CREATE TABLE sys_tabledescr_local (
  tablename varchar(40) DEFAULT '' NOT NULL,
  fieldname varchar(40) DEFAULT '' NOT NULL,
  description tinytext NOT NULL,
  details text NOT NULL,
  syntax text NOT NULL,
  image_descr tinytext NOT NULL,
  serial int(11) DEFAULT '0' NOT NULL,
  tstamp int(11) DEFAULT '0' NOT NULL,
  image tinytext NOT NULL,
  seeAlso text NOT NULL,
  mode tinyint(4) DEFAULT '0' NOT NULL,
  PRIMARY KEY (tablename,fieldname)
);





